
**************************************************************
**************************************************************
*
*   AMN.EXE:  Amnesty Credit Calculator (c) W.S. Herrick 2004
*
*   AMNESTY:  a program to sum finance charges for a customer
*   Given a customer ID, this routine computes all finance charges
*   and reports them, allowing review & edits.  It prints a report of the records.
*
**************************************************************
**************************************************************

Clear all
Release all
SET escape off
SET safety off
Deactivate WINDOWS ALL
Activate window screen

SET century on
set exact on
set near off

PUBLIC ok2quit
STORE .F. to ok2quit

PUBLIC amn_drv,amn_pick,amn_dir,amn_year, amn_t, amn_tt, amn_i, amn_ii
PUBLIC amn_wrk,amn_recno,amn_sum,amn_ID, amn_max_years, amn_Y

STORE 100 to amn_max_years
STORE amn_max_years+1 to amn_wrk
STORE [F] to amn_drv
STORE [/lsw97] to amn_dir
STORE ctod([01/01/1997]) to amn_year
STORE [000000] to amn_ID
STORE  0 to amn_recno
STORE 0 to amn_Y
store [] to amn_pick

* define window big from 1,1 to 40,75
* activate window big
clear
DO open_files
do while .not. ([Q]$upper(amn_pick))
clear
text
****************************************
***   A M N E S T Y    C R E D I T   ***
***        C A L C U L A T O R       ***
****************************************
Enter an ID#  (like 050987),  or 
M to Manage  archives, drives, etc or 
Q to quit
  Enter: ID#), M)anage Setup, or  Q)uit.  
endtext
acce ([      ==>]) to amn_pick

if [M]$upper(amn_pick) then 
   do mng_arch 
else
	if (.not. [Q]$upper(amn_pick)) then 
   		do get_id with amn_pick
	endif
endif

enddo
do close_files
RETURN



**************************************************************
**************************************************************
PROCEDURE open_files
private amn_tttt
     
	SELE (amn_wrk+1)
	USE amn_main  excl
	ZAP
* clear out recs for next pass
	PACK
	SELE (amn_wrk)
	USE  amn exclusive
	SET order to year
	GOTO top
* open all the act_main files in workeareas 1..n ==> recno of amn in amn_wrk
        DO WHILE .not. eof()
		STORE drive to amn_drv
		STORE dir  to amn_dir
		STORE year to amn_year
		SELE recno()
		amn_t=amn_drv+[:/]+alltrim(amn_dir)+[/act_main.dbf]
*		amn_ttt=amn_drv+[:/]+alltrim(amn_dir)+[/srvc_dat]

*		USE (amn_t)  shared order tag srvc_dat
		USE (amn_t)  shared order tag Pickup_ID

		SELE (amn_wrk)
		Skip
	ENDDO
*	go thru all amn and open all years listed there
	RETURN

**************************************************************
**************************************************************
PROCEDURE reindex_files
private amn_tttt

	SELE (amn_wrk)
	USE  amn exclusive
	SET order to year
	GOTO top
* open all the act_main files in workeareas 1..n ==> recno of amn in amn_wrk
	DO WHILE .not. eof()

		STORE drive to amn_drv
		STORE dir  to amn_dir
		STORE year to amn_year

		SELE recno()
		amn_t=amn_drv+[:/]+alltrim(amn_dir)+[/act_main.dbf]
		USE (amn_t)  excl		
*		amn_ttt=amn_drv+[:/]+alltrim(amn_dir)+[/srvc_dat]		
*		INDEX on srvc_dat to (amn_ttt)

*		INDEX on srvc_dat tag srvc_dat additive
		INDEX on Pickup_ID  tag Pickup_ID additive

		USE (amn_t)  shared order tag Pickup_ID
		SELE (amn_wrk)
		Skip
	ENDDO
* go thru all amn and open all years listed there
	RETURN


**************************************************************
**************************************************************
PROCEDURE close_files
	CLOSE data
	RETURN


**************************************************************
**************************************************************
PROCEDURE get_ID
parameter amn_Pickup_ID
if (.not. len(alltrim(amn_Pickup_ID))=6)
	Clear
	?
	?
	Acce [  Enter ID ==>] to amn_Pickup_ID
endif
* set all the years/workareas  filters to this id

**	SELE (amn_wrk)
**	GOTO top
**	DO WHILE .not. eof()
**		SELE recno()
**		SET filter to alltrim(amn_Pickup_ID)=alltrim(pickup_ID)
**		SELE (amn_wrk)
**		Skip
**	ENDDO
*	go thru all amn and set filters in all years listed there
	DO find_last_OK_ytd
	RETURN


**************************************************************
**************************************************************
PROCEDURE find_last_OK_ytd
PRIVATE quitting_time, found_y,amn_no_such_ID
	STORE [F] to quitting_time
	SELE amn_main
	ZAP
* clear prior run
	SELE (amn_wrk)
	GOTO BOTTOM
* MOST RECENT YEAR
	DO WHILE ( ( .not. bof()  )  .and.  (.not.(quitting_time=[T] ) ) )	
		SELE recno()
* if ytd exists keep going

**		GOTO top		

		
		seek alltrim(amn_Pickup_ID)

		found_y=.f.

		do while ((alltrim(amn_Pickup_ID)=alltrim(Pickup_ID)) .and. .not. eof())

			found_y=(found_y .or. ( [Y] $ srvc_list ))

			skip

		enddo

		IF ((  .not. found_y )  .or. (quitting_time=[1]) )  then
		
			quitting_time=[T]
* no ytd, then 
* that this is the year they quit paying
* so  we can quit looking backwards
			SELE (amn_wrk)
			STORE recno() to amn_ii
			DO find_fin_charges
			DO review_fin_charges										
		ELSE	
			SELE (amn_wrk)
			Skip -1						
			if  (recno()=1) then 
				quitting_time=[1] 
			endif
		ENDif		
	ENDDO
	RETURN

**************************************************************
**************************************************************
PROCEDURE find_fin_charges
private wrka
	SELE (amn_wrk)
	GOTO  amn_ii
* year where finance charges weren't paid
	DO WHILE .not. eof()
	    store recno() to wrka
		SELE recno()
		
		
		seek alltrim(amn_Pickup_ID)
**		GOTO top
		DO while ( (alltrim(amn_Pickup_ID)=alltrim(Pickup_ID) ) .and. (.not.eof()))
			IF ([F]$srvc_list) then
* snag a copy to amn_main
				COPY next 1 to junk
				sele amn_main
				appe from junk
				sele (wrka) 
			ENDIF
			Skip
		ENDDO
		
		
		
		SELE (amn_wrk)
		Skip
	ENDDO
	RETURN

**************************************************************
**************************************************************
PROCEDURE review_fin_charges
	PRIVATE quitting_time
	PRIVATE i,j,k,l, c_i, c_j, c_k, c_l, amn_c_i

	SELE amn_main
	SET deleted on
	INDE on srvc_dat to srvc_dat
	
	BROW fields invoice, srvc_dat, srvc_list:20, pric_list:20, coun_list:20, pickup_id:9, fname:15, lname:25 title [Delete records to exclude them from the amnesty.  Ctrl-W to continue]
	pack
	GOTO top
	STORE 0 to amn_sum
	STORE 0 to amn_i
	DO while  .not. eof()
* count bars
		i=at([F],srvc_list)
		j=1+at([|],pric_list)
		c_j=1+at([|],coun_list)
		k=1+at([|],pric_list,2)
		c_k=1+at([|],coun_list,2)
* figure out in which cell (of 3) the Finance charge is listed
              if (i>11)
              	l=substr(pric_list,k,8)
              	c_l=substr(coun_list,c_k,8)
		ELSE
			IF (i>1) then
				l=substr(pric_list,j,8)
				c_l=substr(coun_list,c_j,8)
			ELSE
				IF (i=1) then
					l=substr(pric_list,1,8)
					c_l=substr(coun_list,1,8)
				ENDIF
			ENDIF
		ENDIF		
*make the finance charge a number
		IF (at([|],l)>0) then
			l=alltrim(substr(l,1, (at([|],l))-1))
		ENDIF
		amn_i=val(l)
*make the service count a number too		
		IF (at([|],c_l)>0) then
			c_l=alltrim(substr(c_l,1, (at([|],c_l))-1))
		ENDIF
		amn_c_i=val(c_l)
* mult fin charge by # services then add to balance		
		amn_sum=amn_sum+(amn_i*amn_c_i)
*		? amn_sum, amn_i, amn_c_i, (amn_i*amn_c_i)
*		acce [press enter] to c_i
		skip
* sum up the charges
	ENDDO
	amn_i = []
	do while (.not.(upper(amn_i)=[C]))
		Clear
		?
		?
		? [Pickup_ID ==>],amn_Pickup_ID
		?[[Amnesty Credit ==>  $],amn_sum
		_CLIPTEXT=alltrim(str(amn_sum,10,2))
		?
		Acce [ Enter P)rint,  B)rowse, or C)ontinue ==>] to amn_i
		IF ( [P]$upper(amn_i)) then
			REPO form amn to printer
		ENDIF
		IF ( [B]$upper(amn_i)) then
		BROW NOEDIT fields invoice, pickup_id:9,srvc_dat, srvc_list:22, pric_list:20, coun_list:20, fname:15, lname:25 title [Records included in amnesty credit.  Ctrl-W to continue]
		ENDIF
	enddo
	RETURN

************************************************************
************************************************************
PROCEDURE Mng_Arch
	Clear
TEXT

Caution- some of these procedures can be slow.

Proceed here if you need to change drive letters,
directory names, add or remove archives (years)

Re-indexing is particularly slow.

ENDTEXT

?
acce([  Enter P)roceed or Q)uit ==>]) to amn_i
	if  ([P] $ upper(amn_i))
		SELE (amn_wrk)
		USE  amn exclusive
		SET order to year
		BROW fields drive, dir:30,year,comment:30
		CLOSE data
		SELE (amn_wrk)
		USE  amn exclusive
		SET order to year
		DO open_files
	endif	
	?
	?
	acce([ Enter R)eindex archives or Q)uit ==>]) to amn_i
	if  ([R] $ upper(amn_i))
		DO reindex_files
      endif
	RETURN
