clear
text
*****************  Import TRIM O Files   ****************
*
*
*   This routine imports TRIM data  and prepares it 
*  for optional address correction by BCC's Mailman.
*
*   You must have copies of the TRIM O_BILL__.DAT and 
*   O-TAX___.DAT in the current directory before you proceed.
*
*   If you wish to use MM to correct the USPS addresses,
*   copy the files  ttax2mm.dbf and tbill2mm.dbf to the
*   MailMan  Directory once the procedure completes..  
*   Encode the addresses there.  You must then run
*   the Import MailMan Files option.
*
*   If you choose to not correct the USPS addresses,
*   you are done importing TRIM after running this procedure.
*   
endtext

*   Run Trim_SDF_In  in the same dir with TRIM's "O" files
*   and TRIM_O_TAX2CSV.pl and TRIM_O_BILL2CSV.pl.  Run
*   the Perl scripts first, then Trim_SDF_In
*   It processes the output of the Perl routines 
*   TRIM_O_TAX2SDF.pl and TRIM_O_BILL2SDF.pl 
*   (They prep TRIM's 0_BILL__.DAT and O-TAX___.DAT)

set defa to k:\pva\letpva\letcher_trim
set confirm off
set safety off
USE
&& capture data from TRIM Certified ready to print DAT files

SELECT 11
USE trim_tax.dbf  EXCLUSIVE
zap
appe from O_TAX___.sdf type sdf

SELECT 12
USE trim_bill.dbf  EXCLUSIVE
zap
appe from O-BILL__.sdf type sdf

close data

&& dupe TRIM data to mail man compatible structure, then fix USPS address'
select 15
USE  ttax2mm.dbf  EXCLUSIVE
zap
appe from trim_tax

select 16
USE  tbill2mm.dbf  EXCLUSIVE
zap
appe from trim_bill

&& now reopen orig files

SELECT 11
USE trim_tax.dbf  EXCLUSIVE
inde on alltrim(acct_num) tag acct_num

SELECT 12
USE trim_bill.dbf  EXCLUSIVE

sele 13
USE lpv_pvamain.dbf EXCLUSIVE		&& derived trom MapSync's data structure-contains pva data
inde on alltrim(acct_num) tag acct_num

select 14
USE  lpv_pvaassess.dbf  EXCLUSIVE  && also derived from Mapsync


&& now 6 files open- ready to convert TRIM cty_st_zip field to mm_city, mm_state, & mm_zip
sele  ttax2mm

do  fix_city_st_zip

&& do same for next year\

sele tbill2mm

do  fix_city_st_zip

clear
text
*****************  Import TRIM O Files   ****************
*
*
*   This routine has finished.
*
*   If you wish to use MM to correct the USPS addresses,
*   copy the files  ttax2mm.dbf and tbill2mm.dbf to the
*   MailMan  Directory once the procedure completes..  
*   Encode the addresses there.  Use the Import MM
*  Files option on the MM corrected data.
*
*   If you choose to not correct the USPS addresses,
*   you are done importing TRIM after running this procedure.
*   
endtext

return




******==========================================================*******
PROCEDURE fix_city_st_zip
******==========================================================*******

&& assign data to be managed by BCC MailMan-these fields will be read & written by MM
repl all mm_uniq_id with str(recno())
repl all mm_mail_ad with mail_add
repl all mm_name_1 with name_one
repl all mm_name_2 with name_two

repl all mm_scratch with alltrim(cty_st_zip)  && copy city state zip to scratch area

&& move zip to mm_zip
repl all mm_zip with stuff(alltrim(mm_scratch), rat([ ],alltrim(mm_scratch)) ,1,[-]) ;
	 for ((len(alltrim(mm_scratch))>5) ;
	 .and. (substr(alltrim(mm_scratch),len(alltrim(mm_scratch))-4,1)$[ ])  ;
	 .and. (substr(alltrim(mm_scratch),len(alltrim(mm_scratch))-3,1)$[0123456789]) ;
	 .and. (substr(alltrim(mm_scratch),len(alltrim(mm_scratch))-5,1)$[0123456789]))
	 
repl all mm_zip with right(alltrim(mm_scratch),len(alltrim(mm_scratch))-rat([ ],alltrim(mm_scratch)))
repl all mm_zip with [] for ((len(alltrim(mm_zip))<5) .or. (.not. (left(mm_zip,1)$[0123456789]))) 
repl all mm_zip with right(alltrim(mm_scratch),10)  for ((len(alltrim(mm_zip))=0) .and. (right(alltrim(mm_scratch),1)$[0123456789]))

repl all mm_scratch with left(alltrim(mm_scratch), len(alltrim(mm_scratch))-len(alltrim(mm_zip)) )

&& move state to mm_state
repl all mm_state with right(alltrim(mm_scratch),len(alltrim(mm_scratch))-rat([ ],alltrim(mm_scratch)))
repl all mm_state with [] for ((len(alltrim(mm_state))<2)) 
repl all mm_state with [] for mm_state=[FO] 
repl all mm_state with [KY] for mm_state=[KE] 

repl all mm_scratch with substr(alltrim(mm_scratch),1,len(alltrim(mm_scratch))-len(alltrim(mm_state))) for len(alltrim(mm_scratch))>2

&& move what is left to city & repair:  many states w/out abvn!  Also odd ab[ |-|- | -| - ]vns.  Cleave  state names.
repl all mm_city with alltrim(mm_scratch)

repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-6) for [KENTUC] $ mm_city .and. (mm_state=[KY])

repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-6) for [MICHIG] $ mm_city .and. (mm_state=[MI])

repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-8) for [WASHINGT] $ mm_city .and. (mm_state=[WA])

repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-5) for [FLORI] $ mm_city .and. (mm_state=[FL])

repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-6) for [MARYLA] $ mm_city .and. (mm_state=[MA])

repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-6) for [DELAWA] $ mm_city .and. (mm_state=[DE])

repl all mm_state with [SC] for ([S C] $ right(alltrim(mm_city),3) .and. (mm_state=[]))
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-3) for [S C] $ right(alltrim(mm_city),3) .and. (mm_state=[SC])

repl all mm_state with [NY] for ([N Y] $ right(alltrim(mm_city),3) .and. (mm_state=[]))
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-3) for [N Y] $ right(alltrim(mm_city),3) .and. (mm_state=[NY])

repl all mm_state with [NC] for ([N C] $ right(alltrim(mm_city),3) .and. (mm_state=[]))
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-3) for [N C] $ right(alltrim(mm_city),3) .and. (mm_state=[NC])

repl all mm_state with [TX] for ([TEX] $ mm_city) .and. (mm_state=[TE])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-3) for [TEX] $ mm_city .and. (mm_state=[TX])

repl all mm_state with [TN] for ([TENNESS] $ mm_city) .and. (mm_state=[TE])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-7) for [TENNESS] $ mm_city .and. (mm_state=[TN])

repl all mm_state with [GA] for ([GEORG] $ mm_city) .and. (mm_state=[GE])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-5) for [GEORG] $ mm_city .and. (mm_state=[GA])

repl all mm_state with [MO] for ([MISSOU] $ mm_city) .and. (mm_state=[MI])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-6) for [MISSOU] $ mm_city .and. (mm_state=[MO])

repl all mm_state with [WV] for [WEST VIRGIN] $ mm_city  .and. (mm_state=[WE])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-11) for [WEST VIRGIN] $ mm_city .and. (mm_state=[WV])

repl all mm_state with [SC] for [SOUTH CAROLI] $ mm_city  .and. (mm_state=[SO])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-12) for [SOUTH CAROLI] $ mm_city .and. (mm_state=[SC])

repl all mm_state with [NC] for [NORTH CAROLI] $ mm_city  .and. (mm_state=[NO])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-12) for [NORTH CAROLI] $ mm_city .and. (mm_state=[NC])

repl all mm_state with [AK] for ([ALAS] $ mm_city) .and. (mm_state=[AL])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-4) for [ALAS] $ mm_city .and. (mm_state=[AK])

repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-2) for [OH] $ right(alltrim(mm_city),2) .and. (mm_state=[OH])

repl all mm_state with [IN] for ([INDIA] $ mm_city) .and. (mm_state=[IA])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-5) for [INDIA] $ mm_city .and. (mm_state=[IN])

repl all mm_state with [PA] for ([PENNSYLVAN] $ mm_city) .and. (mm_state=[PE])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-10) for [PENNSYLVAN] $ mm_city .and. (mm_state=[PE])

repl all mm_state with [AZ] for ([ARIZO] $ mm_city) .and. (mm_state=[AR])
repl all mm_city with left(alltrim(mm_city),len(alltrim(mm_city))-5) for [ARIZO] $ mm_city .and. (mm_state=[AZ])

&& Now send this file to mailman and run-it is ready to fix addresses






