
************************************************************
************************************************************
******                        ACT_.prg               *******
******   Released with MIT license, April 22, 2014   *******
*****    Copyright 1995, 2014 W.S.Herrick            *******
************************************************************
************************************************************


************************************************************
************************************************************
The MIT License (MIT)
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
************************************************************
************************************************************

DO act_one




LOCAL lcmainclasslib
LOCAL lclastsettalk,lclastsetpath,lclastsetclasslib,lconshutdown

*-- Save and configure environment.
lclastsettalk=SET("TALK")
SET TALK OFF
lclastsetpath=SET("PATH")


* CD "\act_whi\"


SET PATH TO
PUSH MENU _MSYSMENU
lclastsetclasslib=SET("CLASSLIB")
lcmainclasslib="acx"
SET CLASSLIB TO (lcmainclasslib) ADDITIVE
lconshutdown="ShutDown()"

* ON SHUTDOWN &lcOnShutdown

ON ERROR errorhandler(ERROR(),PROGRAM(),LINENO())
_SHELL="DO Cleanup IN acx"

*-- Instantiate application object.
RELEASE goapp
PUBLIC goapp
goapp=CREATEOBJECT("cApplication")



DO act_two



*-- Configure application object.
goapp.setcaption("ACT V3.0 (C) WS HERRICK 2004")

* goApp.cStartupMenu="acx"


************  Run Trim and Delinquent views  *********
&&
DO dlq_view
*                 DO tax_dlq.mpr
goapp.cstartupmenu="tax_dlq"
&&
******************************************************
***********    Run ACT Accounting view  **************
*                DO act_star.mpr
* goApp.cStartupMenu="ACT_STAR"
******************************************************


* goApp.cStartupForm="qckstart"

* goApp.cStartupForm="act_dlq"


*-- Show application.
goapp.SHOW
*-- Release application.
RELEASE goapp

*-- Restore default menu.
POP MENU _MSYSMENU

*-- Restore environment.
ON ERROR
ON SHUTDOWN
IF NOT lclastsetclasslib==SET("classlib")
	RELEASE CLASSLIB (lcmainclasslib)
ENDIF
IF EMPTY(lclastsetpath)
	SET PATH TO
ELSE
	SET PATH TO &lclastsetpath
ENDIF
IF lclastsettalk=="ON"
	SET TALK ON
ELSE
	SET TALK OFF
ENDIF
RETURN



*************************************************************************
FUNCTION errorhandler(nerror,cmethod,nline)
	LOCAL lcerrormsg,lccodelinemsg

	WAIT CLEAR
	lcerrormsg=MESSAGE()+CHR(13)+CHR(13)
	lcerrormsg=lcerrormsg+"Method:    "+cmethod
	lccodelinemsg=MESSAGE(1)
	IF BETWEEN(nline,1,10000) AND NOT lccodelinemsg="..."
		lcerrormsg=lcerrormsg+CHR(13)+"Line:         "+ALLTRIM(STR(nline))
		IF NOT EMPTY(lccodelinemsg)
			lcerrormsg=lcerrormsg+CHR(13)+CHR(13)+lccodelinemsg
		ENDIF
	ENDIF
	IF MESSAGEBOX(lcerrormsg,17,_SCREEN.CAPTION)#1
		ON ERROR
		RETURN .F.
	ENDIF
ENDFUNC


*************************************************************************
FUNCTION SHUTDOWN
	IF TYPE("goApp")=="O" AND NOT ISNULL(goapp)
		RETURN goapp.onshutdown()
	ENDIF
	cleanup()
	QUIT
ENDFUNC


*************************************************************************
FUNCTION cleanup

	IF CNTBAR("_msysmenu")=7
		RETURN
	ENDIF
	ON ERROR
	ON SHUTDOWN
	SET CLASSLIB TO
	SET PATH TO
	CLEAR ALL
	CLOSE ALL
	POP MENU _MSYSMENU
	RETURN






*************************************************************************
PROCEDURE act_one
*************************************************************************

	SET RESOURCE OFF  && avoid resource file conflict on startup

*** ||| *** SET RESOURCE TO c:\foxuser.DBF
* SET RESOURCE TO \foxuser.DBF
	SET RESOURCE TO foxuser.DBF

	SET RESOURCE OFF


	IF (DIRECTORY('c:\temp')=.F.)  && if the c:/temp dir is missing, make it
		MKDIR('c:\temp')
	ENDIF




	SET ESCAPE OFF
	RELEASE ALL
	SET EXCLUSIVE OFF
	DEACTIVATE WINDOWS ALL
DEFINE WINDOW msg2user   FROM 03,02 TO 07,77 DOUBLE FLOAT SHADOW COLOR SCHEME 7 TITLE [Click Here and Drag to Move This Window.]

&& MODIFY SCREEN FONT "TERMINAL",9  &&!*!*!*!*!*!*!**!*!!*!*!*

&&on error do quit_act with [Q] &&...
PUBL err5_n
STORE 0 TO err5_n	         && Counter for number of err#5 passed in error handler

* | * ON ERROR DO syserror WITH LINENO()

CLEAR

ACTIVATE SCREEN
SET TALK OFF
SET STATUS BAR OFF
SET SCOREBOARD OFF
SET SAFETY OFF

CLEAR ALL
CLOSE DATA
******==========================================================*******
PUBLIC nw_sft
STORE .F. TO nw_sft
******==========================================================*******
PUBLIC a_a, new_u_r
STORE [         ] TO new_u_r
PUBLIC  ur,ur_pw, f4x,p4x, u_sz,uz
STORE [      ] TO ur
STORE ur TO u_sz
STORE ur TO uz
STORE [                   ] TO ur_pw
=RAND(-1)
STORE .F. TO f4x
STORE .F. TO p4x

PUBLIC asc_i, asc_j
STORE 65 TO asc_i
STORE 90 TO asc_j

PUBLIC  act_ok
STORE .F. TO act_ok
PUBLIC  log_count
STORE 0 TO log_count
ACTIVATE SCREEN

DO WHILE (.NOT. (act_ok))
	CLEAR
	log_count=log_count+1
	IF log_count >3
		CANCEL   && givem 3 tries
	ENDIF
TEXT



*********************************************************************

      A C C O U N T      I N F O R M A T I O N       L O G I N

*********************************************************************

ENDTEXT
	ACCE [  Please enter your user ID ==>  ] TO ur
	? [  Please enter your password ==>  ]
	STORE ' ' TO ur_pw
	@ 1,1 EDIT ur_pw FUNCTION 'J' SIZE 1, 1
	READ
	CLEAR
	STORE ALLTRIM(UPPER(ur)) TO ur
	STORE ALLTRIM(UPPER(ur_pw)) TO ur_pw
	STORE ur_pw TO u_sz
	USE act_x SHARED
	APPEND BLANK
	REPL u_name WITH ur
	REPL DATE WITH DATE()
	REPL u_when WITH TIME()
	REPL u_what WITH [In]
	REPL u_where WITH LEFT(SYS(0),10)
	REPL u_seq WITH RECNO()

	USE act_y SHARED
	SET ORDER TO 1
	SEEK ur
	act_ok=FOUND()
	u_sz=UPPER(ALLTRIM(ur_pw))
	act_ok=(act_ok .AND. ( LEN(u_sz)>3))  && no nulls, len 4 and above.
	IF (act_ok)
		act_ok=.F.
		act_ok=((ALLTRIM(UPPER(act_y.u_r))= u_sz ))
	ENDIF
	USE
ENDDO

RETURN

*************************************************************************
	PROCEDURE act_two
*************************************************************************


		PUBLIC hstead_dedn, tax_district

*********************  CONFIGURATION VALUES   *********************
		SELE 0
		USE act_local  &&RESOURCE FILE FOR LOCALIZATION OF THE ACT_ PROGRAM-NAMES, RATES, CYCLES...
		PUBLIC billing_cycle   && are bills run Monthly [M], Quarterly [Q]?
		PUBLIC no_int4res, no_int4c  && flag to waive interest charges (only compute balances) for residentials or commercials
		PUBLIC late_rate_res   && % of mthly rate to asses as 1 time late fee  ###  hmmm 10/8/04 no es on res, fixed
		PUBLIC mth_rate_r, int4mnth  && [R] & [M] in old ACT_CODE- the residential $/mnt rat, and the monthly interest as %, ie: 12% int/year=> 1%/mnth, set as 1
		STORE act_local.mnth_or_qu TO billing_cycle   && reset their value to effect residential billing quarterly.
		STORE act_local.no_res_int TO no_int4res  && flags to not charge interest- res
		STORE act_local.no_com_int TO no_int4c  && flags to not charge interest- res
		STORE act_local.laterate_r TO late_rate_res  && % mth_rate_r to apply as late charge.  Was [L] in act_code
		STORE act_local.mth_rate_r TO mth_rate_r  && monthly residential rate., dollars per month, 10.2N  , was [R] in act_code
		STORE act_local.int4mnth TO int4mnth && the monthly interest as %, ie: 12% int/year=> 1%/mnth, set as 1 Was [M] in act_code
		STORE act_local.hsted_dedn TO hstead_dedn && pva homestead deduction c. 31500$
		STORE act_local.tax_distri TO tax_district && the district to make city tax bills for ie: 2
		USE



*		STORE 28000.00 TO hstead_dedn  	&& set the current homestead deduction to $28000
*		STORE [2] TO tax_district 		&& SET THE TAX DISTRICT TO PULL FROM TRIM

**************



		DEACTIVATE WINDOWS ALL  && clear out the windows needed by the error handler
		ACTIVATE SCREEN
		CLEAR
		?
		?
		?[      A C C O U N T      I N F O R M A T I O N    L O A D I N G.... ]
*? [      Cfg=]+sys(2019)
		?
*? [            ACT_.EXE V2.2 Copyright (c) WS Herrick, 2003]

*** ||| *** SET RESOURCE TO c:\foxuser.DBF
* SET RESOURCE TO \foxuser.DBF
		SET RESOURCE TO foxuser.DBF
		SET CENTURY ON
*SET HELP TO foxhelp.hlp
		SET RESOURCE OFF
		SET EXCLUSIVE OFF


		SET TALK OFF
		SET STATUS BAR OFF
		SET SCOREBOARD OFF
		SET SAFETY OFF

		SET ESCAPE OFF

* Typical system messages:
DEFINE WINDOW msg2user   FROM 03,02 TO 07,77 DOUBLE FLOAT SHADOW COLOR SCHEME 7 TITLE [Click Here and Drag to Move This Window.]


* System error message:
*DEFINE WINDOW syserror   FROM 02,00 TO 24,77 FLOAT GROW ZOOM CLOSE COLOR SCHEME 7
DEFINE WINDOW big_msg   FROM 02,00 TO 24,77 FLOAT GROW ZOOM CLOSE COLOR SCHEME 7
DO view_set

SET ESCAPE OFF


*!* ON ERROR do quit_act with [Q]

* | * ON ERROR DO syserror WITH LINENO()

SET MESSAGE TO ""
SET TALK OFF

SET CURSOR OFF    && Set cursor off
PUBLIC USER,ppww
STORE [                       ] TO USER
STORE [          ] TO ppww
STOR LEFT(SYS(0),20) TO USER


DO view_set

&& flags to not charge interest  commercial
PUBLIC flagxact_inpa
STORE [F] TO flagxact_inpa  && signal act_pay form to disallow browse if called from act_inpa form.

PUBLIC global_ok_cust, print_to, proh, file_action, find_action, done_in_top
STORE 1 TO file_action
STORE [1] TO find_action
STORE 1 TO done_in_top
PUBLIC find_ia,find_ca,find_la
STORE [1] TO find_ia
STORE find_ia TO find_ca
STORE find_ia TO find_la
STORE SPACE(120) TO print_to	&& Fully qualified call to Novell CAPTURE
PUBLIC curdrive
STORE SYS(5) TO curdrive            &&the current default drive
ON KEY LABEL f8 QUIT
= INSMODE(.T.)
= CAPSLOCK(.T.)
= NUMLOCK(.T.)
****************************  CONFIGURATION VALUES   **********************
***************************************************************************

****************GLOBAL VARIABLES--CHANGE AT YOUR OWN RISK! ****************
****************GLOBAL VARIABLES--CHANGE AT YOUR OWN RISK! ****************
PUBLIC id_type, count_var,ticker_str,in_orderin,temp
PUBLIC wsh, worker, fast
STORE [F] TO wsh                 && is this wsh on a standalone ?
IF wsh=[T]
	ON KEY LABEL f8 SUSPEND
	ON KEY LABEL f7 DO msg2user WITH [SYS(1001) AV=]+SYS(1001)+[, SYS(1016) USD=]+SYS(1016)+[SYS(12) !=]+SYS(12)
*   ON KEY LABEL f6 FILER
	= INSMODE(.T.)
	= CAPSLOCK(.T.)
	= NUMLOCK(.F.)
*   SET STATUS ON      && wsh 3/3/92
	STORE [WH] TO USER
ENDIF
*STORE .T. TO worker   && wsh 02/08/93
STORE .F. TO fast   && ENTRY ORDER IN INVOICE.
STORE .T. TO in_orderinlist

PUBLIC mdrive
PUBLIC subdisc, h_subtot, h_sub_tax
PUBLIC dumy_1
PUBLIC custmr
PUBLIC taxamt
PUBLIC start_s, end_d
STORE DATE() TO start_d
STORE DATE() TO end_d
PUBLIC cp_n,cs_n
STORE 1 TO cp_n
STORE cp_n TO cs_n
PUBLIC cur_invoice, cur_cust, cur_claim, cur_pay
STORE act_main.invoice TO cur_invoice
STOR act_cust.pickup_id TO cur_cust
STOR act_pay.pay_rec_n TO cur_pay
PUBLIC ar_l, ar_lp, ar_p,ar_p2,ar_p3
STORE [XXXXXXXXXXXXXXX] TO ar_l
PUBLIC act_titl
STORE "          Hilite Entry then use <Ctrl-W> or <F10> to select and exit.                                       " TO act_titl
PUBLIC a_tmp_med
PUBLIC pay_temp
STORE 0 TO pay_temp
PUBLIC cp_30,cs_30, cs_cp_30
STORE 0 TO cp_30
STORE 0 TO cs_30
STORE 0 TO cs_cp_30

&& amnesty variables
PUBLIC ok2quit
PUBLIC amn_drv,amn_pick,amn_dir,amn_year, amn_t, amn_tt, amn_i, amn_ii
PUBLIC amn_recno,amn_sum,amn_id, amn_max_years, amn_y
* AMN_WRK
PUBLIC amn_pickup_id
STORE [000001] TO amn_pickup_id
&& amnesty variables
PUBLIC dlq_lookup_id, dlq_total_due,dlq_decredit, dlq_90day,dlq_i
PUBLIC dlq_name1,dlq_map, dlq_act, dlq_des, pva_date_txt,pva_date
STORE [000000] TO dlq_lookup_id
STORE 0 TO dlq_total_due
STORE 0 TO dlq_decredit
STORE [] TO dlq_name1
STORE [] TO dlq_map
STORE [] TO dlq_act
STORE [] TO dlq_des
STORE [11/15/2004] TO pva_date_txt
STORE CTOD(pva_date_txt) TO pva_date
STORE 0 TO dlq_i
&& delinquent variables



****************End GLOBAL VARIABLES--CHANGE AT YOUR OWN RISK! ************
****************End GLOBAL VARIABLES--CHANGE AT YOUR OWN RISK! ************

**************************** Set The Environment **************************
***************************************************************************
PUBLIC ok2add,root2bo,repr_tim
ok2add=[F]    && OK TO ADD FLAG FOR INVOICE.PRG
root2bo=[F]   && default to not print BO's connected to an invoice
SET AUTOSAVE         OFF  && 5/9/94
SET CONFIRM          OFF &&N
SET CONSOLE          ON     && Default
SET DELETED          ON
SET EXACT            ON   &&OFF
SET EXCLUSIVE        OFF    &&&&&   WSH WSH WSH WSH WSH 7/19/90
SET FULLPATH         ON
SET NOTIFY           ON   && wsh 4/10/90 - user isn't notified of locking til error.
SET REFRESH TO 15,15      && refresh extra-user modified data each 15 seconds
STORE 60 TO repr_tim
&& SET REPROCESS TO 60   && WSH TESTED FROM 1-100, 60 SEEMS BEST 3/31/92
SET REPROCESS TO AUTOMATIC   && WSH TESTED FROM 1-100, 60 SEEMS BEST 3/31/92
SET LOCK OFF		&& make copy to and report etc not lock file
SET MULTILOCKS OFF   && do not lock more than 1 record in a file at a time
SET ODOMETER TO 250
ON KEY LABEL rightmouse KEYBOARD CHR(13)
SET SCOREBOARD       OFF


*loads the service codes and prices to the invoice page.
TEXT
public I_I
SELE 9
USE act_line SHARED ORDER TAG invoice
*SELE act_line
COPY TO ARRAY I_A

UNLOCK ALL
FOR I_I=1 TO ALEN(I_A,1)
	I_A(I_I,1)=act_main->invoice
ENDFOR
UNLOCK ALL
SELE act_main
SET BELL OFF
ENDTEXT
CLEAR


PUBLIC seg, this_one
seg = 1
PUBLIC m.done
m.done=.F.
SET STATUS BAR ON
SET CLOCK STATUS
STORE .T. TO in_orderin
SET CONFIRM ON
SET SYSMENU ON  &&*!
UNLOCK ALL


SET RESOURCE ON

RETURN







*************************************************************************
	PROCEDURE act_three
*************************************************************************


*************************************************************************
***********************  Begin main routine  ****************************
*************************************************************************


		PUBLIC seg, this_one
		seg = 1
		PUBLIC m.done
		m.done=.F.
		SET STATUS BAR ON
		SET CLOCK STATUS
		STORE .T. TO in_orderin
		SET CONFIRM ON
		SET SYSMENU ON  &&*!

		UNLOCK ALL



*   * | * ON ERROR DO syserror WITH LINENO()



&& ON ERROR DO quit_act with [Q]

TEXT
************  Run Trim and Delinquent views  *********
&&
do dlq_view
DO tax_dlq.mpr
&&
******************************************************



***********    Run ACT Accounting view  **************
*  DO act_star.mpr

******************************************************

IF .NOT. in_orderin
	m.done=.T.
	UNLOCK ALL
ENDIF

READ VALID m.done

*QUIT*
* *! set sysmenu to DEFAULT
* *! enddo &&in_orderin

DO quit_act WITH [Q]
ENDTEXT
		CLEAR

		RETURN

******==========================================================*******
******==========================================================*******
******==========================================================*******
******==========================================================*******
******==========================================================*******
******==========================================================*******
******==========================================================*******


********************************************************************************
********************************************************************************

**************************************************************
**************************************************************
*PROCEDURE amnesty
**************************************************************
**************************************************************


**************************************************************
**************************************************************
	PROCEDURE open_files
		PRIVATE amn_tttt,oa,ob,oc,od

		SELE 0
		USE amn_main  EXCL
		ZAP
		SELE 0
		USE amn_pay EXCL
		ZAP
* clear out recs for next pass
		PACK
		SELE 0
		USE  amn EXCLUSIVE ALIAS amn_wrk
		SET ORDER TO YEAR
		GOTO TOP
* open all the act_main files in workeareas 1..n ==> recno of amn in amn_wrk
		DO WHILE .NOT. EOF()
			STORE DRIVE TO amn_drv
			STORE DIR  TO amn_dir
			STORE YEAR TO amn_year
			SELE 0
			amn_t=amn_drv+[:\]+ALLTRIM(amn_dir)+[\act_main.dbf]
			USE (amn_t)  SHARED ORDER TAG pickup_id
			STORE STR(SELE()) TO oa

&& now snag pay in comment+1
			SELE 0
			amn_t=amn_drv+[:\]+ALLTRIM(amn_dir)+[\act_pay.dbf]
			USE (amn_t)  SHARED ORDER TAG pickup_id

			SELE amn_wrk
			REPL  amn_wrk.COMMENT WITH oa
			SKIP
		ENDDO
*	go thru all amn and open all years listed there
		RETURN



**************************************************************
**************************************************************
	PROCEDURE close_files
		CLOSE DATA
		RETURN



**************************************************************
**************************************************************
	PROCEDURE find_last_ok_ytd
		PRIVATE quitting_time, found_y,amn_no_such_id
		STORE [F] TO quitting_time
		SELE amn_main
		ZAP

*	SELE (amn_wrk)
		SELE amn_wrk

		GOTO BOTTOM		&&  MOST RECENT YEAR
		DO WHILE ( ( .NOT. BOF()  )  .AND.  (.NOT.(quitting_time=[T] ) ) )
			SELE (VAL(ALLTRIM(amn_wrk.COMMENT)))		&& comment is actually workspace
* if ytd exists keep going
			SEEK ALLTRIM(amn_pickup_id)
			found_y=.F.
			DO WHILE ((ALLTRIM(amn_pickup_id)=ALLTRIM(pickup_id)) .AND. .NOT. EOF())
				found_y=(found_y .OR. ( [Y] $ srvc_list ))
				SKIP
			ENDDO
			IF ((  .NOT. found_y )  .OR. (quitting_time=[1]) )  then
				quitting_time=[T]
* no ytd, then
* that this is the year they quit paying
* so  we can quit looking backwards

*			SELE (amn_wrk)
				SELE amn_wrk
				STORE RECNO() TO amn_ii
				DO find_fin_charges
				DO review_fin_charges
			ELSE
*			SELE (amn_wrk)
				SELE amn_wrk
				SKIP -1
				IF  (RECNO()=1) then
					quitting_time=[1]
				ENDIF
			ENDIF
		ENDDO
		RETURN


**************************************************************
**************************************************************
	FUNCTION find_amnesty_credits
		PRIVATE wrka, wrkb
*
*	snag all pay records of type [T] (Credit)
*
*
		STORE SELE() TO wrkb
		SELE amn_pay
*       zap
		DELE ALL
		SELE amn_wrk
		GOTO  TOP
		DO WHILE .NOT. EOF()
			STORE SELE() TO wrka
			SELE (VAL(ALLTRIM(amn_wrk.COMMENT))+1)

			SEEK ALLTRIM(act_cust.pickup_id)

*	  COPY ALL to junk  FOR  (( (alltrim(Pickup_ID)=alltrim(ACT_CUST.Pickup_ID) ) ) .AND. (ALLTRIM(cshchkcr)$[Tt]))

			DO WHILE ( (ALLTRIM(pickup_id)=ALLTRIM(act_cust.pickup_id) ) .AND. (.NOT.EOF()))
				IF (ALLTRIM(cshchkcr)$[Tt]) then
*	? [AMN_PAY  JUNK]
					COPY NEXT 1 TO junk
					SELE amn_pay
					APPE FROM junk
					SELE (VAL(ALLTRIM(amn_wrk.COMMENT))+1)
				ENDIF
				SKIP
			ENDDO

			SELE amn_wrk
			SKIP
		ENDDO

		SELE amn_pay
		PACK
		GOTO TOP
		SELE(wrkb)
		RETURN .T.


**************************************************************
**************************************************************
	PROCEDURE find_fin_charges
		PRIVATE wrka
*	SELE (amn_wrk)
		SELE amn_wrk
		GOTO  amn_ii
* year where finance charges weren't paid
		DO WHILE .NOT. EOF()
			STORE SELE() TO wrka
			SELE (VAL(ALLTRIM(amn_wrk.COMMENT)))
			SEEK ALLTRIM(amn_pickup_id)
			DO WHILE ( (ALLTRIM(amn_pickup_id)=ALLTRIM(pickup_id) ) .AND. (.NOT.EOF()))
				IF ([F]$srvc_list) then
* snag a copy to amn_main
					COPY NEXT 1 TO junk
					SELE amn_main
					APPE FROM junk
					SELE (VAL(ALLTRIM(amn_wrk.COMMENT)))
				ENDIF
				SKIP
			ENDDO
			SELE amn_wrk
			SKIP
		ENDDO
		RETURN

**************************************************************
**************************************************************
	PROCEDURE review_fin_charges
		PRIVATE quitting_time
		PRIVATE i,j,k,l, c_i, c_j, c_k, c_l, amn_c_i

		SELE amn_main
		SET DELETED ON
		INDE ON srvc_dat TO srvc_dat

*	BROW LAST  fields invoice, srvc_dat, srvc_list:20, pric_list:20, coun_list:20, pickup_id:9, fname:15, lname:25 title [Delete recent records to calculate amnesty for a prior date.  Kill all records made after your cutoff.  Ctrl-W to continue]

		PACK
		GOTO TOP
		STORE 0 TO amn_sum
		STORE 0 TO amn_i
		DO WHILE  .NOT. EOF()
* count bars
			i=AT([F],srvc_list)
			j=1+AT([|],pric_list)
			c_j=1+AT([|],coun_list)
			k=1+AT([|],pric_list,2)
			c_k=1+AT([|],coun_list,2)
* figure out in which cell (of 3) the Finance charge is listed
			IF (i>11)
				l=SUBSTR(pric_list,k,8)
				c_l=SUBSTR(coun_list,c_k,8)
			ELSE
				IF (i>1) then
					l=SUBSTR(pric_list,j,8)
					c_l=SUBSTR(coun_list,c_j,8)
				ELSE
					IF (i=1) then
						l=SUBSTR(pric_list,1,8)
						c_l=SUBSTR(coun_list,1,8)
					ENDIF
				ENDIF
			ENDIF
*make the finance charge a number
			IF (AT([|],l)>0) then
				l=ALLTRIM(SUBSTR(l,1, (AT([|],l))-1))
			ENDIF
			amn_i=VAL(l)
*make the service count a number too
			IF (AT([|],c_l)>0) then
				c_l=ALLTRIM(SUBSTR(c_l,1, (AT([|],c_l))-1))
			ENDIF
			amn_c_i=VAL(c_l)
* mult fin charge by # services then add to balance
			amn_sum=amn_sum+(amn_i*amn_c_i)
*		? amn_sum, amn_i, amn_c_i, (amn_i*amn_c_i)
*		acce [press enter] to c_i
			SKIP
* sum up the charges
		ENDDO
		amn_i = []
*		Clear
*		?
*		? [Pickup_ID ==>],amn_Pickup_ID
*		?[[Amnesty Credit if Given Today==>  $],amn_sum
*		_CLIPTEXT=alltrim(str(amn_sum,10,2))
*		?
*		SELE amn_main
*		BROW LAST NOEDIT nowait fields invoice, pickup_id:9,srvc_dat, srvc_list:22, pric_list:20, coun_list:20, fname:15, lname:25 title [Records included in amnesty credit.  Ctrl-W to continue]
		RETURN

************************************************************
************************************************************
********************************************************************************
********************************************************************************


***************************************************
	PROCEDURE dlq_start
***************************************************

TEXT

****   SEQUENCE TO MAKE LIST FIRST TIME  ******
USE JUNK EXCL
zap
* junk starts as l1 c100, empty
APPE FROM K:\ACT_4LT\JOHNS_LIST.TXT TYPE SDF
DELE ALL FOR LEN(ALLTRIM(L1))<1
REPL ALL L1 WITH ALLTRIM(L1)

PACK
? [Hey MODI STRU and add Pickup_ID C8 & NAME C30
MODI STRU

GOTO TOP
REPL ALL junk.PICKUP_ID WITH ALLTRIM(LEFT(L1,7))
BROW
REPL ALL junk.NAME WITH ALLTRIM(RIGHT(L1,7))
REPL ALL junk.NAME WITH ALLTRIM(SUBSTR(L1,7))
REPL ALL junk.NAME WITH ALLTRIM(UPPER(junk.NAME))
REPL ALL junk.PICKUP_ID WITH PADL(ALLTRIM(junk.PICKUP_ID),6,'0')
REPL ALL junk.NAME WITH ALLTRIM(junk.NAME)
COPY ALL TO GOT_LETTERS FIELDS PICKUP_ID, NAME

CLOSE DATA
USE ACT_DLE EXCL
ZAP
appe blank
repl name with [<== LOOK UP ACCOUNT. ENTER  ID, SCROLL DOWN/UP    ], active_id with [000000]
APPE FROM GOT_LETTERS
REPL ALL ACTIVE_ID WITH PICKUP_ID

ENDTEXT
		CLEAR

&& clean up the id #'s entered for the "got letters" list
		CLOSE DATA
		DO view_set
		SELE 0

TEXT

	USE act_dle   									&& Got Letters w/in 60 days PVA billing, candidates for Prop bill, pickup_id's
	SELE act_dle
	SET ORDER TO
	SET FILTER TO
	GOTO TOP
	DO WHILE (.NOT. EOF())  						&& clean up stray whitespace at right end
		DO WHILE (.NOT. RIGHT(ALLTRIM(pickup_id),1) $ [0123456789]) .AND. (LEN(ALLTRIM(pickup_id))>0)
			REPL pickup_id WITH LEFT(ALLTRIM(pickup_id),LEN(ALLTRIM(pickup_id))-1)
		ENDDO
		SKIP
	ENDDO
	GOTO TOP  									&& THE ACT_DLE'S ARE UNIFORM PICKUP_ID'S
	REPL ALL pickup_id WITH PADL(ALLTRIM(pickup_id),6,[0])
	FLUSH
	UNLOCK ALL
	REPL ALL active_id WITH [] , inact_id WITH []
	FLUSH
	USE
ENDTEXT
		CLEAR


		USE act_dle EXCL
		INDE ON ALLTRIM(pickup_id) TAG pickup_id		&&locate and delete duplicates
		USE

		USE act_dle   									&& Got Letters w/in 60 days PVA billing, candidates for Prop bill, pickup_id's
		SELE act_dle
		SET ORDER TO TAG pickup_id

		GOTO BOTTOM										&& Kill duplicate ID's
		di=pickup_id
		SKIP -1
		dh=pickup_id

		DO WHILE (.NOT. BOF())
*			? DH,[|],DI
			IF (ALLTRIM(dh)=ALLTRIM(di))
				SKIP
				DELE
				SKIP -1
			ENDIF
			SKIP -1
			di=dh
			dh=pickup_id
		ENDDO

		USE act_dle EXCL									&& Presume that you can pack the dle file.
		SET DELETED OFF
		BROW
		SET DELETED ON
		PACK
		USE act_dle
		SET ORDER TO TAG pickup_id							&& no duplicates, now locate the active accounts




		USE act_dle EXCL						&& Presume that you can pack the dle file.
		PACK
		FLUSH
		USE

		USE act_dle
		SET ORDER TO TAG pickup_id								&& no duplicates, now locate the active accounts
		COPY ALL TO act_dlq									&& at this point,  we can make the set of delinquents from those who were notified.
		SELE 0
		USE act_dlq	EXCL										&& shim file to glue PVA rex to delinquent SW
		INDE ON ALLTRIM(compound) TAG compound
		INDE ON ALLTRIM(NAME) TAG NAME
		INDE ON ALLTRIM(pickup_id) TAG pickup_id
		USE
		SELE 0
		USE act_dlq
		SET ORDER TO TAG compound
		GOTO TOP											&&dlq can match act_cust by compound, change to working SW dir




&& Done with act_dle for now
&& make TIGHT compound in act_cust && Should this be the name_one from ttax2mm ?
		SELE act_cust
		REPLACE ALL compound WITH ALLTRIM(lname)+LEFT(fname,3)+;
			RIGHT(ALLTRIM(fname),3)+LEFT(address,10)+;
			LEFT(city,4)+ALLTRIM(zip)
		SET ORDER TO TAG compound

&&   should this be the name_one from ttax2mm?
		SELE 0
		USE ttax2mm EXCL
		INDEX ON ALLTRIM(compound) TAG compound
		USE
		FLUSH
		UNLOCK ALL
&& this is the PVA TRIM TAX LIST IN TIGHT COMPOUND ORDER
		SELE 0
		USE ttax2mm
		REPL ALL compound WITH ALLTRIM(lname)+LEFT(fname,3)+;
			RIGHT(ALLTRIM(fname),3)+LEFT(address,10)+;
			LEFT(city,4)+ALLTRIM(zip)
		SET ORDER TO TAG compound
&& now we can see pva in compound order as well as the other orders.


&& get these two files open in reasonable time
		SELE 0
		USE phnbook EXCL
		INDE ON ALLTRIM(compound)  TAG compound
		USE phnbook
		SET ORDER TO TAG compound

		SELE 0
		USE voters EXCL
		INDE ON ALLTRIM(compound) TAG compound
		USE voters
		SET ORDER TO TAG compound



		SELE act_dle

		RETURN



***************************************************
	PROCEDURE dlq_fix_act_cust
***************************************************

		CLEAR
		?
		?
&&  run act_4lt working copy LSW ACT accounts thru MM for harmonization&  & orig defa in dd
		&db
&& set  defa to current Solid Waste dir
		SELE 0
		USE act_cust ALIAS sw_current_cust										&&  this is the solid waste customer list
		COPY NEXT 1 TO act_cust2mm
		SELE 0
		USE act_cust2mm EXCL
		ZAP
		USE

		SELE sw_current_cust
		COPY ALL TO act_cust2mm
		SELE 0
		USE act_cust2mm EXCL
		INDE ON VAL(ALLTRIM(pickup_id)) TAG pickup_id
		INDE ON ALLTRIM(compound) TAG compound							&& make a copy of sw cust & fix addresses so they match well
		USE
		FLUSH
		UNLOCK ALL											&& set up the current sw cust list inde on pickup id
		SELE 0
		USE act_cust2mm ALIAS solid_waste_customers
&& now we have the copy of master sw cust list in solid_waste_customers-MM that
&& the Current ACT SW customer accounts are in SW_CURRENT_CUST
		&dd
&& set  defa  back to orig dir.  	&& make the MM work file to correct addresses from.
		REPL ALL solid_waste_customers.compound WITH PADL(ALLTRIM(STR(RECNO())),9,[0])
		COPY ALL TO wrk_tax.DBF FIELDS compound, account, fname, lname ,address,address2,city,state,zip
		?
		? [  The Solid Waste Customer Work Files for MM were ]+dd
		? [  Now run Mail Man and Encode WRK_TAX.DBF.  Export]
		? [  It to mm_tax.dbf (as usual).  Press Enter to ]
		? [  import the MM fixed addresses in  mm_tax.dbf to the ]
		? [  Solid Waste Customers after you have MM encoded them.]
		?
		STORE [ ] TO dc
		? [ Press Enter to Import corrected addresses from MailMan.]
		ACCE [Enter Q to Quit ] TO dc
&& now re-import the fixed mm rex
		? [Please Wait...]
		SELE 0		&& open the next avail workarea
		USE mm_tax.DBF EXCL
		INDE ON ALLTRIM(prop_num) TAG az
		SELE solid_waste_customers
&& * 	"compound with padl(alltrim(str(recno())),9,[0])"
		SET RELA TO ALLTRIM(solid_waste_customers.compound) INTO mm_tax
&& Don't ask why-MM has re-labeled compound as prop_num, but it has, so go with it



****
****   swapped address and address2 10/25/04
****
		GOTO TOP
		REPL ALL solid_waste_customers.fname WITH ALLTRIM(mm_tax.first_name),;
			solid_waste_customers.lname WITH ALLTRIM(mm_tax.last_name),;
			solid_waste_customers.address2 WITH ALLTRIM(mm_tax.dlvryaddr1),;
			solid_waste_customers.address WITH ALLTRIM(mm_tax.company),;
			solid_waste_customers.city WITH ALLTRIM(mm_tax.city),;
			solid_waste_customers.state WITH ALLTRIM(mm_tax.state),;
			solid_waste_customers.zip WITH ALLTRIM(mm_tax.zip4)

&& Make Tight Compound
		REPL ALL compound WITH ALLTRIM(solid_waste_customers.lname)+LEFT(solid_waste_customers.fname,3)+;
			RIGHT(ALLTRIM(solid_waste_customers.fname),3)+LEFT(solid_waste_customers.address,10)+;
			LEFT(solid_waste_customers.city,4)+ALLTRIM(solid_waste_customers.zip)

*		SET ORDER TO tag compound

		SELE mm_tax
		USE  && close the mm_tax data set
		RETURN  && The working copy  LSW ACT Solid Waste Customers have been MM'd and are harmonious



***************************************************
	PROCEDURE dlq_find_ids
***************************************************
		PRIV dj
		STORE [ ] TO dj

		? [ TOP dlq_find_IDs]
		ACCE ([ testing....]) TO dj
&&  load act_dle.compound from working LSW dir act_cust
		SELE solid_waste_customers
		SET ORDER TO TAG pickup_id

		SELE act_dle
		GOTO TOP


		SET RELA TO VAL(ALLTRIM(pickup_id)) INTO solid_waste_customers
		SKIP
		SKIP -1 													&& assert the relation
*	? [ DLE DO WHILE-BUILD COMPOUND FOR ACTIVE/INACTIVE SEARCH]
		DO WHILE .NOT. EOF()
			IF (solid_waste_customers.cust_type$[CcRr] )		&& is this customer active?
				REPL active_id WITH ALLTRIM(pickup_id), compound WITH ALLTRIM(solid_waste_customers.lname)+LEFT(solid_waste_customers.fname,3)+;
					RIGHT(ALLTRIM(solid_waste_customers.fname),3)+LEFT(solid_waste_customers.address,10)+;
					LEFT(solid_waste_customers.city,4)+ALLTRIM(solid_waste_customers.zip)
			ELSE
				REPL inact_id WITH ALLTRIM(pickup_id),  compound WITH ALLTRIM(solid_waste_customers.lname)+LEFT(solid_waste_customers.fname,3)+;
					RIGHT(ALLTRIM(solid_waste_customers.fname),3)+LEFT(solid_waste_customers.address,10)+;
					LEFT(solid_waste_customers.city,4)+ALLTRIM(solid_waste_customers.zip)
			ENDIF
			SKIP
		ENDDO									&& now we have the id's as active or not & matchable compounds
*	? [BELOW FLESH OUT ID#S]
		SELE act_dle
		GOTO TOP
		SET RELA OFF INTO solid_waste_customers
&& for now ac_dle.compound is LSW solid waste act_cust (not ttax2mm derived)

		SELE solid_waste_customers
		SET ORDER TO TAG compound

		SELE act_dle
		SET RELA TO ALLTRIM(compound) INTO solid_waste_customers
		SET SKIP TO solid_waste_customers
*	? [SET UP RELNS]
&& now we should be able to skip across dle and if an id shows up, we see if we have it,if not, we assume it's the other one.
&& hope like hell only two hits on compound....
		GOTO TOP
		SKIP
		SKIP -1						&& assert relation
		? [LOOKING IN PVA CUSTS]
		DO WHILE (.NOT. EOF())
			IF (ALLTRIM(act_cust.pickup_id) >[0])  && we have a hit
				?? [.]
				IF (ALLTRIM(solid_waste_customers.cust_type)$[CcRr])
					IF act_dle.active_id =[]
						act_dle.active_id=ALLTRIM(solid_waste_customers.pickup_id)
					ENDIF
				ENDIF

				IF (ALLTRIM(solid_waste_customers.cust_type)$[Ii])
					IF act_dle.inact_id =[]
						act_dle.inact_id=ALLTRIM(solid_waste_customers.pickup_id)
					ENDIF
				ENDIF


			ENDIF
			SKIP
		ENDDO									&& now we have inactives for actives, visa versa-, assign pickup_id to active
		SET RELA OFF INTO solid_waste_customers
		REPL ALL pickup_id WITH ALLTRIM(active_id)		&& list the active accounts
		RETURN



***************************************************
	PROCEDURE dlq_dupechk
***************************************************
* ? [ dlq dupe chk]
&& check again for dupes- mustn't bill anyone 2x
		INDE ON ALLTRIM(pickup_id) TO pickup_id		&&locate and delete duplicates
		GOTO BOTTOM
		di=pickup_id
		SKIP -1
		dh=pickup_id
		DO WHILE (.NOT. BOF())
			IF (ALLTRIM(dh)=ALLTRIM(di))
				SKIP
				DELE
				SKIP -1
			ENDIF
			SKIP -1
			di=dh
			dh=pickup_id
		ENDDO
		BROW
		USE act_dle EXCL						&& Presume that you can pack the dle file.
		PACK
		FLUSH
		USE

		USE act_dle
		SET ORDER TO TAG pickup_id								&& no duplicates, now locate the active accounts
		COPY ALL TO act_dlq									&& at this point,  we can make the set of delinquents from those who were notified.
		SELE 0
		USE act_dlq	EXCL										&& shim file to glue PVA rex to delinquent SW
		INDE ON ALLTRIM(compound) TAG compound
		INDE ON ALLTRIM(NAME) TAG NAME
		INDE ON ALLTRIM(pickup_id) TAG pickup_id
		USE
		SELE 0
		USE act_dlq
		SET ORDER TO TAG compound
		GOTO TOP											&&dlq can match act_cust by compound, change to working SW dir

		RETURN


***************************************************
	PROCEDURE dlq_tight_fit
***************************************************

		SELE solid_waste_customers
		REPL ALL compound WITH ALLTRIM(solid_waste_customers.lname)+LEFT(solid_waste_customers.fname,3)+;
			RIGHT(ALLTRIM(solid_waste_customers.fname),3)+LEFT(solid_waste_customers.address,10)+;
			LEFT(solid_waste_customers.city,4)+ALLTRIM(solid_waste_customers.zip)
		SET ORDER TO TAG compound

		SELE act_cust 							&& make compound in act_cust
		REPLACE ALL compound WITH ALLTRIM(lname)+LEFT(fname,3)+;
			RIGHT(ALLTRIM(fname),3)+LEFT(address,10)+;
			LEFT(city,4)+ALLTRIM(zip)
		SET ORDER TO TAG compound

		SELE phnbook 							&& make compound
		REPLACE ALL compound WITH ALLTRIM(lname)+LEFT(fname,3)+;
			RIGHT(ALLTRIM(fname),3)+LEFT(address,10)+;
			LEFT(city,4)+ALLTRIM(zip)
		SET ORDER TO TAG compound

		SELE voters 							&& make compound
		REPLACE ALL compound WITH ALLTRIM(lname)+LEFT(fname,3)+;
			RIGHT(ALLTRIM(fname),3)+LEFT(address,10)+;
			LEFT(city,4)+ALLTRIM(zip)
		SET ORDER TO TAG compound

&&   should this be the name_one from ttax2mm?

		SELE ttax2mm  && this is the PVA TRIM TAX LIST IN COMPOUND ORDER
		REPL ALL compound WITH ALLTRIM(lname)+LEFT(fname,3)+;
			RIGHT(ALLTRIM(fname),3)+LEFT(address,10)+;
			LEFT(city,4)+ALLTRIM(zip)
		SET ORDER TO TAG compound
&& now we can see pva in compound order as well as the other orders.



		SELE act_dlq
		SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO solid_waste_customers
		REPLACE ALL compound WITH ALLTRIM(solid_waste_customers.lname)+LEFT(solid_waste_customers.fname,3)+;
			RIGHT(ALLTRIM(solid_waste_customers.fname),3)+LEFT(solid_waste_customers.address,10)+;
			LEFT(solid_waste_customers.city,4)+ALLTRIM(solid_waste_customers.zip)
		SET RELATION OFF INTO solid_waste_customers



***************************************************
	PROCEDURE dlq_loose_fit
***************************************************


		SELE solid_waste_customers
		REPL ALL compound WITH ALLTRIM(solid_waste_customers.lname)+;
			LEFT(solid_waste_customers.address,10)+;
			LEFT(solid_waste_customers.city,4)+ALLTRIM(solid_waste_customers.zip)
		SET ORDER TO TAG compound

		SELE act_cust 							&& make compound in act_cust
		REPLACE ALL compound WITH ALLTRIM(lname)+LEFT(address,10)+;
			LEFT(city,4)+ALLTRIM(zip)
		SET ORDER TO TAG compound

		SELE phnbook							&& make compound in act_cust
		REPLACE ALL compound WITH ALLTRIM(lname)+LEFT(address,10)+;
			LEFT(city,4)+ALLTRIM(zip)
		SET ORDER TO TAG compound

		SELE voters 							&& make compound in act_cust
		REPLACE ALL compound WITH ALLTRIM(lname)+LEFT(address,10)+;
			LEFT(city,4)+ALLTRIM(zip)
		SET ORDER TO TAG compound




&&   should this be the name_one from ttax2mm?

		SELE ttax2mm  && this is the PVA TRIM TAX LIST IN COMPOUND ORDER
		REPL ALL compound WITH ALLTRIM(lname)+LEFT(street,10)+;
			LEFT(city,4)+ALLTRIM(zip)
		SET ORDER TO TAG compound
&& now we can see pva in compound order as well as the other orders.


		SELE act_dlq
		SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO solid_waste_customers
		REPLACE ALL compound WITH ALLTRIM(solid_waste_customers.lname)+LEFT(solid_waste_customers.address,10)+;
			LEFT(solid_waste_customers.city,4)+ALLTRIM(solid_waste_customers.zip)
		SET RELATION OFF INTO solid_waste_customers



***************************************************
	PROCEDURE dle2dlq
***************************************************
		PRIV da,db,dc,dd,de,df,dg,dh,di

		CLEAR
TEXT

					***  Prep for Delinquent SW Bill  ***

	This procedure builds the indexes and data sets to select
	Delinquent Solid Waste customers. Do this AFTER
	your last mailing of NOI's,  ie, w/in 60 days of
	PVA billing.  Late SW accounts will be placed on Property Tax
	bills.

	Run this from ACT_4LT, with a current tax year's TRIM/O/O-TAX___.DAT
	or LI SMITH tblACCOUNT file from the PVA.  Run the TRIM/ARM menus to
	import, fix, and export the TRIM/ARM data.  Have the PVA Tax Bills
	run to a SPL printer spool file.

	Now is a good time to update your Amnesty files (copy the latest Solid
	Waste ACT_MAIN.DBF to a local workstation drive and run Amnesty,
	M(anage to set the path to the files you copied).  It is also a
	good time to run a CALC_BALANCE in the CURRENT SOLID WASTE accounts.
	If you have fresh Voter lists or Phonebooks, install those first too.

	When this routine finishes it's annual run, you may open the ACT_4LT
	dir for sharing.  Many staff can run thru delinquent accounts at once.

	Enter the path to your copy of the current Solid Waste ACT
	Accounts, (like F:\LSW04).  Enter Q to Quit.


ENDTEXT
		STORE [set defa to ]+SYS(5)+SYS(2003) TO dd
		STORE [k:\act_whi]	TO da
		ACCE ([Enter CURRENT Solid Waste directory (Like F:\LSW04) ==>  ]) TO da
		STORE [set defa to ]+ALLTRIM(UPPER(da)) TO db
		IF (.NOT.(UPPER(ALLTRIM(da))=[Q]))

			DO dlq_start

			DO dlq_fix_act_cust

*	DO dlq_find_ids

*	DO dlq_dupechk

			DO dlq_loose_fit

			DO dlq_tight_fit
&& all the compounds are built w/ harmonized data where available



&&  how to do this across years?
*
*
***  index all the files by compound of lname,fname,street,city,&zip
*
*
			CLEAR
TEXT


	Delinquent SW data sets ready for viewing.


ENDTEXT

			CLOSE DATA
			DO view_set
		ENDIF


		RETURN



********************************************************
	PROCEDURE dlq_view
********************************************************
		PRIVATE cur_path, wrk_path, sw_path,amnesty_path, dj
		CLEAR
		STORE [ ]  TO sw_path
		STORE [ ]  TO cur_path
		STORE [ ]  TO amnesty_path
TEXT

Please enter the drive and directory
paths  for  your CURRENT SW accounts,
like F:\LSW04

Also, please enter the mailing date for the PVA Property Tax
Bills.  Enter a date like 10/25/2005

ENDTEXT

		ACCE ([Enter  path  to your CURRENT SW accounts==> ]) TO sw_path
		ACCE ([Enter the Mailing Date for the PVA Tax Bills. ==> ]) TO pva_bill_txt
		pva_bill=CTOD(pva_bill_txt)

		STORE [c:\amnesty] TO amnesty_path
		STORE [set defa to ]+ALLTRIM(sw_path) TO sw_path
		STORE [set defa to ]+ amnesty_path TO  amnesty_path
		STORE [set defa to ]+SYS(5)+SYS(2003) TO cur_path       && orig defa in cur_path

* sw_path
* cur_path
* amnesty_path


		SET RESOURCE ON

		SET CENTURY ON
		SET EXACT ON
		SET NEAR OFF

		STORE .F. TO ok2quit
		STORE 100 TO amn_max_years
		STORE amn_max_years+1 TO amn_wrk
		STORE [F] TO amn_drv
		STORE [/lsw97] TO amn_dir
		STORE CTOD([01/01/1997]) TO amn_year
		STORE [000000] TO amn_id
		STORE  0 TO amn_recno
		STORE 0 TO amn_y

		STORE [] TO amn_pick


		CLOSE DATA


&& start in Current Solid Waste dir
		&sw_path

		DO view_set

		SELE act_main
		SET RELA OFF INTO act_cust
		SET RELA OFF INTO act_pay
		SET ORDER TO TAG pickup_id
		SELE act_pay
		SET ORDER TO TAG pic_id_i
		SELE act_cust
		SET RELA TO ALLTRIM(pickup_id) INTO act_main
		SET RELA TO  ALLTRIM(pickup_id) INTO act_pay ADDITIVE

		USE act_cust.DBF IN 0 AGAIN SHARED ORDER TAG bothnames ALIAS cus_bothnames

&& MAIN PARENT TO PAY AND MAIN, PAY IS NOT BOUND TO INVOICE, JUST CUST

		GOTO TOP
		SKIP
		SKIP -1
		SELE 0
		USE act_cust2mm ALIAS solid_waste_customers ORDER TAG pickup_id


		&amnesty_path
		DO open_files
* set up amnesty files


&& now change to starting dir
		&cur_path

		SELE 0
		USE tax_spl
		SET ORDER TO TAG  name1map

		SELE 0
		USE phnbook
		SET ORDER TO TAG addrzip5

		SELE 0
		USE voters
		SET ORDER TO TAG addrzip5

		SELE 0
		USE act_dle ORDER TAG pickup_id

		SELE 0
		USE act_dlq
		SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO act_cust
		SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO act_dle ADDITIVE
		SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO solid_waste_customers ADDITIVE
		SET RELATION TO ALLTRIM(act_cust.lname)+[ ]+ALLTRIM(act_cust.fname) INTO cus_bothnames ADDITIVE
		GOTO TOP
		SKIP
		SKIP -1


* sele solid_waste_customers
* set relation to ALLTRIM(compound) into voters
* set relation to ALLTRIM(compound) into phnbook additive


* GOTO TOP
* SKIP
* SKIP -1


		SELE 0
		USE ttax2mm  ORDER TAG addrzip5

		SELE solid_waste_customers
		SET RELATION TO ALLTRIM(address)+" "+LEFT(zip,5) INTO ttax2mm

		GOTO TOP
		SKIP
		SKIP -1

		SELE ttax2mm
		SET RELA TO ALLTRIM(name_one)+[ ]+ALLTRIM(map) INTO tax_spl,;
			ALLTRIM(address)+" "+LEFT(zip,5) INTO voters,;
			ALLTRIM(address)+" "+LEFT(zip,5) INTO phnbook

&&  ASSERT ALL RELN'S
		SELE act_dlq
		GOTO TOP
		SKIP
		SKIP -1


* &sw_path
*  SELE 0
*  sUSE act_cust ALIAS sw_current_cust

* &cur_path

		SELE act_dle
		BROW LAST NOWAIT NOEDIT TITLE [Recipients of NOI Delinquency Letters]

		SELE voters
		BROWSE LAST NOWAIT NOEDIT  TITLE  [Voter Registration List]

		SELE phnbook
		BROWSE LAST NOWAIT NOEDIT TITLE [2000 Phone Book]

		SELE ttax2mm
		BROWSE LAST NOWAIT NOEDIT TITLE [Property Tax Only-not Tangible/Intangible]

		SELE act_cust
		BROW LAST NOWAIT FIELDS totl_amt:12, pickup_id:9,comments:10, lname:15,fname:15 TITLE [Master Solid Waste Account (Edit OK).]

		SELE cus_bothnames
		BROW LAST NOWAIT FIELDS cust_type:3,pickup_id:9,lname:15,fname:15  TITLE [SW: Find Inactives.]

		SELE  amn_pay
		BROW LAST NOWAIT NOEDIT FIELDS amt_paid,date_paid,COMMENT:20, pickup_id:9, t_name:20 TITLE [Press Analyse to Show All Credits ordered by amount.  Amnesty credit should be near top]

		SELE act_pay
		BROW NOWAIT LAST NOEDIT TITLE [Payment Records for Master SW Account]

*sele tax_spl
*edit nowait noedit noclear

		SELE solid_waste_customers
		BROW LAST NOEDIT NOWAIT  TITLE[Solid Waste  Account  (Copy with MM Fixed Addressing).]

* ACTIVATE WINDOW CALCULATOR

		SELE act_dlq
		BROW LAST NOWAIT FIELDS pickup_id:9,done:3,NAME:25,active_id:9, inact_id:9 TITLE [Delinquent SW Account ID/Name]

		DO FORM act_dlq

* DO FORM act_dlq
* READ EVENTS

		&cur_path
* close data
*  do view_set
		RETURN

********************************************************************************
********************************************************************************
	PROCEDURE spool2bill
********************************************************************************
********************************************************************************
*  ARM version   wsh oct 11 2005-will not work for trim records

		PRIV sline,sa,sb,sc,sd,se,sf,sg

		PRIV SP_FF,SP_LF,SP_NUL,SP_CR,map_line_offset
		STORE CHR(13) TO SP_CR
		STORE CHR(12) TO SP_FF
		STORE CHR(10) TO SP_LF
		STORE CHR(0) TO SP_NUL
		STORE 0 TO map_line_offset


		PRIV lines_per_bill
		STORE 24 TO lines_per_bill

&& Set these line numbers for your bill style
		PRIV l_name, l_map, l_desc, l_acct,l_clerk,l_ttax_wrong, ;
			acct_start_col,name_start_col, arm_li, arm_lj, ;
			arm_lk,arm_total_tax,arm_clerk,ttax_start_col,clerk_start_col, space_col

		STORE [WINSTON MEADE] TO arm_clerk		&& 2005 arm run broken- no clerk, so hand fix

		STORE [l14] TO l_clerk
		STORE 85 TO ttax_start_col
		STORE [l13] TO l_ttax_wrong
		STORE 62 TO clerk_start_col
		STORE 53 TO space_col		&& where to add a blank in l17 & l19

		STORE [L18] TO l_name							&& WAS L16   &&bill line number containing taxpayer's name
		STORE [L23] TO l_map							&&  WAS L22
		STORE [L22] TO l_desc							&& WAS L21
		STORE [L5] TO l_acct
		STORE 90 TO acct_start_col						&& WAS 105 &&  column positions of the bill parts
		STORE 10 TO name_start_col						&& WAS 25

		CLOSE DATA  			&& close any open files
		ACTIVATE SCREEN
		CLEAR

		SELE 0
		USE tax_tmp EXCL

		ACTIVATE WINDOW big_msg

		CLEAR
TEXT

		***   Import PVA Bill SPL File   ***

	This procedure captures PVA Bills (T TYPE ONLY)
	from their Printer's Spool File, made during a
	bill run.The spool file name is typically
	00001.SPL and is found in:
	c:\WINNT\system32\spool\PRINTER, but you
	may create it with a "print to file" run.

	Enter the full drive/path/filename (Q to quit):
ENDTEXT

		ZAP
		sf=[]
		sg=.T.
		DO WHILE sg
			?
			ACCE([ ==>]) TO sf

			IF ALLTRIM(sf)$[Qq]
				DO QUIT_ACT WITH [Q]
			ENDIF

			IF FILE( ALLTRIM(UPPER(sf)) )
				APPE FROM [&sf] TYPE SDF
				sg=.F.
			ELSE
				? [Bad File Name.  Try Again.]
			ENDIF
		ENDDO
		CLEAR
		?
		? [WORKING...]

		SELE 0
		USE tax_spl  EXCL
		ZAP
		APPE BLANK
		SELE tax_tmp

		sline=0
		GOTO TOP
		
		skip  && extra first line in ARM files
		
		DO WHILE .NOT.EOF()
			sline=sline+1
			IF SP_FF$L1
				sa="repl tax_spl.L"+ALLTRIM(STR(sline))+" with l1"
				&sa
				sline=lines_per_bill		&& the form feed signals the end of the record
			ELSE
				sa="repl tax_spl.L"+ALLTRIM(STR(sline))+" with l1"
				&sa
			ENDIF
			IF sline=lines_per_bill
				sline=0
				SELE tax_spl
				APPE BLANK   				&& new bill
				SELE tax_tmp
			ENDIF
			SKIP
		ENDDO
		SELE tax_tmp
		ZAP
&& now link bill to ttax2mm

		SELE 0
		USE ttax2mm
		SET ORDER TO TAG name1map

		GOTO TOP
		SELE tax_spl

		GOTO TOP


		SET FILTER TO (LEN(ALLTRIM(L23))>0 .AND. (.NOT. ([TANG] $ L23))) .AND.(SP_FF$L23)
&&  l16 is name_one, l22 is map, l21 is desc
		? [L23:  Linking data from PVA T-type Bill Spool Record to PVA TAX data]
		STORE [L18] TO l_name							&& WAS L16   &&bill line number containing taxpayer's name
		STORE [L23] TO l_map							&&  WAS L22
		STORE [L22] TO l_desc							&& WAS L21

		REPL ALL name_one WITH ALLTRIM(SUBSTR(&l_name,name_start_col,40));		&& was 30 char long
		map WITH ALLTRIM(SUBSTR(&l_map,name_start_col,25));					&& was 19 char
		DESCRIPT WITH ALLTRIM(SUBSTR(&l_desc,name_start_col,40));
			account WITH ALLTRIM(SUBSTR(&l_acct,acct_start_col,9))
		REPL ALL L23 WITH  LEFT(L23,AT(SP_FF,L23)-1)

&& now clean up the tangs in l23
&& for the ones with only a top line- they've got the totals in l12 not l13
		SET FILTER TO (LEN(ALLTRIM(L23))>0 .AND. (([TANG] $ L23))) .AND.(SP_FF$L23) .AND. (LEN(ALLTRIM(LEFT(L5,80)))=0)
		REPL ALL l13 WITH l12
		REPL ALL l12 WITH []
&&  Now get the form feed out of there
		SET FILTER TO (LEN(ALLTRIM(L23))>0 .AND. (([TANG] $ L23))) .AND.(SP_FF$L23)
		REPL ALL L23 WITH  LEFT(L23,AT(SP_FF,L23)-1)

		SET FILTER TO (LEN(ALLTRIM(L22))>0 .AND. (.NOT. ([TANG] $ L22))).AND.(SP_FF$L22)
&&  l16 is name_one, l22 is map, l21 is desc
		? [L22: Linking data from PVA T-type Bill Spool Record to PVA TAX data]
		STORE [L17] TO l_name							&& WAS L16   &&bill line number containing taxpayer's name
		STORE [L22] TO l_map							&&  WAS L22
		STORE [L21] TO l_desc							&& WAS L21
		REPL ALL name_one WITH ALLTRIM(SUBSTR(&l_name,name_start_col,40));		&& was 30 char long
		map WITH ALLTRIM(SUBSTR(&l_map,name_start_col,25));					&& was 19 char
		DESCRIPT WITH ALLTRIM(SUBSTR(&l_desc,name_start_col,40));
			account WITH ALLTRIM(SUBSTR(&l_acct,acct_start_col,9))
		REPL ALL L22 WITH  LEFT(L23,AT(SP_FF,L22)-1)

&& now clean up the tangs in l22
&& for the ones with only a top line- they've got the totals in l12 not l13
		SET FILTER TO (LEN(ALLTRIM(L22))>0 .AND. (([TANG] $ L22))) .AND.(SP_FF$L22) .AND. (LEN(ALLTRIM(LEFT(L5,80)))=0)
		REPL ALL l13 WITH l12
		REPL ALL l12 WITH []
&&  Now get the form feed out of there
		SET FILTER TO (LEN(ALLTRIM(L22))>0 .AND. (([TANG] $ L22))) .AND.(SP_FF$L22)
		REPL ALL L22 WITH  LEFT(L22,AT(SP_FF,L22)-1)



		SET FILTER TO (LEN(ALLTRIM(L21))>0 .AND. (.NOT. ([TANG] $ L21))).AND.(SP_FF$L21)
&&  l16 is name_one, l22 is map, l21 is desc
		? [L21: Linking data from PVA T-type Bill Spool Record to PVA TAX data]
		STORE [L16] TO l_name							&& WAS L16   &&bill line number containing taxpayer's name
		STORE [L21] TO l_map							&&  WAS L22
		STORE [L20] TO l_desc							&& WAS L21
		REPL ALL name_one WITH ALLTRIM(SUBSTR(&l_name,name_start_col,40));		&& was 30 char long
		map WITH ALLTRIM(SUBSTR(&l_map,name_start_col,25));					&& was 19 char
		DESCRIPT WITH ALLTRIM(SUBSTR(&l_desc,name_start_col,40));
			account WITH ALLTRIM(SUBSTR(&l_acct,acct_start_col,9))

		REPL ALL L21 WITH  LEFT(L23,AT(SP_FF,L21)-1)
&& finish using formfeed to locate field positions

&& now clean up the tangs in l21
&& for the ones with only a top line- they've got the totals in l12 not l13
		SET FILTER TO (LEN(ALLTRIM(L21))>0 .AND. (([TANG] $ L21))) .AND.(SP_FF$L21) .AND. (LEN(ALLTRIM(LEFT(L5,80)))=0)
		REPL ALL l13 WITH l12
		REPL ALL l12 WITH []
&&  Now get the form feed out of there
		SET FILTER TO (LEN(ALLTRIM(L21))>0 .AND. (([TANG] $ L21))) .AND.(SP_FF$L21)
		REPL ALL L21 WITH  LEFT(L21,AT(SP_FF,L21)-1)




&& now fix the intang that have crowded up 1 line too close to clerk line
set filter to ([INTANG]$l21).and.(len(alltrim(left(l5,82)))=0)
&& first move lines down 1
			GOTO TOP
			DO WHILE .NOT. EOF()
				FOR arm_li=23 TO 15 step -1
					sa="repl tax_spl.L"+ALLTRIM(STR(arm_li+1))+" with l"+ALLTRIM(STR(arm_li))
					&sa
				ENDFOR
				REPL tax_spl.L15 WITH []
				SKIP
			ENDDO
&& fix weird tang 05 that has escaped fixing so far (9 recs)
set filter to ((.not. [ASSMT]$l14).and.(len(alltrim(l15))>0))
&& first move lines down 1
			GOTO TOP
			DO WHILE .NOT. EOF()
				FOR arm_li=23 TO 15 step -1
					sa="repl tax_spl.L"+ALLTRIM(STR(arm_li+1))+" with l"+ALLTRIM(STR(arm_li))
					&sa
				ENDFOR
				REPL tax_spl.L15 WITH []
				SKIP
			ENDDO


		SET FILTER TO SP_FF$map
		REPL ALL map WITH LEFT(map,AT(SP_FF,map)-1)


&&  now nail the formfeeds

		SET FILTER TO
		INDE ON ALLTRIM(name_one) TAG name_one
		INDE ON ALLTRIM(map) TAG map
		INDE ON ALLTRIM(DESCRIPT) TAG DESCRIPT
		INDE ON ALLTRIM(account) TAG account
		INDE ON ALLTRIM(name_one)+[ ]+ALLTRIM(map) TAG name1map


&& postfix ARM screwups in the printform

		IF yesno([Fix ARM 2005 bill errors (add Winston, homestead lines, add char to dec 31 & 2n Jan 31 lines)?])
&& first move all assmt (homesteads up) 1 line form l16 thru l24
			SET FILTER TO ([ASSMT]$ l14)
			GOTO TOP
			DO WHILE .NOT. EOF()
				FOR arm_li=16 TO 23
					sa="repl tax_spl.L"+ALLTRIM(STR(arm_li))+" with l"+ALLTRIM(STR(arm_li+1))
					&sa
				ENDFOR
				REPL tax_spl.L24 WITH []
				SKIP
			ENDDO
&& finished fixing the homesteads

&& find the total_tax in l13 & move to l14

			SET FILTER TO
			GOTO TOP
			DO WHILE .NOT. EOF()
* store [WINSTON MEADE] to arm_clerk
* store 85 to ttax_start_col
* store 62 to clerk_start_col
				STORE SUBSTR(l13,ttax_start_col) TO arm_total_tax		&& grab the total tax from l13
				REPL l13 WITH LEFT(l13,ttax_start_col)					&& nail the total tax from l13
				REPL l14 WITH STUFF(l14,clerk_start_col,LEN(arm_clerk),arm_clerk)				&& stuff in the clerk name
				REPL l14 WITH STUFF(l14,ttax_start_col,LEN(arm_total_tax),arm_total_tax)		&& stuff in the clerk name
&& finish find the total_tax in l13 & move to l14



&& insert a char in lines 17 and 19 at space_pos, and into l18 if there is a val in left 53 chars
				REPL L17 WITH SUBSTR(L17,1,space_col)+SUBSTR(L17,space_col)
				IF   LEN(ALLTRIM(LEFT(L18,space_col)))>0
					REPL L18 WITH SUBSTR(L18,1,space_col)+SUBSTR(L18,space_col)
				ENDIF
				REPL l19 WITH SUBSTR(l19,1,space_col)+SUBSTR(l19,space_col)
&&  end insert char
				SKIP
			ENDDO
&& now all bills are harmoniously incorrect and need to be frame shifted down at line 16									
			
			GOTO TOP
			DO WHILE .NOT. EOF()
				FOR arm_li=23 TO 16 step -1
					sa="repl tax_spl.L"+ALLTRIM(STR(arm_li+1))+" with l"+ALLTRIM(STR(arm_li))
					&sa
				ENDFOR
				REPL tax_spl.L16 WITH []
				SKIP
			ENDDO			
			
			
			CLEAR
			? [Done fixing ARM 2005 layout errors.]

		ENDIF											&& yesno


		?
		? [Finished Importing PVA Property Bill Printer Spool (SPL) File]
		?
		? [ PROGRAM WILL QUIT WHEN YOU HIT ENTER. RESTART TO CONTINUE.]

		ACCE [PRESS ENTER TO QUIT.] TO sg
		IF ALLTRIM(sg) $[Nn] then
			?
		ELSE
			CLOSE DATA
			DO QUIT_ACT WITH [Q]
			DEACTIVATE MENU TAX_DLQ
		ENDIF
		RETURN


********************************************************************************
********************************************************************************
	PROCEDURE deduct_interest_from_dlq
********************************************************************************
********************************************************************************
		PUBLIC ded_recn, ded_int, ded_fix,ded_i, ded_j,ded_k, ded_l, DED_PRE,DED_POST

		PRIVATE cur_path, wrk_path, sw_path,amnesty_path, dj
		CLEAR
		STORE [ ]  TO sw_path
		STORE [ ]  TO cur_path
		STORE [ ]  TO amnesty_path

		ACTIVATE WINDOW big_msg
		CLEAR
TEXT

Please enter the drive and directory
paths  for  your CURRENT SW accounts,
like F:\LSW04

Also, please enter the mailing date for the PVA Property Tax
Bills.  Enter a date like 10/25/2005

ENDTEXT

		ACCE ([Enter  path  to your CURRENT SW accounts==> ]) TO sw_path
		ACCE ([Enter the Mailing Date for the PVA Tax Bills. ==> ]) TO pva_bill_txt
		pva_bill=CTOD(pva_bill_txt)


		STORE [c:\amnesty] TO amnesty_path
		STORE [set defa to ]+ALLTRIM(sw_path) TO sw_path
		STORE [set defa to ]+ amnesty_path TO  amnesty_path
		STORE [set defa to ]+SYS(5)+SYS(2003) TO cur_path       && orig defa in cur_path

* sw_path
* cur_path
* amnesty_path


		SET RESOURCE ON

		SET CENTURY ON
		SET EXACT ON
		SET NEAR OFF

		STORE .F. TO ok2quit
		STORE 100 TO amn_max_years
		STORE amn_max_years+1 TO amn_wrk
		STORE [F] TO amn_drv
		STORE [/lsw97] TO amn_dir
		STORE CTOD([01/01/1997]) TO amn_year
		STORE [000000] TO amn_id
		STORE  0 TO amn_recno
		STORE 0 TO amn_y

		STORE [] TO amn_pick


		CLOSE DATA


&& start in Current Solid Waste dir
		&sw_path

		DO view_set

		SELE act_main
		SET RELA OFF INTO act_cust
		SET RELA OFF INTO act_pay
		SET ORDER TO TAG pickup_id
		SELE act_pay
		SET ORDER TO TAG pic_id_i
		SELE act_cust
		SET RELA TO ALLTRIM(pickup_id) INTO act_main
		SET RELA TO  ALLTRIM(pickup_id) INTO act_pay ADDITIVE

		USE act_cust.DBF IN 0 AGAIN SHARED ORDER TAG bothnames ALIAS cus_bothnames

&& MAIN PARENT TO PAY AND MAIN, PAY IS NOT BOUND TO INVOICE, JUST CUST

		GOTO TOP
		SKIP
		SKIP -1
		SELE 0
		USE act_cust2mm ALIAS solid_waste_customers ORDER TAG pickup_id


		&amnesty_path
		DO open_files
* set up amnesty files


&& now change to starting dir
		&cur_path

		SELE 0
		USE tax_spl
		SET ORDER TO TAG  name1map

		SELE 0
		USE phnbook
		SET ORDER TO TAG addrzip5

		SELE 0
		USE voters
		SET ORDER TO TAG addrzip5

		SELE 0
		USE act_dle ORDER TAG pickup_id

		SELE 0
		USE act_dlq
		SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO act_cust
		SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO act_dle ADDITIVE
		SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO solid_waste_customers ADDITIVE
		SET RELATION TO ALLTRIM(act_cust.lname)+[ ]+ALLTRIM(act_cust.fname) INTO cus_bothnames ADDITIVE
		GOTO TOP
		SKIP
		SKIP -1


* sele solid_waste_customers
* set relation to ALLTRIM(compound) into voters
* set relation to ALLTRIM(compound) into phnbook additive


* GOTO TOP
* SKIP
* SKIP -1


		SELE 0
		USE ttax2mm  ORDER TAG addrzip5

		SELE solid_waste_customers
		SET RELATION TO ALLTRIM(address)+" "+LEFT(zip,5) INTO ttax2mm

		GOTO TOP
		SKIP
		SKIP -1

		SELE ttax2mm
		SET RELA TO ALLTRIM(name_one)+[ ]+ALLTRIM(map) INTO tax_spl,;
			ALLTRIM(address)+" "+LEFT(zip,5) INTO voters,;
			ALLTRIM(address)+" "+LEFT(zip,5) INTO phnbook

&&  ASSERT ALL RELN'S
		SELE act_dlq
		GOTO TOP
		SKIP
		SKIP -1



		ACTIVATE WINDOW big_msg
		CLEAR

TEXT
This procedure does a once-a-year fix to remove all interest charges
from a delinquent assesment before conveying it to the PVA tax bill.

Amnesty credits back interest fees, so a client's balance that took
amnesty would get double-dip credits unless the amnesty credit is first
returned to the sum before removing all credit charges.  Likewise with
the Fix_M2Q credit that repairs the interest rate error made when monthly
billing changed to quarterly.

Run this routine One Time Per Year before printing the Tax Bills.  The
Act_dlq records are first copied to the file Dlq_bax.dbf before proceeding.

ENDTEXT

		ACCE ([ OK to Continue ? Y/N==>]) TO ded_j
		IF ALLTRIM(ded_j)$[Yy] then
			SELE act_dlq		&& use the tagged delinquent records
			COPY ALL TO dlq_bax && make a copy before anything else
			SET FILTER TO done=.T.
			SUM ALL TOTAL_DUE TO DED_PRE
			GOTO TOP
			SKIP			&& SKIP THE FIRST REC ALWAYS
			DO WHILE .NOT. EOF()	&&do all delinquents
				STORE RECNO() TO ded_recn
				ded_fix=0
				ded_int=0
				STORE act_dlq.pickup_id TO amn_pickup_id		&& grab te ID#
				STORE 0 TO amn_sum
				DO find_last_ok_ytd		&& compute all interest charges back to paid up/$0 balance
				ded_int = amn_sum		&& this is the total interest- subtract it from total_due
				SELE amn_wrk
				SEEK CTOD([12/31/2005])  && year when fix_m2q credits were set
				SELE(VAL(ALLTRIM(amn_wrk.COMMENT))+1)  && act_pay for 2005
				SEEK ALLTRIM(act_dlq.pickup_id)			&& look for dlq's ID#
				DO WHILE ((ded_fix=0).AND. (ALLTRIM(pickup_id)=ALLTRIM(act_dlq.pickup_id) ) .AND. (.NOT.EOF()))  && go thru all 2005 credits for this dlq ID
					IF ([FixErr_m2q]$COMMENT) then		&& ok found the fix_m2q credit
						ded_fix=amt_paid				&& grab the $ dedn & add it back into the dlq account-> like de-amnesty
					ENDIF
					SKIP
				ENDDO		&& quits as soon as I find one
				SELE act_dlq
&& now assert all the debits and credits to act_dlq
				ACTIVATE WINDOW big_msg
				? [==> ]+act_dlq.pickup_id+[ | Pre Interest Fix:],act_dlq.TOTAL_DUE, [| M2Q_Fix:],ded_fix,[ | All Int:], ded_int
				REPL act_dlq.TOTAL_DUE WITH act_dlq.TOTAL_DUE+ded_fix-ded_int		&& adjust the total due:  add back interest credit, then subtract off all interest
				?? [ | Post Interest Fix: ],act_dlq.TOTAL_DUE, [ <==]

				SELE act_cust
				SEEK act_dlq.pickup_id
* title [Master Solid Waste Account (w/out Address fixes).]
				REPL  dlq_hist WITH [ | Pre Interest Fix:]+STR(act_dlq.TOTAL_DUE)+[| M2Q_Fix:]+STR(ded_fix)+[ | All Int:]+STR(ded_int)+[ | Post Fix: ]+STR(act_dlq.TOTAL_DUE)+ [ <==]+ALLTRIM(dlq_hist)

				SELE solid_waste_customers
				SEEK act_dlq.pickup_id
				REPL  dlq_hist WITH [ | Pre Interest Fix:]+STR(act_dlq.TOTAL_DUE)+[| M2Q_Fix:]+STR(ded_fix)+[ | All Int:]+STR(ded_int)+[ | Post Fix: ]+STR(act_dlq.TOTAL_DUE)+ [ <==]+ALLTRIM(dlq_hist)
				SELE act_dlq
				GOTO ded_recn
				SKIP
			ENDDO
			ACTIVATE WINDOW big_msg
			ACCE ([Press ENTER to proceed]) TO ded_k
			CLEAR

			SET FILTER TO
			COPY ALL TO DLQ_ALL_FOR_YEAR
			SET FILTER TO (done=.T.) .AND. (TOTAL_DUE>1)
			COUNT ALL FOR done TO ded_l
			SUM(TOTAL_DUE) TO DED_POST
			?
			? [PLEASE NOTE THE FOLLOWING:]
			?
			? [FOR DELINQUENT ACCOUNTS OWING MORE THAN 1$==>]
			?
			? [TOTAL DELINQUENTS TAGGED: ],ded_l
			?
			? [TOTAL AMOUNT TAGGED: ],DED_POST
			?
			? [TOTAL INTEREST DEDUCTED: ],DED_PRE-DED_POST
			?
			SET FILTER TO (done=.T.).AND.(TOTAL_DUE<1)
			COUNT ALL TO A
			? [# ACCOUNTS NOT PRINTED (MARKED DONE BUT < $1) =>],A
			SET FILTER TO
			ACCE ([Press ENTER to proceed]) TO ded_k
			SET FILTER TO

		ENDIF && ded_j ok
		DEACTIVATE WINDOW big_msg
		ACTIVATE SCREEN
		CLOSE DATA



		RETURN







********************************************************************************
********************************************************************************
	PROCEDURE MAKE_tax_bills
********************************************************************************
********************************************************************************


		PRIV sline,sa,sb,sc,sd,se,sf,sg, s_tab, s_noroom
		PRIV MA_LEFT_OFFSET
		
		STORE 1 TO sd
		STORE .F. TO s_noroom
		PRIV lines_per_bill
		STORE 24 TO lines_per_bill
		STORE SPACE(6) TO s_tab

&& Set these line numbers for your bill style
		PRIV l_name, l_map, l_desc, l_acct,l_clerk,l_ttax_wrong, ;
			acct_start_col,name_start_col, arm_li, arm_lj, ;
			arm_lk,arm_total_tax,arm_clerk,ttax_start_col,clerk_start_col, space_col

		STORE [WINSTON MEADE] TO arm_clerk		&& 2005 arm run broken- no clerk, so hand fix

		STORE [l14] TO l_clerk
		STORE 85 TO ttax_start_col
		STORE [l13] TO l_ttax_wrong
		STORE 62 TO clerk_start_col
		STORE 53 TO space_col		&& where to add a blank in l17 & l19

		STORE [L18] TO l_name							&& WAS L16   &&bill line number containing taxpayer's name
		STORE [L23] TO l_map							&&  WAS L22
		STORE [L22] TO l_desc							&& WAS L21
		STORE [L5] TO l_acct
		STORE 90 TO acct_start_col						&& WAS 105 &&  column positions of the bill parts
		STORE 10 TO name_start_col						&& WAS 25


*	STORE [L16] TO l_name							&& bill line number containing taxpayer's name
*	STORE [L22] TO l_map
*	STORE [L21] TO l_desc
*	STORE [L4] TO l_acct
*	STORE 105 TO acct_start_col					&&  column positions of the bill parts
*	STORE 25 TO name_start_col


		CLOSE DATA
		DO view_set

		ACTIVATE SCREEN
		CLEAR
		ACTIVATE WINDOW big_msg
		CLEAR
TEXT

		***  Make SW/TRIM Bill SPL File   ***

	This procedure makes Property Tax Bills
	(Ky State TRIM T-TYPE ONLY) with SW debt
	from the Printer Spool File made during a
	PVA bill run.

	Overdue Solid Waste debt will added to
	some records, per the data in ACT_DLQ.

	The spool file was previously imported.

	RUN THIS ONCE PER YEAR.  DO NOT RUN IT
	TWICE.


ENDTEXT


		USE act_dlq SHARED ORDER TAG name1map IN 0
		SELE act_dlq
		REPL ALL printed_on WITH CTOD([00/00/00]),bill_num WITH 0
		COPY NEXT 1 TO act_dlp
* ACT_DLP PVA BILLS BEFORE DOING SW DELINQUENT BILL TOUCHES
		USE act_dlp EXCL IN 0
		SELE act_dlp
		ZAP
		USE act_dlp SHARED
		USE tax_spl SHARED IN 0
		SELE tax_spl
		SET RELATION TO ALLTRIM(name_one)+[ ]+ALLTRIM(map) INTO act_dlq

*		STORE ORDER() TO c_tmp

		SET ORDER TO
		GO BOTTOM
		STORE RECNO()TO end_i
		GO TOP
		SKIP 1
		SKIP -1
* dummy rec at top
		STOR RECNO() TO start_i

		sline=0
		sf=start_i+end_i
		ON KEY LABEL ESC EXIT
		SET CONSOLE OFF
*		do while .not. ((eof() ).and.(recno()<=sf ))
		FOR sd=1 TO end_i
			noroom=.F.
			IF ((ALLTRIM(act_dlq.name1map)=ALLTRIM(name_one)+[ ]+ALLTRIM(map)) .AND. (act_dlq.done).AND. (act_dlq.TOTAL_DUE>1))
*			noroom=((LEN(ALLTRIM(l10))>0).OR.(LEN(ALLTRIM(l11))>0))
				noroom=((LEN(ALLTRIM(l11))>0).OR.(LEN(ALLTRIM(l12))>0))			&& SHIFTED DOWN 1
				IF noroom
					DO msg2user WITH [ ]
					ACTIVATE WINDOW msg2user
					CLEAR
					? [ERROR: NO ROOM FOR SW TEXT.  BILL #: ],RECNO(),[,SW ACCT#: ],act_dlq.pickup_id
					ACCE [MAKE SW BILL BY HAND.  PVA UNCHANGED.  PRESS ENTER TO CONTINUE. ] TO start_i
					CLEAR
					DO msg2user WITH [CLOSE]
				ENDIF
			ENDIF

STORE 22 TO MA_LEFT_OFFSET			&&  WAS 30, SPACE OFFSET FROM LEFT OF LINE FOR TWEAKING THE RIGHT-LEFTNESS

			FOR sline=1 TO lines_per_bill
* inspect line # & content- do fixes now, also threshold print/no print , and keep sums.
				IF (((ALLTRIM(act_dlq.name1map)=ALLTRIM(name_one)+[ ]+ALLTRIM(map))) .AND. (.NOT.(noroom )).AND.(act_dlq.done ).AND. (act_dlq.TOTAL_DUE>1))
* have a hit on the SW billing
*					? [ACCOUNT # ]+act_dlq.pickup_id+[  LATE LETCHER COUNTY SOLID WASTE DEBT PER KRS 109 ===>]
*					? [THE LATE DEBT LISTED ABOVE IS NOT SUBJECT TO DISCOUNT OR PENALTY.]
*					? [ BINGO: ],act_dlq.pickup_id,[| ],act_dlq.total_due, [| ],act_dlq.gt90day,[| ],act_dlq.decredit,[| ], act_dlq.chg_date
					DO CASE       &&         * case by line
					CASE sline=1		&& SNAG UNTOUCHED RECORD TO ACT_DLP
						COPY NEXT 1 TO junk
						SELE act_dlp
						APPE FROM junk
						SELE tax_spl
					CASE sline=11  && COUNTY CLERK LINE
						REPL l11 WITH  space(7)+[ACCOUNT # ]+act_dlq.pickup_id+[. LATE LETCHER COUNTY SOLID WASTE DEBT PER KRS 109:  ]+PADL(STR(act_dlq.TOTAL_DUE,7,2),7,' ')
					CASE sline=12
						REPL l12 WITH space(7)+[THE LATE SOLID WASTE DEBT ABOVE IS NOT SUBJECT TO DISCOUNT OR PENALTY.]
					CASE sline=13
						REPL l13 WITH STUFF(l13,MA_LEFT_OFFSET+56,7,PADR(STR(VAL(RIGHT(RTRIM(l13),7))+act_dlq.TOTAL_DUE,7,2),7,' '))
					CASE sline=14
						REPL l14 WITH STUFF(l14,MA_LEFT_OFFSET+68,9,PADR(STR(VAL(RIGHT(RTRIM(l14),9))+act_dlq.TOTAL_DUE,9,2),9,' '))
					CASE sline=17
						REPL L17 WITH STUFF(L17,MA_LEFT_OFFSET+68,9,PADR(STR(VAL(RIGHT(RTRIM(L17),9))+act_dlq.TOTAL_DUE,9,2),9,' '))
					CASE sline=18
						REPL L18 WITH STUFF(L18,MA_LEFT_OFFSET+68,9,PADR(STR(VAL(RIGHT(RTRIM(L18),9))+act_dlq.TOTAL_DUE,9,2),9,' '))
					CASE sline=19
						REPL l19 WITH  STUFF(L19,MA_LEFT_OFFSET+68,9,PADR(STR(VAL(RIGHT(RTRIM(L19),9))+act_dlq.TOTAL_DUE,9,2),9,' '))
					CASE sline=20
						REPL L20 WITH  STUFF(l20,MA_LEFT_OFFSET+68,9,PADR(STR(VAL(RIGHT(RTRIM(l20),9))+act_dlq.TOTAL_DUE,9,2),9,' '))
					ENDCASE

**  04 SETUP (trim NOT arm)
*				DO CASE       &&         * case by line
*				CASE sline=1		&& SNAG UNTOUCHED RECORD TO ACT_DLP
*					COPY NEXT 1 TO junk
*					SELE act_dlp
*					APPE FROM junk
*					SELE tax_spl
*				CASE sline=10  && COUNTY CLERK LINE
*					REPL l10 WITH  SPACE(14)+[ACCOUNT # ]+act_dlq.pickup_id+[. LATE LETCHER COUNTY SOLID WASTE DEBT PER KRS 109:  ]+PADL(STR(act_dlq.TOTAL_DUE,7,2),7,' ')
*				CASE sline=11
*					REPL l11 WITH SPACE(14)+[THE LATE SOLID WASTE DEBT ABOVE IS NOT SUBJECT TO DISCOUNT OR PENALTY.]
*				CASE sline=12
*					REPL l12 WITH STUFF(l12,91,7,PADR(STR(VAL(RIGHT(RTRIM(l12),7))+act_dlq.TOTAL_DUE,7,2),7,' '))
*				CASE sline=13
*					REPL l13 WITH STUFF(l13,98,9,PADR(STR(VAL(RIGHT(RTRIM(l13),9))+act_dlq.TOTAL_DUE,9,2),9,' '))
*				CASE sline=16
*					REPL L16 WITH STUFF(L16,98,9,PADR(STR(VAL(RIGHT(RTRIM(L16),9))+act_dlq.TOTAL_DUE,9,2),9,' '))
*				CASE sline=17
*					REPL l17 WITH STUFF(l17,98,9,PADR(STR(VAL(RIGHT(RTRIM(l17),9))+act_dlq.TOTAL_DUE,9,2),9,' '))
*				CASE sline=18
*					REPL l18 WITH  STUFF(l18,98,9,PADR(STR(VAL(RIGHT(RTRIM(l18),9))+act_dlq.TOTAL_DUE,9,2),9,' '))
*				CASE sline=19
*					REPL l19 WITH  STUFF(l19,98,9,PADR(STR(VAL(RIGHT(RTRIM(l19),9))+act_dlq.TOTAL_DUE,9,2),9,' '))
*				ENDCASE

				ENDIF
			ENDFOR
			SKIP
*			? recno()
			IF EOF()
				EXIT
			ENDIF
		ENDFOR
		ON KEY LABEL ESC
		CLOSE DATA
		DO view_set
		deactivate window big_msg
		ACTIVATE SCREEN
		CLEAR
TEXT
	Done Setting SW DLQ's into PVA records.

	BACKUP ACT_DLP.DBF PROMPTLY.  IT CONTAINS THE UNTOUCHED PVA
	BILLS FOR THOSE RECORDS GETTING SOLID WASTE FEES.

ENDTEXT

		SET CONSOLE ON

		RETURN


********************************************************************************
********************************************************************************
	PROCEDURE print_sw_nopva
********************************************************************************
********************************************************************************
		PARAMETER JUST_SWZ
		PRIV sline,sa,sb,sc,sd,se,sf,sg, s_tab, s_noroom
		STORE 1 TO sd
		STORE .F. TO s_noroom
		PRIV lines_per_bill
		STORE 24 TO lines_per_bill
		STORE SPACE(6) TO s_tab
		PRIV MA_LEFT_OFFSET, SHIFT_LEFT
		STORE 30 TO MA_LEFT_OFFSET			&&  WAS 30, SPACE OFFSET FROM LEFT OF LINE FOR TWEAKING THE RIGHT-LEFTNESS
		STORE 20 TO SHIFT_LEFT			&& WAS 14
&& Set these line numbers for your bill style
		PRIV  l_acct, acct_start_col,name_start_col


		STORE [L5] TO l_acct
		STORE 90 TO acct_start_col						&& WAS 105 &&  column positions of the bill parts
		STORE 10 TO name_start_col						&& WAS 25


		CLOSE DATA
		DO view_set

		ACTIVATE SCREEN
		CLEAR
		ACTIVATE WINDOW big_msg
TEXT

		***  Print TRIM Bill SPL File   ***

	This procedure prints Property Tax Bills
	(Ky State TRIM T-TYPE ONLY)
	from the Printer Spool File made during a
	Win32 TRIM bill run.

	Overdue Solid Waste debt will added to
	some records, per the data in ACT_DLQ.

	The spool file was previously imported.


ENDTEXT

		SET PRINTER TO [\temp\TAX_BILL.001]

		USE act_dlq SHARED ORDER TAG name1map IN 0
		SELE act_dlq
		USE ttax2mm ORDER name1map SHARED IN 0
		USE tax_spl SHARED IN 0
		SELE tax_spl
		SET RELATION TO ALLTRIM(name_one)+[ ]+ALLTRIM(map) INTO act_dlq

*		STORE ORDER() TO c_tmp

		SET ORDER TO
		GO BOTTOM
		STORE RECNO()TO end_i
		GO TOP
		SKIP 1
* dummy rec at top
		STOR RECNO() TO start_i

		DO msg2user WITH [ ]
		ACTIVATE WINDOW msg2user
		CLEAR
		ACCE [  Enter the Bill Sequence # to start printing. (Numeric Order)==>] TO start_i
		CLEAR
		ACCE [  Enter the Number of Bills to Print (Enter 99999 to print all) ==>] TO end_i
		CLEAR
		DO msg2user WITH [CLOSE]
*		r_i="goto "+str(start_i)
*		&r_i

		GOTO BOTTOM



		IF VAL(ALLTRIM(RIGHT(ALLTRIM(&l_acct),6)))<VAL(start_i)
			start_i=ALLTRIM(RIGHT(ALLTRIM(&l_acct),6))
		ENDIF

*           GOTO &start_i
		GOTO BOTTOM
		DO WHILE VAL(ALLTRIM(RIGHT(ALLTRIM(&l_acct),6)))>= VAL(start_i)
			SKIP -1
		ENDDO
		SKIP



		sline=0
		sf=start_i+end_i
		ON KEY LABEL ESC EXIT
		SET CONSOLE OFF

* PRINT 3 DUMMIES
		SET PRINT ON
		FOR R_I=1 TO lines_per_bill
			? SPACE(SHIFT_LEFT)+ALLTRIM(STR(R_I))
		ENDFOR
		FOR R_I=1 TO lines_per_bill
			? SPACE(SHIFT_LEFT)+ALLTRIM(STR(R_I))
		ENDFOR
		FOR R_I=1 TO lines_per_bill
			? SPACE(SHIFT_LEFT)+ALLTRIM(STR(R_I))
		ENDFOR
		SET PRINT OFF


*		do while .not. ((eof() ).and.(recno()<=sf ))
		FOR sd=1 TO VAL(end_i)
			noroom=.F.
			FOR sline=1 TO lines_per_bill

				IF JUST_SWZ
					IF (((ALLTRIM(act_dlq.name1map)=ALLTRIM(name_one)+[ ]+ALLTRIM(map))) .AND. (.NOT.(noroom )).AND.(act_dlq.done).AND. (act_dlq.TOTAL_DUE>1))
* WE HAVE A SW HIT

						sa="tax_spl.L"+ALLTRIM(STR(sline))
						SET PRINT ON
						? SUBSTR(STRTRAN(&sa,CHR(0),[]),1,78+MA_LEFT_OFFSET)
*				? &sa
						SET PRINT OFF

					ELSE

						IF (act_dlq.done)
							SET PRINTER TO DEFA
							?
							?
							?
							?
							?
							?
							?
							?
							?
							?  SPACE(SHIFT_LEFT)+[ACCOUNT # ]+act_dlq.pickup_id+[. LATE LETCHER COUNTY SOLID WASTE DEBT PER KRS 109:  ]+PADL(STR(act_dlq.TOTAL_DUE,7,2),7,' ')
							?  SPACE(SHIFT_LEFT)+[THE LATE SOLID WASTE DEBT ABOVE IS NOT SUBJECT TO DISCOUNT OR PENALTY.]
							?  SPACE(75+MA_LEFT_OFFSET)+STR(act_dlq.TOTAL_DUE)
							?
							?
							?  SPACE(75+MA_LEFT_OFFSET)+STR(act_dlq.TOTAL_DUE)
							?
*  ? space(14)+alltrim()    &&     <=================  yikes...not the final working version ...
							? SPACE(SHIFT_LEFT)
							? SPACE(SHIFT_LEFT)
							?
							?
							?
							?
							?
						ENDIF
					ENDIF
				ELSE
					sa="tax_spl.L"+ALLTRIM(STR(sline))
					SET PRINT ON
					? SUBSTR(STRTRAN(&sa,CHR(0),[]),1,78+MA_LEFT_OFFSET)
*				? &sa
					SET PRINT OFF
				ENDIF
			ENDFOR
			SKIP
*			? recno()
			IF EOF()
				EXIT
			ENDIF
		ENDFOR
		ON KEY LABEL ESC
		SET CONSOLE ON

		SET PRINTER TO
		IF yesno([Start Printing \temp\lsw_bill.001 to LPT1 now?  Y/N])
			!COPY \temp\tax_bill.001 lpt1
		ENDIF
		CLEAR
		ACTIVATE SCREEN
		CLEAR
		CLOSE DATA
		DO view_set
		RETURN









********************************************************************************
********************************************************************************
	PROCEDURE print_tax_bills
********************************************************************************
********************************************************************************
		PARAMETER JUST_SWZ
		PRIV sline,sa,sb,sc,sd,se,sf,sg, s_tab, s_noroom,start_ii,end_ii
		STORE 1 TO sd
		PRIV lines_per_bill
		STORE 24 TO lines_per_bill
		STORE SPACE(6) TO s_tab


		PRIV MA_LEFT_OFFSET, SHIFT_LEFT
		STORE 30 TO MA_LEFT_OFFSET			&&  WAS 30, SPACE OFFSET FROM LEFT OF LINE FOR TWEAKING THE RIGHT-LEFTNESS
		STORE 20 TO SHIFT_LEFT			&& WAS 14
&& Set these line numbers for your bill style
		PRIV  l_acct, acct_start_col,name_start_col

		STORE [L5] TO l_acct
		STORE 90 TO acct_start_col						&& WAS 105 &&  column positions of the bill parts
		STORE 10 TO name_start_col						&& WAS 25



		CLOSE DATA

		ACTIVATE SCREEN
		CLEAR

		SET PRINTER TO [\temp\TAX_BILL.001]

		USE tax_spl SHARED IN 0
		SELE tax_spl

		SET ORDER TO
		GO BOTTOM
		STORE RECNO()TO end_i
		GO TOP
		SKIP 1
* dummy rec at top
		STOR RECNO() TO start_i

		DO msg2user WITH [ ]
		ACTIVATE WINDOW msg2user
		CLEAR
		STORE [0] TO start_ii
		ACCE [  Enter the Bill # to start printing. ==>] TO start_ii
		CLEAR
		STORE [0] TO end_ii
		ACCE [  Enter the Number of Bills to Print (Enter 99999 to print all) ==>] TO end_ii
		CLEAR
		DO msg2user WITH [CLOSE]

		start_i=VAL(start_ii)
		end_i=VAL(end_ii)


		GOTO start_i
		sline=0
		sf=start_i+end_i
		ON KEY LABEL ESC EXIT
		SET CONSOLE OFF

* PRINT 3 DUMMIES
		SET PRINT ON
		FOR R_I=1 TO lines_per_bill
			? SPACE(SHIFT_LEFT)+ALLTRIM(STR(R_I))
		ENDFOR
		FOR R_I=1 TO lines_per_bill
			? SPACE(SHIFT_LEFT)+ALLTRIM(STR(R_I))
		ENDFOR
		FOR R_I=1 TO lines_per_bill
			? SPACE(SHIFT_LEFT)+ALLTRIM(STR(R_I))
		ENDFOR
		SET PRINT OFF



		FOR sd=1 TO end_i
			FOR sline=1 TO lines_per_bill
				sa="tax_spl.L"+ALLTRIM(STR(sline))
				SET PRINT ON
				? SPACE(SHIFT_LEFT)+LEFT(&sa,78+MA_LEFT_OFFSET)
				SET PRINT OFF

			ENDFOR
			SKIP
*			? recno()
			IF EOF()
				EXIT
			ENDIF
		ENDFOR

		ON KEY LABEL ESC
		SET CONSOLE ON

		SET PRINTER TO
		IF yesno([Start Printing \temp\lsw_bill.001 to LPT1 now?  Y/N])
			!COPY \temp\tax_bill.001 lpt1
		ENDIF

		CLOSE DATA
		DO view_set
		RETURN








********************************************************************************
********************************************************************************
	PROCEDURE  whi_late_fee	&& Late Charges Applied to all overdue  customers
********************************************************************************
********************************************************************************
&& run this from a menu command button to add late fees to customer records.


&& if an inactive customer has a past due of more than 12.50 (current m rate) & is reactiveated in the first two weeks of the
&& month- they will get a late charge ??
		PRIVATE MONTH,c,r,A,b,due,YEAR,distrix,m_t,m_r, ok2go,w_a,w_b,w_c,w_d,w_e,w_flag,w_m, w_res_rate
		PRIVATE cp,ct,t_t,p_p
		PRIVATE mnth_tot, mnth_res, mnth_com, mnth_ina,mth_allc,mth_resc,mth_inac,mth_comc
		PRIVATE type_of_run, jjuunnkk,w_qr
		STORE [ ] TO type_of_run
		STORE [ ] TO jjuunnkk
		STORE 1.0 TO w_qr  &&1=monthly, 3=quarterly
		STORE [          ] TO MONTH
		STORE [    ] TO YEAR
		STORE [           ] TO due
		STORE [012345] TO distrix
		STORE [B] TO c
		STORE [0] TO bill_num
		STORE [M] TO m_t
		STORE 1.000 TO m_r  && this has to be tweeked for counties that hav different interest rates for C vs R
		STORE .F. TO ok2go

&&		SELE ACT_CODE
&&		        SEEK [R]
&& store act_code.price to w_res_rate  && snag the regular residential monthly charge as $nnnnnn.nn
		STORE mth_rate_r TO w_res_rate  && snag the regular residential monthly charge as $nnnnnn.nn
&&			SEEK [L]  && snag the montly late fee %age
&&			IF FOUND()
&& STORE act_code.price TO w_d
		STORE late_rate_res TO w_d
		CLOSE DATA
		CLEAR
		? [**  Apply Early Payment Discount  **]
		? [    This procedure applies discounts for customers that have paid their most ]
		? [first bill within one month of our mailing them.  They must have paid 98% or more ]
		? [of their tax balance to receive the discount.]
		? [This is a one time discount.]
		? [    Caution!  There are few safeguards on the discounts.  Do NOT run this  twice]
		? [or you will overdiscount the customer. ]
		? [    Use the Utility Menu to A)dd or E)dit Services to change the Late Rate Charge.]
		? [ It is listed in the PRICE column as a percentile, i.e: 2.0=2.0% of the bill]
		? [ The current rate is:]+STR(w_d,6,2)

		STORE [C] TO type_of_run

		DO view_set
		STORE 0 TO w_m
		SELE act_cust            &&  of the CODE "M" item.
		GO TOP

		IF yesno ([Proceed to apply discounts ? ])
			CLEAR
TEXT


 				        PLEASE WAIT:  Discounts Are Being Applied


ENDTEXT
			SET STATUS BAR OFF
			SET TALK OFF
			DO reindxm       && reindex prior to accounting
			DO calc_balance  && computes the current account balance per customer
			SELE act_main
			SET RELA OFF INTO act_cust

			SELE act_cust
			SET ORDER TO cust_type
			SET FILTER TO (cust_type$type_of_run)  &&C
			STORE 1 TO w_qr		&&

			GOTO TOP
			DO WHILE .NOT. EOF()
* APPLY discount TO CURRENT CUSTOMER  (INVOICE COMES NEXT).
				STORE act_cust.pickup_id TO c_tmp
&& harvest the dollars paid this month from the customer's record


				w_m=act_cust.totl_amt  &&  City of whitesburg has 1 cust per property, so that property's balance is what they've
&& were originally billed less whatever's been paid in first month

				IF (act_cust.totl_amt>0)   && they haven't paid in full
					REPLACE rev_date WITH DATE() && assign the latest billing date to the cust record
&&    M A K E   I N V O I C E
					SELE act_main
					ar_i=add_1([IN])
					UNLOCK ALL
					REPL invoice WITH ar_i
					REPL srvc_dat WITH DATE()
					REPL rev_date WITH DATE()  && billing date
					REPL pickup_id WITH act_cust.pickup_id
					REPL cust_id WITH act_cust.pickup_id  &&  wh 7/03
					REPL lname WITH act_cust->lname
					REPL fname WITH act_cust->fname
					REPL INITIAL WITH act_cust->INITIAL
					REPL Phone  WITH act_cust->Phone
					REPL address WITH act_cust->address
					REPL address2 WITH act_cust->address2
					REPL city WITH act_cust->city
					REPL zip WITH act_cust->zip
					REPL state WITH act_cust->state
					REPL dob WITH act_cust->dob
					UNLOCK ALL
*CREATE NEW RECORD IN SCR
					SELE act_scr
					APPEND BLANK
					REPLACE invoice WITH act_main.invoice
					REPL act_scr->c1 WITH 1
					REPL act_scr->i1 WITH [Missed Discount Chg]
					REPL act_scr->code1 WITH [L]

					REPL act_scr->p1 WITH (w_m*(0.01*w_d))    &&charge cust % of balance
					UNLOCK ALL
					DO scr_subtot  &&build service strings and invoice total
				ENDIF  && w_flag--was [CcRc] with past debt
				UNLOCK ALL
				SELE act_cust
				SKIP  && next
			ENDDO  &&all customers
			CLOSE DATA

			DO view_set
			DO calc_balance  &&apply the new charges to all accounts
			CLEAR
			?[ Discounts have been applied.]
			? []
			WAIT
			CLEAR

		ENDIF

&&		ELSE  &&NOT FOUND [L]
&&			?[ERROR:  Late Rate not found. Please set this value.]
&&			?[ Use the Utility Menu to A)dd or E)dit Services to change the rate. ]
&&			?[ It is listed in the PRICE column as a percentile:  i.e.. 0.83=0.83%/month (=10%/yr)]
&&			WAIT
&&			Clear
&&		ENDIF
		CLOSE DATA
		DO view_set
		CLEAR
		RETURN




********************************************************************************
********************************************************************************
	PROCEDURE whi_tax_bill
********************************************************************************
********************************************************************************
		PRIVATE hokay, iz_restart, iz_once,iz_temp, m2_temp, cp_30_temp, cs_30_temp, zz_tt, city_rate, citynrate,ssa,ssb,ssc
		STORE [01/06/2000] TO hokay
		STORE .F. TO iz_restart
		STORE .F. TO iz_once
		STORE [        ] TO iz_temp

		CLEAR
TEXT
                             Welcome to the Tax Bill Printing Routine.

   This will print Tax Bills for all customers  that  owe
   more than one dollar,  showing all invoices (tax line items) for the given
   account. The statement presents the current balance  as due.  Enter
   tax reciepts as they are payed.  Enter tax bills (invoices)
   ONLY AFTER the regular Generate Bill step and DO NOT run the
   Generate  Bill step again. Print the bills BEFORE the end of the
    month.

    Please prepare the default printer.

ENDTEXT


&& pick billingoption
		CLOSE DATA
		SELE 1
		USE act_cust ORDER TAG pickup_id
		SELE 2
		USE act_main ORDER TAG pickup_id
*  SELE 4
*  USE act_scr ORDER TAG invoice
		SELE 3
		USE act_pay ORDER TAG pic_id_i
		SELE 4
		USE tax_cityrates
		GOTO TOP
		STORE STR(100*tax_cityrates.re_res,4,2) TO city_rate
		STORE tax_cityrates.re_res TO citynrate
		USE

****
		SELE act_cust
		SET RELATION TO pickup_id INTO act_main
		SELE act_main
		SET RELA TO pickup_id INTO act_pay  && relate pay to invoice to customer
*  SET RELA TO invoice INTO act_scr ADDITIVE
***
		SELE act_cust
		GOTO TOP
		iz_temp=[                ]
		ACCE [R)estart partial run, O)ne Customer only, Q)uit, or Press <Enter> to proceed.  ==>] TO iz_temp
		IF (LEN(ALLTRIM(iz_temp))>0)
			IF ([R] $ ALLTRIM(UPPER(iz_temp)))
				ACCE [Enter Customer PickupID# to Restart From ==>] TO iz_temp
				STORE .T. TO iz_restart
				SEEK ALLTRIM(iz_temp)
				BROW LAST TITLE [Select Customer to Restart From.  <ESC> to Continue.]
			ELSE
				IF ([O] $ ALLTRIM(UPPER(iz_temp)))
					ACCE [Enter Customer PickupID# to Print ==>] TO iz_temp
					STORE .T. TO iz_once
					SEEK ALLTRIM(iz_temp)
					BROW LAST TITLE [Select Customer to Print.  <ESC> to Continue.]
				ELSE
					IF ([Q] $ ALLTRIM(UPPER(iz_temp)))
						GOTO BOTTOM
						SKIP
					ENDIF
				ENDIF
			ENDIF
		ENDIF
&&**EOF billing option********************

		ACTIVATE SCREEN
		? [Preparing Tax Bills... Please Wait]
		DO WHILE .NOT. EOF()
			IF act_cust.cust_type$[cC]
				STORE act_cust.pickup_id TO c_tmp  && c_tmp is pickup ID
				SELECT act_main

&& compute debt
				STORE 0 TO cs_n
				STORE 0 TO ssa
				STORE 0 TO ssb
				STORE 0 TO ssc
				SEEK c_tmp
				DO WHILE (pickup_id=c_tmp) .AND. ( .NOT. EOF())
					cs_n=cs_n+total_amt
					IF (num_srvcs>0)
						ssa=ALLTRIM(coun_list)  			&& snag assesment string complete with plus signs
						ssc=RAT([+],ssa)-1
						ssa=LEFT(ssa,ssc)					&& do a magic macro * sum assesments from string
						ssa=[ssc=]+ssa
						&ssa
						ssb=ssb + ssc			&& sum up the assesments
						REPL cust_ssn WITH STR(ssb,14,2)	&& assign the assesment sum to act_main.cust_ssn
						REPL id_provid WITH LEFT(ALLTRIM(srvc_list),1)  &&  tag for whether real/tang etc
					ENDIF
					SKIP
				ENDDO
				SELE act_cust  && reset relations, & go back to starting act_main record
				SELE act_main

&& compute payments
				SELE act_pay
				STORE 0. TO cp_n
				SEEK c_tmp
				DO WHILE (id_of_payr=c_tmp) .AND. ( .NOT. EOF())
					cp_n=cp_n+amt_paid
					SKIP
				ENDDO
				SELE act_cust  && reset relations, & go back to starting act_main record

&& set the totals to the act_cust rec
				UNLOCK ALL  && FREE NETWORK LOCKS
				SELE act_cust  && reset act_main by relation
				REPLACE act_cust.totl_amt WITH cs_n-cp_n, act_cust.last_calc WITH DATE()  && assign the billed amount ot the customer record

				SET SKIP TO act_main  && 1:many from cust to invoice
&& do all invoices for a customer
				SELE act_main  &&start invoice processing
				IF (act_cust.totl_amt>1.00)
					REPO FORM act_wbil ALL FOR( (act_main.pickup_id=act_cust.pickup_id)  ) TO PRINTER
				ENDIF
				SELE act_cust
				SET SKIP TO
			ENDIF

			IF (iz_once)  && bag out of printing
				GOTO BOTTOM
			ENDIF

			SKIP		&& do next commercial cust til eof
		ENDDO
		CLOSE DATA
		DO view_set
		ACTIVATE SCREEN
		CLEAR
		RETURN



**********************************************************************************
**********************************************************************************
	PROCEDURE whi_delinquent_bill
**********************************************************************************
**********************************************************************************
		PRIVATE hokay, iz_restart, iz_once,iz_temp, m2_temp, cp_30_temp, cs_30_temp, zz_tt
		STORE [01/06/2000] TO hokay
		STORE .F. TO iz_restart
		STORE .F. TO iz_once
		STORE [        ] TO iz_temp

		CLEAR
TEXT
                             Welcome to the Delinquent Bill Printing Routine.

   This will print  Bills for all  customers  that owe more than one dollar.
   The statement presents the current balance  as due.   Enter
   receipts as they are payed.  Enter bills (invoices) ONLY AFTER
   the monthly Levy Finance Charge step. Print the bills BEFORE the end of the
   month.

    Please prepare the default printer.

ENDTEXT

		ACCE ([Enter month as MM/01/YYYY, ie:  12/01/2003 ==>  ]) TO hokay
		m2run = CTOD(ALLTRIM(hokay))
		? [Printing Monthly Statement for ],DTOC(m2run)
		?

&& pick billingoption
		CLOSE DATA
		SELE 1
		USE act_cust ORDER TAG pickup_id
		SELE 2
		USE act_main ORDER TAG pickup_id
*  SELE 4
*  USE act_scr ORDER TAG invoice
		SELE 3
		USE act_pay ORDER TAG pic_id_i
****
		SELE act_cust
		SET RELATION TO pickup_id INTO act_main
		SELE act_main
		SET RELA TO pickup_id INTO act_pay  && relate pay to invoice to customer
*  SET RELA TO invoice INTO act_scr ADDITIVE
***
		SELE act_cust
		GOTO TOP
		iz_temp=[                ]
		ACCE [R)estart partial run, O)ne Customer only, Q)uit, or Press <Enter> to proceed.  ==>] TO iz_temp
		IF (LEN(ALLTRIM(iz_temp))>0)
			IF ([R] $ ALLTRIM(UPPER(iz_temp)))
				ACCE [Enter Customer PickupID# to Restart From ==>] TO iz_temp
				STORE .T. TO iz_restart
				SEEK ALLTRIM(iz_temp)
				BROW LAST TITLE [Select Customer to Restart From.  <ESC> to Continue.]
			ELSE
				IF ([O] $ ALLTRIM(UPPER(iz_temp)))
					ACCE [Enter Customer PickupID# to Print ==>] TO iz_temp
					STORE .T. TO iz_once
					SEEK ALLTRIM(iz_temp)
					BROW LAST TITLE [Select Customer to Print.  <ESC> to Continue.]
				ELSE
					IF ([Q] $ ALLTRIM(UPPER(iz_temp)))
						GOTO BOTTOM
						SKIP
					ENDIF
				ENDIF
			ENDIF
		ENDIF
&&**EOF billing option********************


		ACTIVATE SCREEN
		? [Preparing  Commercial Bills... Please Wait]
		DO WHILE .NOT. EOF()
			IF act_cust.cust_type$[cC]

				STORE act_cust.pickup_id TO c_tmp  && c_tmp is pickup ID

				SELECT act_main

*  WSH 09/04/2004	&& from calc_one-faster
				STORE 0 TO cs_n
				SEEK c_tmp
				DO WHILE (pickup_id=c_tmp) .AND. ( .NOT. EOF())
					cs_n=cs_n+total_amt
					SKIP
				ENDDO
				SELE act_cust  && reset relations, & go back to starting act_main record
				SELE act_main

*  WSH 09/04/2004	&& from calc_one-faster				&&	SUM total_amt TO cs_n ALL FOR pickup_id=c_tmp  && sum all invoiced debts
*  WSH 09/04/2004
				STORE 0.0 TO cs_30
				SEEK c_tmp
				DO WHILE (pickup_id=c_tmp) .AND. ( .NOT. EOF())   && found customer, now sum invoices for month
					IF ( BETWEEN( act_main.srvc_dat,m2run,GOMONTH(m2run,1) ))
						cs_30=cs_30+total_amt
					ENDIF
					SKIP
				ENDDO
				SELE act_cust  && reset relations, & go back to starting act_main record
				SELE act_main
*  WSH 09/04/2004	&& from calc_one-faster	&& SUM total_amt TO cs_30 ALL FOR ((pickup_id=c_tmp) .and. between( act_main.srvc_dat,M2Run,gomonth(M2Run,1) ) )   && as above, but only for invoices dated  in statement month
				STORE cs_30 TO cs_30_temp  && hold on to it, it's been getting lost
*  WSH 09/04/2004
*  WSH 09/04/2004 &&				GOTO top
*  WSH 09/04/2004 &&				SELE act_pay
*  WSH 09/04/2004	&& from calc_one-faster
				SELE act_pay
				STORE 0. TO cp_n
				SEEK c_tmp
				DO WHILE (id_of_payr=c_tmp) .AND. ( .NOT. EOF())
					cp_n=cp_n+amt_paid
					SKIP
				ENDDO
				SELE act_cust  && reset relations, & go back to starting act_main record
*  WSH 09/04/2004	&& from calc_one-faster			&& 	SUM amt_paid TO cp_n ALL FOR id_of_payr=c_tmp  && total all payments ever made
*  WSH 09/04/2004
				SELE act_pay
				STORE 0. TO cp_30
				SEEK c_tmp
				DO WHILE (id_of_payr=c_tmp) .AND. ( .NOT. EOF())
					IF  (BETWEEN( act_pay.date_paid,m2run,GOMONTH(m2run,1) ) )
						cp_30=cp_30+amt_paid
					ENDIF
					SKIP
				ENDDO
*  WSH 09/04/2004	&& from calc_one-faster			&&SUM amt_paid TO cp_30 ALL FOR ((id_of_payr=c_tmp) .and. (between( ACT_PAY.DATE_PAID,M2Run,gomonth(M2Run,1) ) ) ) && as above, but for statment month
				STORE cp_30 TO cp_30_temp
*  WSH 09/04/2004
&& set the totals to the act_cust rec
				UNLOCK ALL  && FREE NETWORK LOCKS
				SELE act_cust  && reset act_main by relation
				REPLACE act_cust.totl_amt WITH cs_n-cp_n, act_cust.last_calc WITH DATE()  && assign the billed amount ot the customer record
				m2_temp=m2run		&&snag the m2run  *************  WSH 09/02/04 ************
				SET SKIP TO act_main  && 1:many from cust to invoice
&& do all invoices for a customer

				SELE act_main  &&start invoice processing
&&				SET filter to ((ALLTRIM(act_main.pickup_id)=ALLTRIM(act_cust.pickup_id)) .and. (between( act_main.srvc_dat,M2Run,gomonth(M2Run,1) ) ) )


&&  				IF (.not. eof()) .And. (act_cust.totl_amt>1.00)
&&				IF (act_cust.totl_amt>1.00)
				IF (act_cust.totl_amt>1.00)
* wsh 09/04/2004 dumb fix for cp_30 vaporz
					STORE cp_30_temp TO cp_30
					STORE cs_30_temp TO cs_30
* wsh 09/04/2004 dumb fix for cp_30 vaporz
					REPO FORM act_cbil ALL FOR( (act_main.pickup_id=act_cust.pickup_id)  ) TO PRINTER
				ENDIF
&&				ENDIF
&&				M2Run=m2_temp		&&restore the m2run  *************  WSH 09/02/04 ************

&&				SET filter to  && release the filter on act_main
				SELE act_cust
				SET SKIP TO
			ENDIF

			IF (iz_once)  && bag out of printing
				GOTO BOTTOM
			ENDIF

			SKIP		&& do next commercial cust til eof
		ENDDO
		CLOSE DATA
		DO view_set
		ACTIVATE SCREEN
		CLEAR
		RETURN


******==========================================================*******
	PROCEDURE Import_ARM
******==========================================================*******
		DIMENSION i_htype[9]
		STORE [No Homestead Exemption] TO i_htype[1]
		STORE [Homestead Exemption:  RD ] TO i_htype[2]
		STORE [Homestead Exemption:  RR ] TO i_htype[3]
		STORE [Homestead Exemption:  FD ] TO i_htype[4]
		STORE [homestead Exemption:  FR ] TO i_htype[5]
		STORE [Homestead Exemption:  CD] TO i_htype[6]
		STORE [Homestead Exemption:  CR] TO i_htype[7]
		STORE [Homestead Exemption:  MD] TO i_htype[8]
		STORE [Homestead Exemption:  MR] TO i_htype[9]

* wsh 10/15/05
		RELEASE WINDOW FORM1
		CLOSE DATA
		ACTIVATE SCREEN
		CLEAR
TEXT
*
*
*   This routine starts the annual procedure. It imports ARM data
*   from the LI Smith PVA accounts file ARM_Complete.mdb
*   and prepares it for optional address correction by BCC's Mailman.
*
*   You must have the tables exported from ARM_Complete.mdb
*   as described in the manual.  It's easiest to use Microsoft Access
*   to export the tblAccount.dbf and tblassessment.dbf files from the
*   ARM_Complete.mdb file, but you can use MDB tools or kexi
*   under Linux to the same end.
*
*   Be sure both  tblAccount.dbf and tblassessment.dbf  are in
*   current directory before you proceed.
*
*   If you wish to use MM to correct the USPS addresses,
*   copy the file  ttax2mm.dbf  to the
*   MailMan  Directory once the procedure completes.
*   Encode & Export the addresses there.  You must then run
*   the Import MailMan Files option.
*
*   If you choose to not further correct the addresses,
*   you will be ready for the second step.
ENDTEXT
		IF (yesno([Ready to Import LI Smith/ARM Data from PVA tblAccounts?]))
			USE tblaccount IN 0 EXCL
			USE TBLASSESSMENT IN 0 EXCL
			SELE tblaccount
			INDE ON account_id TAG account_id
			SELE TBLASSESSMENT
			SET RELA TO account_id INTO tblaccount
&& now we can span the assesment file & have the related account id & names come too.

			SET CONFIRM OFF
			SET SAFETY OFF
&& capture data from ARM Certified ready to print MDB tbl files
			USE trim_tax.DBF IN 0 EXCLUSIVE
			SELE trim_tax
			ZAP
*			APPE FROM o_tax___.SDF TYPE SDF
			SELE TBLASSESSMENT
			GOTO TOP
			DO WHILE .NOT. EOF()
				SELE trim_tax
				APPE BLANK
				REPLACE ;
					prop_num WITH tblaccount.prop_num,;
					map_num WITH tblaccount.map,;
					last_sale WITH [],;
					loc_str_nm WITH ALLTRIM(tblaccount.proploc_st),;
					loc_str_no WITH ALLTRIM(STR(tblaccount.proploc_nu,14,0)),;
					name_one WITH ALLTRIM(tblaccount.name1),;
					name_two WITH ALLTRIM(tblaccount.name2),;
					mail_add WITH tblaccount.mail_addre,;
					cty_st_zip WITH tblaccount.c_s_zip,;
					prev_owner WITH ALLTRIM(tblaccount.prev_owner),;
					deed_num WITH [],;
					mort_num WITH [],;
					tax_distr WITH tblaccount.tax_dist,;
					date_acq WITH DTOC(tblaccount.date_sale),;
					inspect_by WITH tblaccount.inspected_,;
					date_insp WITH tblaccount.date_inspe,;
					DESCRIPT WITH tblaccount.DESC,;
					re_res WITH TBLASSESSMENT.res,;
					re_fcv WITH TBLASSESSMENT.frm_fcv,;
					re_ftv WITH TBLASSESSMENT.frm_txv,;
					re_fres WITH TBLASSESSMENT.frm_res,;
					ac_farm WITH TBLASSESSMENT.frm_ac,;
					ac_fire WITH TBLASSESSMENT.fire_ac,;
					re_com WITH TBLASSESSMENT.com,;
					re_mob WITH TBLASSESSMENT.mob,;
					U_1 WITH 0,;
					hsteadcode WITH TBLASSESSMENT.HOMESTEAD_,; 	&& this needs to either get expanded to hold $ value of hstead, or do a lookup to htead$ from this val
				ta_oil WITH TBLASSESSMENT.oil_min,;
					ta_unc WITH TBLASSESSMENT.umc,;
					ta_lea WITH TBLASSESSMENT.lshold,;
					ta_was WITH TBLASSESSMENT.wtrshed,;
					wa_acr WITH TBLASSESSMENT.wtr_ac,;
					ta_45p WITH TBLASSESSMENT.tang_45,;
					in_15p_so WITH TBLASSESSMENT.tang_15,;
					ta_inv WITH TBLASSESSMENT.mer_inv,;
					ta_fin WITH TBLASSESSMENT.mfg_fin,;
					ta_gif_so WITH TBLASSESSMENT.mfg_gip,;
					ta_prs WITH TBLASSESSMENT.pub_wh_rs,;
					ta_ptr WITH TBLASSESSMENT.pub_wh_tr,;
					ta_ato WITH TBLASSESSMENT.ag_tobac,;
					ta_aot WITH TBLASSESSMENT.ag_other,;
					ta_amf WITH TBLASSESSMENT.ag_mfg,;
					ta_bai WITH TBLASSESSMENT.boats_air,;
					ta_vin_so WITH TBLASSESSMENT.vehic_inv,;
					ta_001 WITH TBLASSESSMENT.tang_001,;
					ta_oth45 WITH TBLASSESSMENT.other_45,;
					ta_rec WITH TBLASSESSMENT.rec_mech,;
					ta_air WITH TBLASSESSMENT.air_nc,;
					in_25p_so WITH TBLASSESSMENT.int_25,;
					in_015p_so WITH TBLASSESSMENT.int_015,;
					in_001p_so WITH TBLASSESSMENT.int_001
				IF hsteadcode=0
					REPL hsteadcode WITH 1	&& FIX BAD DATA
				ENDIF
				SELE TBLASSESSMENT
				SKIP
			ENDDO

&& STRIP LEADING 0 FROM DISTRICT  && WSH 9/28/05
			SELE trim_tax
			SET FILTER TO [0]=LEFT(ALLTRIM(tax_distr),1)
			REPL ALL tax_distr WITH SUBSTR(ALLTRIM(tax_distr),2,1)
			SET FILTER TO

			CLOSE DATA
&& dupe ARM data to mail man compatible structure, then fix USPS address'
			USE  ttax2mm.DBF IN 0 EXCLUSIVE
			SELE ttax2mm
			ZAP
			APPE FROM trim_tax

			DO  fix_city_st_zip
&& assert TRIM data to ACT fields
&& use party for homestead
			REPLACE ALL  pickup_id WITH [],;
				compound WITH PADL(ALLTRIM(STR(RECNO())),9,[0]),;
				account WITH ALLTRIM( acct_num),;
				address   WITH ALLTRIM( mm_name_2),;
				address2 WITH ALLTRIM( mail_add),;
				lname WITH ALLTRIM( mm_name_1),;
				lnamefname WITH ALLTRIM( mm_name_1),;
				district WITH ALLTRIM(tax_distr),;
				city WITH ALLTRIM( mm_city),;
				zip 	WITH ALLTRIM( mm_zip),;
				state 	WITH ALLTRIM( mm_state),;
				map WITH ALLTRIM(  map_num),;
				party WITH ALLTRIM(hsteadcode) ,;
				comments WITH ;
				[|  DESC.:| ]+ALLTRIM( DESCRIPT);
				+[| Farm Ac.: ] +ALLTRIM( ac_farm);
				+[| Fire Ac. : ]+ALLTRIM( ac_fire);
				+[| Watershed Ac. : ]+ALLTRIM( wa_acr);
				+[|  ]+ALLTRIM(i_htype[val(party)]);  				&&  WSH party type homestead
			+[| Prop.: ] +ALLTRIM( prop_num);
				+[| Rec_id. : ]+ALLTRIM( rec_id),;
				street  WITH ALLTRIM( STR(VAL(loc_str_no),5))+[  ]+ALLTRIM( loc_str_nm),;
				SOURCE WITH [T]
*

&& fix the fname lname order
			IF yesno([Fix backwards names in addresses for all but TANG types?  Say NO to Import TRIM records "as is", if you want to look up from past years records, for example ])
				REPL   lname WITH ;
					ALLTRIM(LEFT( ALLTRIM(lnamefname),;
					AT([ ],ALLTRIM(lnamefname))) );
					ALL FOR (;
					(  .NOT. ( [TANG]$ map ) ).AND.;
					(.NOT.([ TRUST]$  lnamefname)).AND.;
					(.NOT.([ LLC]$  lnamefname)).AND.;
					(.NOT.([ REALTY ]$  lnamefname)).AND.;
					(.NOT.([ BANK]$  lnamefname)).AND.;
					(.NOT.([ CO]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ LTD]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ INC]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ BANK OF WHITESBURG]$  lnamefname)).AND.;
					(.NOT.([ ENTERPRISE]$  lnamefname)).AND.;
					(.NOT.([ CORP]$  lnamefname)).AND.;
					(.NOT.([ HOUSING]$  lnamefname)).AND.;
					(.NOT.([ STORE]$  lnamefname));
					)	  && it appears that the TANG names are rightly ordered
				REPL  fname WITH ALLTRIM(	SUBSTR ( 	ALLTRIM(lnamefname), AT( [ ], ALLTRIM(lnamefname)   )   ) 	   );
					ALL FOR (;
					(  .NOT. ( [TANG]$ map ) ).AND.;
					(.NOT.([ TRUST]$  lnamefname)).AND.;
					(.NOT.([ LLC]$  lnamefname)).AND.;
					(.NOT.([ REALTY ]$  lnamefname)).AND.;
					(.NOT.([ BANK]$  lnamefname)).AND.;
					(.NOT.([ CO]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ LTD]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ INC]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ BANK OF WHITESBURG]$  lnamefname)).AND.;
					(.NOT.([ ENTERPRISE]$  lnamefname)).AND.;
					(.NOT.([ CORP]$  lnamefname)).AND.;
					(.NOT.([ HOUSING]$  lnamefname)).AND.;
					(.NOT.([ STORE]$  lnamefname));
					)

&& exclude swapping for TANG, INTANG, LLC's and TRUSTs, still some swapping wrong.
&&				REPL ALL  lnamefname WITH ALLTRIM(lname)+[ ]+ALLTRIM(fname) FOR (.NOT.([TANG]$ map))
			ENDIF



			CLEAR 	&& make MM xfer file
			SELE ttax2mm
			GOTO TOP
*			? [eo import_trim...next tax file]
			COPY  TO wrk_tax.DBF FIELDS compound, acct_num, fname,lname ,address,address2,city,state,zip ALL
*		SELE tbill2mm
*		GOTO TOP
*			? [nxt bill file]
*		COPY  TO wrk_bill.DBF FIELDS compound, acct_num,  fname,lname ,address,address2,city,state,zip ALL
TEXT
**********  Import LI Smith/ARM Files from PVA   ************
*
*
*   This routine has finished.
*
*   If you wish to use MM to correct the USPS addresses,
*   copy the files WRK_TAX.DBF to the
*   MailMan  Directory.. Encode the addresses there.
*   Copy the corrected file back to the ACT directory, then
*   use the Import MM Files option on the MM corrected data.
*
*   If you choose to not correct the USPS addresses,
*   proceed directly to the TRIM/TAXBASE menu  (above)
*   and RUN the UPDATE CUSTOMER and UPDATE INVOICE.
*   options.
*
*   Again, You may run Mailman first, but you
*   must run the UPDATE steps to complete the import from TRIM/ARM.
**************************************************************

ENDTEXT
			STORE [] TO aq
			ACCE ([Press Enter to Continue]) TO aq

		ENDIF
		CLEAR
		CLOSE DATA
		DO view_set
		RETURN



******==========================================================*******
	PROCEDURE import_trim
******==========================================================*******
* wsh 9/19/04
		PRIV izdos,aq
		DIMENSION i_htype[9]
		STORE [No Homestead Exemption] TO i_htype[1]
		STORE [Homestead Exemption:  RD ] TO i_htype[2]
		STORE [Homestead Exemption:  RR ] TO i_htype[3]
		STORE [Homestead Exemption:  FD ] TO i_htype[4]
		STORE [homestead Exemption:  FR ] TO i_htype[5]
		STORE [Homestead Exemption:  CD] TO i_htype[6]
		STORE [Homestead Exemption:  CR] TO i_htype[7]
		STORE [Homestead Exemption:  MD] TO i_htype[8]
		STORE [Homestead Exemption:  MR] TO i_htype[9]

		STORE .T. TO izdos
		CLEAR
TEXT
*****************  Import TRIM O Files   ****************
*
*
*   This routine starts the annual routine.  It imports TRIM data
*   and prepares it for optional address correction by BCC's Mailman.
*
*   You must have a copy of O-TAX___.DAT in the
*  current directory before you proceed.
*
*   If you wish to use MM to correct the USPS addresses,
*   copy the file  ttax2mm.dbf  to the
*   MailMan  Directory once the procedure completes.
*   Encode & Export the addresses there.  You must then run
*   the Import MailMan Files option.
*
*   If you choose to not further correct the addresses,
*   you will be ready for the second step.
*
ENDTEXT

*   Run Trim_SDF_In  in the same dir with TRIM's "O" files
*   and TRIM_O_TAX2CSV.pl and TRIM_O_BILL2CSV.pl.  Run
*   the Perl scripts first, then Trim_SDF_In
*   It processes the output of the Perl routine
*   TRIM_O_TAX2SDF.pl
*   (They prep TRIM's   O-TAX___.DAT)
*
*NB:    trim_tax.dbf is an SDF map to the TRIM
* records.  Don't mess with it unless TRIM changes structure

		IF (yesno([Import TRIM Data?]))
&&			IF (yesno([Run Prep routines?]))
			ON ERROR
			STORE .T. TO izdos
			ON ERROR STORE .F. TO izdos
&&			RUN perl trim_o_bill_dat2sdf.pl
			RUN perl  trim_o_tax_dat2sdf.pl
* | * ON ERROR DO syserror WITH LINENO()
			IF (.NOT. izdos )
				IF (yesno([PREP ROUTINES FAILED!  Run trim_o_bill_dat2sdf.pl and  trim_o_tax_dat2sdf.pl manually and then proceed.  SDFs Ready?]))
&& wait while user hand preps sdf's
				ENDIF
			ENDIF

&&			ENDIF
			SET CONFIRM OFF
			SET SAFETY OFF
			USE
&& capture data from TRIM Certified ready to print DAT files

			SELECT 11
			USE trim_tax.DBF  EXCLUSIVE
			ZAP
			APPE FROM o_tax___.SDF TYPE SDF

*		SELECT 12
*		USE trim_bill.DBF  EXCLUSIVE
*		ZAP
*		APPE FROM o-bill__.SDF TYPE SDF

			CLOSE DATA

&& dupe TRIM data to mail man compatible structure, then fix USPS address'
			SELECT 13
			USE  ttax2mm.DBF  EXCLUSIVE
			ZAP
			APPE FROM trim_tax
			DO  fix_city_st_zip
&& assert TRIM data to ACT fields
&& use party for homestead
			REPLACE ALL  pickup_id WITH [],;
				compound WITH PADL(ALLTRIM(STR(RECNO())),9,[0]),;
				account WITH ALLTRIM( acct_num),;
				address   WITH ALLTRIM( mm_name_2),;
				address2 WITH ALLTRIM( mail_add),;
				lname WITH ALLTRIM( mm_name_1),;
				lnamefname WITH ALLTRIM( mm_name_1),;
				district WITH ALLTRIM( tax_distr),;
				city WITH ALLTRIM( mm_city),;
				zip 	WITH ALLTRIM( mm_zip),;
				state 	WITH ALLTRIM( mm_state),;
				map WITH ALLTRIM(  map_num),;
				party WITH ALLTRIM( hsteadcode) ,;
				comments WITH ;
				[|  DESC.:| ]+ALLTRIM( DESCRIPT);
				+[| Farm Ac.: ] +ALLTRIM( ac_farm);
				+[| Fire Ac. : ]+ALLTRIM( ac_fire);
				+[| Watershed Ac. : ]+ALLTRIM( wa_acr);
				+[|  ]+ALLTRIM(i_htype[val(party)]);  				&&  WSH party type homestead
			+[| Prop.: ] +ALLTRIM( prop_num);
				+[| Rec_id. : ]+ALLTRIM( rec_id),;
				street  WITH ALLTRIM( STR(VAL(loc_str_no),5))+[  ]+ALLTRIM( loc_str_nm),;
				SOURCE WITH [T]
*

&& fix the fname lname order
			IF yesno([Fix backwards names in addresses for all but TANG types?  Say NO to Import TRIM records "as is", if you want to look up from past years records, for example ])
				REPL   lname WITH ;
					ALLTRIM(LEFT( ALLTRIM(lnamefname),;
					AT([ ],ALLTRIM(lnamefname))) );
					ALL FOR (;
					(  .NOT. ( [TANG]$ map ) ).AND.;
					(.NOT.([ TRUST]$  lnamefname)).AND.;
					(.NOT.([ LLC]$  lnamefname)).AND.;
					(.NOT.([ REALTY ]$  lnamefname)).AND.;
					(.NOT.([ BANK]$  lnamefname)).AND.;
					(.NOT.([ CO]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ LTD]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ INC]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ BANK OF WHITESBURG]$  lnamefname)).AND.;
					(.NOT.([ ENTERPRISE]$  lnamefname)).AND.;
					(.NOT.([ CORP]$  lnamefname)).AND.;
					(.NOT.([ HOUSING]$  lnamefname)).AND.;
					(.NOT.([ STORE]$  lnamefname));
					)	  && it appears that the TANG names are rightly ordered
				REPL  fname WITH ALLTRIM(	SUBSTR ( 	ALLTRIM(lnamefname), AT( [ ], ALLTRIM(lnamefname)   )   ) 	   );
					ALL FOR (;
					(  .NOT. ( [TANG]$ map ) ).AND.;
					(.NOT.([ TRUST]$  lnamefname)).AND.;
					(.NOT.([ LLC]$  lnamefname)).AND.;
					(.NOT.([ REALTY ]$  lnamefname)).AND.;
					(.NOT.([ BANK]$  lnamefname)).AND.;
					(.NOT.([ CO]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ LTD]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ INC]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
					(.NOT.([ BANK OF WHITESBURG]$  lnamefname)).AND.;
					(.NOT.([ ENTERPRISE]$  lnamefname)).AND.;
					(.NOT.([ CORP]$  lnamefname)).AND.;
					(.NOT.([ HOUSING]$  lnamefname)).AND.;
					(.NOT.([ STORE]$  lnamefname));
					)

&& exclude swapping for TANG, INTANG, LLC's and TRUSTs, still some swapping wrong.
&&				REPL ALL  lnamefname WITH ALLTRIM(lname)+[ ]+ALLTRIM(fname) FOR (.NOT.([TANG]$ map))
			ENDIF


TEXT
		SELECT 14
		USE  tbill2mm.DBF  EXCLUSIVE
		ZAP
		APPE FROM trim_bill
		DO  fix_city_st_zip
&& assert TRIM data to ACT fields
		REPLACE ALL  pickup_id WITH [],;
			compound WITH PADL(ALLTRIM(STR(RECNO())),9,[0]),;
			account WITH ALLTRIM( acct_num),;
			address   WITH ALLTRIM( mm_name_2),;
			address2 WITH ALLTRIM( mail_add),;
			lname WITH ALLTRIM( mm_name_1),;
			lnamefname WITH ALLTRIM( mm_name_1),;
			city WITH ALLTRIM( mm_city),;
			state 	WITH ALLTRIM( mm_state),;
			zip 	WITH ALLTRIM( mm_zip),;
			map WITH ALLTRIM(  map_num),;
			comments WITH ;
			[|  DESC. : ]+ALLTRIM( DESCRIPT);
			+[| Prop. : ]+ALLTRIM( prop_num)+[|]+STR(t1,8)+STR(t2,8)+STR(t3,8)+STR(t4,8)+[|]+u0+u1+u2+u4,;
			SOURCE WITH [T],;
			district WITH ALLTRIM( tax_distr)

&&				 STREET  WITH ALLTRIM( str(val(LOC_STR_NO),5))+[  ]+ALLTRIM( LOC_STR_NM),;
&&				 STREET  WITH SUBSTR(ALLTRIM( str(val(LOC_STR_NO),5))+SPACE(2)+ALLTRIM(  LOC_STR_NM),1),;

&& fix the fname lname order
		IF yesno([Fix backwards names in addresses for all but TANG types?  Say NO to Import TRIM records "as is", if you want to look up from past years records, for example ])
			REPL   lname WITH ;
				ALLTRIM(LEFT( ALLTRIM(lnamefname),;
				AT([ ],ALLTRIM(lnamefname))) );
				ALL FOR (;
				(  .NOT. ( [TANG]$ map ) ).AND.;
				(.NOT.([ TRUST]$  lnamefname)).AND.;
				(.NOT.([ LLC]$  lnamefname)).AND.;
				(.NOT.([ REALTY ]$  lnamefname)).AND.;
				(.NOT.([ BANK]$  lnamefname)).AND.;
				(.NOT.([ CO]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
				(.NOT.([ LTD]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
				(.NOT.([ INC]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
				(.NOT.([ BANK OF WHITESBURG]$  lnamefname)).AND.;
				(.NOT.([ ENTERPRISE]$  lnamefname)).AND.;
				(.NOT.([ CORP]$  lnamefname)).AND.;
				(.NOT.([ HOUSING]$  lnamefname));
				)	  && it appears that the TANG names are rightly ordered
			REPL  fname WITH ALLTRIM(	SUBSTR ( 	ALLTRIM(lnamefname), AT( [ ], ALLTRIM(lnamefname)   )   ) 	   );
				ALL FOR (;
				(  .NOT. ( [TANG]$ map ) ).AND.;
				(.NOT.([ TRUST]$  lnamefname)).AND.;
				(.NOT.([ LLC]$  lnamefname)).AND.;
				(.NOT.([ REALTY ]$  lnamefname)).AND.;
				(.NOT.([ BANK]$  lnamefname)).AND.;
				(.NOT.([ CO]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
				(.NOT.([ LTD]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
				(.NOT.([ INC]$  RIGHT(ALLTRIM(lnamefname),5))).AND.;
				(.NOT.([ BANK OF WHITESBURG]$  lnamefname)).AND.;
				(.NOT.([ ENTERPRISE]$  lnamefname)).AND.;
				(.NOT.([ CORP]$  lnamefname)).AND.;
				(.NOT.([ HOUSING]$  lnamefname)).AND.;
				(.NOT.([ STORE]$  lnamefname));
				)								&& exclude swapping for TANG, INTANG, LLC's and TRUSTs, still some swapping wrong.
		ENDIF
ENDTEXT

			CLEAR 	&& make MM xfer file
			SELE ttax2mm
			GOTO TOP
*			? [eo import_trim...next tax file]
			COPY  TO wrk_tax.DBF FIELDS compound, acct_num, fname,lname ,address,address2,city,state,zip ALL
*		SELE tbill2mm
*		GOTO TOP
*			? [nxt bill file]
*		COPY  TO wrk_bill.DBF FIELDS compound, acct_num,  fname,lname ,address,address2,city,state,zip ALL
TEXT
*****************  Import TRIM O Files   ****************
*
*
*   This routine has finished.
*
*   If you wish to use MM to correct the USPS addresses,
*   copy the files WRK_TAX.DBF to the
*   MailMan  Directory.. Encode the addresses there.
*   Copy the corrected file back to the ACT directory, then
*   use the Import MM Files option on the MM corrected data.
*
*   If you choose to not correct the USPS addresses,
*   proceed directly to the TRIM/TAXBASE menu  (above)
*   and RUN the UPDATE CUSTOMER and UPDATE INVOICE.
*   options.
*
*   Again, You may run Mailman first, but you
*   must run the UPDATE steps to complete the import from TRIM.
**************************************************************

ENDTEXT
			STORE [] TO aq
			ACCE ([Press Enter to Continue]) TO aq
		ENDIF && user said OK
		CLEAR
		CLOSE DATA
		DO view_set
		RETURN






********************************************
	PROCEDURE trimupcust
********************************************
*		PRIV T
*		STORE [] TO T
		PRIVATE c_start,c_i,c_j,c_k,c_a,r_s,r_n,c_s,c_n,m_start,s_start, m_at,c_at,last1, c_b,c_c
		CLEAR
TEXT
*****************  Apply TAX BILL Files   ****************
******************   Update Accounts   *******************
*
*     ***  W A R N I N G   ***  ***  W A R N I N G   ***
*
* Completing the following procedure will Update the
* existing Customer list with records imported from TRIM/ARM
* and  ADD invoice records (tax bills) imported from
* TRIM/ARM.  The Tax rates are adjusted for the first month
* discount.  The full charge is restored by adding in a
* fee at the end of the first month.
*
* DO NOT RUN THIS ROUTINE UNLESS YOU
* INTEND TO UPDATE THE CUSTOMER LIST
* AND TO IMPORT TAX BILLS FROM TRIM/ARM.
*
* ONLY RUN THIS ROUTINE ONCE (1) TIME
* PER TAX YEAR. REALLY, ONLY ONCE!
*
* You must have EXCLUSIVE USE of the
* ACT Data files.
*
* BACK UP ALL TRIM/ARM and ACT DATA
* BEFORE PROCEEDING
*
**************************************************************

ENDTEXT
		IF yesno([Update Existing Customer List & Import Tax Bills ? ])
			CLEAR
			CLOSE DATA
			DO view_set
			SELECT 15
			USE tax_cityrates
			SELECT 13
			USE  ttax2mm.DBF
			SELECT 14
			USE  tbill2mm.DBF
			? [***   PLEASE WAIT--LOADING DATA FROM TRIM ***]
			SELE ttax2mm



************************************  !!!   *****************************************
*  THIS IS WHERE YOU CHOOSE TO BUILD DATA FOR 1 DISTRICT or ALL
*		COPY ALL FOR tax_district$district TO tmp  && TMP SOURCES BOTH CUST & MAIN
			COPY ALL TO tmp
*  THIS IS WHERE YOU CHOOSE TO BUILD DATA FOR 1 DISTRICT or ALL
************************************  !!!   *****************************************




			GOTO TOP			&& return to the first ttax2mm record, then process all records
			SELE act_cust
			USE act_cust EXCL

			SET ORDER TO									&& catch  last rec # before append
			STORE RECCOUNT()+1 TO c_start
			APPE FROM tmp

			GOTO c_start
			? [***  Setting record dates  ***]
			REPL REST last_calc WITH DATE(),;
				cust_type WITH [C],;
				totl_amt WITH 0,;
				last_updat WITH DATE(),;
				good WITH .T.,;
				first_star WITH DATE(),;
				rev_date WITH DATE()

			GOTO c_start
			DO WHILE (.NOT. EOF())  							&& Assign PICKUP_ID #
				IF (i_count([CU]))  								 && fetch valid cust # from I_Count
					last1=PADL(ALLTRIM(STR(count_var,6)),6,'0')
					REPLACE pickup_id WITH ALLTRIM(last1)
				ENDIF
				SKIP
			ENDDO


			? [***   Completed  Customer, Next Tax Bills  ***]
			SELE act_main										&& make  invoice records from TRIM
			USE act_main EXCL  									&& create act_main even if there is no tax- there is a cust record, so we want  to
&& know that the PVA has a record with no tax in distr 2 (city)
			STORE RECCOUNT()+1 TO m_start 					&&  create new invoice for eachTAX
			APPE FROM tmp 									&& CREATE NEW RECORDS IN MAIN
			GOTO m_start
			REPL REST srvc_dat WITH DATE(),	rev_date WITH DATE()
			GOTO m_start
			SELE act_cust
			GOTO c_start
			SELE act_main
			DO WHILE (.NOT. EOF())  							&& Assign PICKUP_ID #
				REPL pickup_id WITH act_cust.pickup_id
				SELE act_cust
				SKIP
				SELE act_main
				SKIP
			ENDDO


			SELE ttax2mm
			SET FILTER TO tax_district$district
			SKIP -1
			SELE act_main


			ERASE tmp											&& housekeeping
			GOTO m_start
			STORE m_start TO m_at								&& keep tabs on main invoice record

*on key label ALT+F1 cancel
*? [m_start,],RECNO()

			DO WHILE .NOT. EOF()								&& assign invoice #
				SELE act_main
				IF (i_count([IN]))  							&& fetch valid cust # from I_Count
					last1=STR(count_var,10)
					REPLACE invoice WITH  ALLTRIM(last1)
				ENDIF
*? [invoice: ], invoice
				UNLOCK ALL									&& CREATE NEW RECORD IN SCR
				SELE tax_cityrates							&& read the tax rates from Tax_CityRates by field name.
				GOTO TOP									&& the names correspond between files, but the city rates are numeric, while ttax2mm has strings
				c_i=1
				FOR c_a=1 TO FCOUNT()						&& across all taxes in tax_cityrates
					SELE tax_cityrates
					STORE FIELD(c_a) TO r_s  				&&snag the name of the tax field
					STORE &r_s TO r_n  						&& snag the rate as a decimal
					SELE ttax2mm
*? [ttax2mm recno()], recno()
					STORE [ttax2mm.]+r_s TO c_b
					STORE &c_b TO c_s 						&& snag the assesment as string
*					STORE &r_s TO c_s 						&& snag the assesment as string
					STORE VAL(c_s) TO c_n

*? [ test 5], [|],r_s,[|],r_n,[|],c_s,[|],c_n,[|],c_i, [|], c_b
					IF (r_n*c_n>0) 				 			&& somethings taxed, make invoice record of it
						SELE act_scr
						IF c_i=1
							APPEND BLANK  				&&needed another invoice line
							REPLACE invoice WITH act_main.invoice
							REPL act_scr->i1 WITH r_s  	&& name of tax
							REPL act_scr->code1 WITH r_s  && name of tax
*							REPL act_scr->p1 WITH r_n 	&& tax rate as decimal
							REPL act_scr->p1 WITH r_n*(1-(late_rate_res/100))	&& tax rate as decimal  with first month discount deducted-it will be added back if they don't pay in the first month
							IF (LEFT(r_s,1)=[R] ).AND.;
									(   ( SUBSTR(r_s,4,1)=[R].AND.(ttax2mm.party$[23])) ;
									.OR.   ( SUBSTR(r_s,4,1)=[F].AND.(ttax2mm.party$[45]))  ;
									.OR.   ( SUBSTR(r_s,4,1)=[C].AND.(ttax2mm.party$[67]))  ;
									.OR.   ( SUBSTR(r_s,4,1)=[M].AND.(ttax2mm.party$[89]))  )
								c_n=MAX(0,c_n-hstead_dedn)	&& set the homestead exemption, deduct 28000 from assesment
							ENDIF
							REPL act_scr->c1 WITH c_n  	&&assemement
						ENDIF
						IF c_i=2
							REPL act_scr->i2 WITH r_s  	&& name of tax
							REPL act_scr->code2 WITH  r_s  && name of tax
*							REPL act_scr->p2 WITH r_n 	&& tax rate as decimal
							REPL act_scr->p2 WITH r_n*(1-(late_rate_res/100))	&& tax rate as decimal  with first month discount deducted-it will be added back if they don't pay in the first month
							IF (LEFT(r_s,1)=[R] ).AND.;
									(   ( SUBSTR(r_s,4,1)=[R].AND.(ttax2mm.party$[23])) ;
									.OR.   ( SUBSTR(r_s,4,1)=[F].AND.(ttax2mm.party$[45]))  ;
									.OR.   ( SUBSTR(r_s,4,1)=[C].AND.(ttax2mm.party$[67]))  ;
									.OR.   ( SUBSTR(r_s,4,1)=[M].AND.(ttax2mm.party$[89]))  )
								c_n=MAX(0,c_n-hstead_dedn)	&& set the homestead exemption, deduct 28000 from assesment
							ENDIF
							REPL act_scr->c2 WITH c_n  	&&assemement
						ENDIF
						IF c_i=3
							REPL act_scr->i3 WITH r_s  	&& name of tax
							REPL act_scr->code3 WITH  r_s  && name of tax
*							REPL act_scr->p3 WITH r_n	 && tax rate as decimal
							REPL act_scr->p3 WITH r_n*(1-(late_rate_res/100))	&& tax rate as decimal  with first month discount deducted-it will be added back if they don't pay in the first month
							IF (LEFT(r_s,1)=[R] ).AND.;
									(   ( SUBSTR(r_s,4,1)=[R].AND.(ttax2mm.party$[23])) ;
									.OR.   ( SUBSTR(r_s,4,1)=[F].AND.(ttax2mm.party$[45]))  ;
									.OR.   ( SUBSTR(r_s,4,1)=[C].AND.(ttax2mm.party$[67]))  ;
									.OR.   ( SUBSTR(r_s,4,1)=[M].AND.(ttax2mm.party$[89]))  )
								c_n=MAX(0,c_n-hstead_dedn)	&& set the homestead exemption, deduct homestead dedn from assesment
							ENDIF
							REPL act_scr->c3 WITH c_n  	&&assemement
						ENDIF
						c_i=c_i+1							&& increment screen cell in invoice SCR record
						IF c_i > 3
							c_i=1	  						&& new rec after 3 cells
						ENDIF
*? [ whoopeeee!!! we made an invoice scr rec],reccount()
					ENDIF									&& Done adding SCR record for this tax
					SELE tax_cityrates
				ENDFOR									&& do for all taxes in tax_cityrates
				UNLOCK ALL
				DO scr_subtot  								&&build service strings and invoice total
				UNLOCK ALL
				SELE ttax2mm					&& increment the TRIM/TTAX data in lockstep

				SKIP							&& next Tax record
				SELE act_main								&& process next main record
				GOTO m_at

				SKIP  										&& next Invoice record
*? [m_skip  ,],RECNO()
*acce [ test 6 hit enter] to c_k
				m_at= RECNO()
			ENDDO
*acce [ test 6 hit enter] to c_k
*on key label ALT+F1
			CLOSE DATA
			DO view_set
			DO calc_balance

			DO view_set

			SELE act_main

			GOTO TOP
			DO WHILE (.NOT.EOF())
				REPL act_cust.comments WITH ALLTRIM(act_cust.comments);
					+[| ]+ALLTRIM(srvc_list);
					+[| ]+ALLTRIM(pric_list);
					+[| ]+ALLTRIM(coun_list)
				SKIP
			ENDDO
			CLEAR 										&&Close data & reset the  files
TEXT
*****************  Apply TAX BILL Files   ****************
*******************   Update Accounts   *******************
*
*   This routine has finished.
*
*   Tax data from TRIM/ARM has been assigned to new
*   records.  Prior data is untouched.and clients have
*   a full history in the records.   You may proceed to billing.
*
*   Please Note;  All tax bills are commercial records.
*   The notion of residentiial here applies to a sytle of billng,
*   not whether the client is a commercial enterprise or
*   a domicile.  Use Commercial billing options.
*
*   ***   COMPLETED IMPORTING TAX BILLS   ***.
**************************************************************

ENDTEXT
			ACCE ([ Press ENTER to continue ]) TO estr_var
			CLEAR
		ENDIF  &&yes Overwrite
		RETURN


******==========================================================*******
	PROCEDURE fix_city_st_zip
******==========================================================*******
		PRIV T, t_st, t_len, t_state, t_sfu, t_sub, t_scr,t_sln

&& assign data to be managed by BCC MailMan-these fields will be read & written by MM
		REPL ALL mm_uniq_id WITH STR(RECNO()),;
			mm_mail_ad WITH mail_add,;
			mm_name_1 WITH name_one,;
			mm_name_2 WITH name_two,;
			mm_scratch WITH ALLTRIM(cty_st_zip)  && copy city state zip to scratch area

&& if two word state name, test for full state instead of abbvn- fix to abbvn
		STORE SELE() TO T
		SELE 15
		USE trim_st
		GOTO TOP
		DO WHILE (.NOT. EOF())
			STORE st TO t_st
			STORE UPPER(ALLTRIM(state)) TO t_state
			STORE LEN(ALLTRIM(t_state)) TO t_len
			IF ([ ]$ ALLTRIM(t_state))  && then two word state
				SELE (T)
				SET FILTER TO (ALLTRIM(t_state)$mm_scratch)
				REPL ALL mm_scratch WITH;
					SUBSTR(mm_scratch,1,AT(ALLTRIM(t_state),mm_scratch)-1);
					+t_st;
					+ALLTRIM(SUBSTR(mm_scratch,AT(ALLTRIM(t_state),mm_scratch) +t_len,;
					LEN(ALLTRIM(mm_scratch))-(AT(ALLTRIM(t_state),mm_scratch)+t_len)  ) );

				SET FILTER TO
				SELE 15
			ENDIF
			SKIP
		ENDDO
		SELE (T)

&& move zip to mm_zip
		REPL ALL mm_zip WITH STUFF(ALLTRIM(mm_scratch), RAT([ ],ALLTRIM(mm_scratch)) ,1,[-]) ;
			FOR ((LEN(ALLTRIM(mm_scratch))>5) ;
			.AND. (SUBSTR(ALLTRIM(mm_scratch),LEN(ALLTRIM(mm_scratch))-4,1)$[ ])  ;
			.AND. (SUBSTR(ALLTRIM(mm_scratch),LEN(ALLTRIM(mm_scratch))-3,1)$[0123456789]) ;
			.AND. (SUBSTR(ALLTRIM(mm_scratch),LEN(ALLTRIM(mm_scratch))-5,1)$[0123456789]))

		REPL ALL mm_zip WITH RIGHT(ALLTRIM(mm_scratch),LEN(ALLTRIM(mm_scratch))-RAT([ ],ALLTRIM(mm_scratch)))
		REPL ALL mm_zip WITH [] FOR ((LEN(ALLTRIM(mm_zip))<5) .OR. (.NOT. (LEFT(mm_zip,1)$[0123456789])))
		REPL ALL mm_zip WITH RIGHT(ALLTRIM(mm_scratch),10)  FOR ((LEN(ALLTRIM(mm_zip))=0) .AND. (RIGHT(ALLTRIM(mm_scratch),1)$[0123456789]))

		REPL ALL mm_scratch WITH LEFT(ALLTRIM(mm_scratch), LEN(ALLTRIM(mm_scratch))-LEN(ALLTRIM(mm_zip)) )

&& move state to mm_state
		REPL ALL mm_state WITH RIGHT(ALLTRIM(mm_scratch),LEN(ALLTRIM(mm_scratch))-RAT([ ],ALLTRIM(mm_scratch)))
		REPL ALL mm_state WITH [] FOR ((LEN(ALLTRIM(mm_state))<2))
		REPL ALL mm_state WITH [] FOR mm_state=[FO]
		REPL ALL mm_state WITH [KY] FOR mm_state=[KE]
		REPL ALL mm_scratch WITH SUBSTR(ALLTRIM(mm_scratch),1,LEN(ALLTRIM(mm_scratch))-LEN(ALLTRIM(mm_state))) FOR LEN(ALLTRIM(mm_scratch))>2
&& move what is left to city & repair:  many states w/out abvn!  Also odd ab[ |-|- | -| - ]vns.  Cleave  state names.
		REPL ALL mm_city WITH ALLTRIM(mm_scratch)

		REPL ALL mm_state WITH [SC] FOR ([S C] $ RIGHT(ALLTRIM(mm_city),3) .AND. (mm_state=[]))
		REPL ALL mm_city WITH LEFT(ALLTRIM(mm_city),LEN(ALLTRIM(mm_city))-3) FOR [S C] $ RIGHT(ALLTRIM(mm_city),3) .AND. (mm_state=[SC])

		REPL ALL mm_state WITH [NY] FOR ([N Y] $ RIGHT(ALLTRIM(mm_city),3) .AND. (mm_state=[]))
		REPL ALL mm_city WITH LEFT(ALLTRIM(mm_city),LEN(ALLTRIM(mm_city))-3) FOR [N Y] $ RIGHT(ALLTRIM(mm_city),3) .AND. (mm_state=[NY])

		REPL ALL mm_state WITH [NC] FOR ([N C] $ RIGHT(ALLTRIM(mm_city),3) .AND. (mm_state=[]))
		REPL ALL mm_city WITH LEFT(ALLTRIM(mm_city),LEN(ALLTRIM(mm_city))-3) FOR [N C] $ RIGHT(ALLTRIM(mm_city),3) .AND. (mm_state=[NC])

* ? [test 3], mm_city
&& go thru all 50 states and fix any full spellings- replace with abbvn's & strip state name from city
		STORE SELE() TO T
		SELE 15
		USE trim_st
		GOTO TOP
		DO WHILE (.NOT. EOF())
			STORE st TO t_st
			STORE UPPER(ALLTRIM(state)) TO t_state
*	?? st,[|]
			STORE LEN(ALLTRIM(t_state)) TO t_len
			STORE LEFT(ALLTRIM(t_state),t_len-4) TO t_sub
			STORE UPPER(LEFT(ALLTRIM(t_state),2)) TO t_sfu
*     ?? t_state,[|], t_len,[|],t_sub,[|],t_sfu,[|]
			SELE (T)
			REPL ALL mm_state WITH t_st FOR (t_sub $ mm_city) .AND. (mm_state=t_sfu)
			REPL ALL mm_city WITH ;
				LEFT(ALLTRIM(mm_city),LEN(ALLTRIM(mm_city))-(t_len-3)) ;
				FOR t_sub $ mm_city .AND. (mm_state=t_st)
			SELE 15
			SKIP
		ENDDO
		SELE (T)
* ? [Finished cleaning City State, & ZIP]
&& Now send this file to mailman and run-it is ready to fix addresses

		RETURN


******==========================================================*******
	PROCEDURE import_mm
******==========================================================*******
		PRIVATE i_str
		CLEAR
TEXT
****************************   USPS Address Fix   ******************************
**************** Import Corrected Addresses From MailMan   ****************
*
*   Run this AFTER you have used MM to correct addresses.
*
*   MailMan (MM) makes the files "mm_tax.dbf" and "mm_bill.dbf" from
*   WRK_TAX.DBF  and WRK_BILL.DBF.  You made the WRK_ files
*   when you last ran the menu option TRIM/Update Accounts. They were
*   copied to the MailMan  Directory where they were encoded to  make the
*   mm_ files. Copy back the files "mm_tax.dbf" and "mm_bill.dbf"
*   to your current directory before proceeding with this import.
*

ENDTEXT

		IF (yesno([OK to Import corrected addresses from MailMan ?]))

			CLOSE DATA
			SELE A
			USE mm_tax.DBF EXCL
			INDE ON ALLTRIM(prop_num) TAG az
			SELE b
			USE ttax2mm.DBF EXCL
			SET RELA TO ALLTRIM(ttax2mm.compound) INTO A  && Don't ask why-MM has re-labeled compound as prop_num, but it has, so go with it
			GOTO TOP
*do while (.not. eof())
* ? [@ IMPORT_MM, ABOVE REPL ALL TTAX2MM]
*	? RECNO(),alltrim(mm_tax.first_name), alltrim(mm_tax.last_name),  alltrim(mm_tax.dlvryaddr1), alltrim(mm_tax.company), alltrim(mm_tax.city),  alltrim(mm_tax.state),   alltrim(mm_tax.zip4)
			REPL ALL ttax2mm.fname WITH ALLTRIM(mm_tax.first_name),;
				ttax2mm.lname WITH ALLTRIM(mm_tax.last_name),;
				ttax2mm.address WITH ALLTRIM(mm_tax.dlvryaddr1),;
				ttax2mm.address2 WITH ALLTRIM(mm_tax.company),;
				ttax2mm.city WITH ALLTRIM(mm_tax.city),;
				ttax2mm.state WITH ALLTRIM(mm_tax.state),;
				ttax2mm.zip WITH ALLTRIM(mm_tax.zip4)

*			 skip
*enddo
TEXT

		CLOSE DATA
		SELE a
		USE mm_bill.DBF EXCL
		INDE ON ALLTRIM(prop_num) TAG az
		SELE b
		USE tbill2mm.DBF EXCL
		SET RELA TO ALLTRIM(tbill2mm.compound) INTO a
		GOTO TOP

* ? [@ IMPORT_MM, ABOVE REPL ALL TBILL2MM]
		REPL ALL tbill2mm.fname WITH ALLTRIM(mm_bill.first_name),;
			tbill2mm.lname WITH ALLTRIM(mm_bill.last_name),;
			tbill2mm.address WITH ALLTRIM(mm_bill.dlvryaddr1),;
			tbill2mm.address2 WITH ALLTRIM(mm_bill.company),;
			tbill2mm.city WITH ALLTRIM(mm_bill.city),;
			tbill2mm.state WITH ALLTRIM(mm_bill.state),;
			tbill2mm.zip WITH ALLTRIM(mm_bill.zip4)
*			REPL ALL tbill2mm.MM_NAME_1 WITH WRK_BILL.DBF.MM_NAME_1, tbill2mm.MM_NAME_2 WITH WRK_BILL.DBF.MM_NAME_2,tbill2mm.mm_mail_add WITH WRK_BILL.DBF.mm_mail_add,tbill2mm.city WITH WRK_BILL.DBF.city,tbill2mm.state WITH WRK_BILL.DBF.state,tbill2mm.zip WITH WRK_BILL.DBF.zip
ENDTEXT
			CLEAR
TEXT
****************************   USPS Address Fix   ******************************
***************  Import Corrected Addresses From MailMan   ****************
*
*
*   This routine has finished.
*
*
*   You have used MM to correct the USPS addresses.
*
*
*   Now use the TRIM menu's UPDATE ACCOUNT to apply
*   the corrected addresses.
*
*
******************************************************************************

ENDTEXT
			CLOSE DATA
			DO view_set
			STORE [] TO istr_var
			ACCE ([Press ENTER to continue ]) TO estr_var
			CLEAR
		ENDIF
		RETURN



******==========================================================*******
	PROCEDURE export2trim
******==========================================================*******
		PRIV ei, estr_var
		CLEAR
TEXT
****************************  Finish TRIM (Export DA_) ****************************
***  Merge (USPS) Corrected Address Files and Make TRIM DA_ files.  ***
*
*   Run this to merge fixed addresses with  the current TRIM_TAX files.
*  O_TAX___.DAT   makes O_TAX___.DAT.DA_
*
*  Once written, the DA_ file is an address corrected substitute for the
*  original TRIM DAT file.  To use it, BACKUP YOUR TRIM FILES,
*  then copy the NEW DA_ file to the  original DAT file, then  re-index TRIM
*
*
ENDTEXT

		IF (yesno([OK to write (USPS) corrected addresses from the current TTAX2MM file to the merge file O_TAX___.DA_?]))
			SET SPACE OFF
*on key label ALT+F1 goto bottom
			SET PRINTER TO o_tax___.new
*? [@export2trim just set printer to O_TAX___.NEW]
			SET PRINTER ON
			SET CONSOLE OFF
			SELECT 11
&&			USE trim_tax.DBF  EXCLUSIVE
			USE ttax2mm.DBF  EXCLUSIVE
			SET ORDER TO
			GOTO TOP
			DO WHILE (.NOT. EOF())
				?? PADR(ALLTRIM(name_one),30," "),;
					PADR(ALLTRIM(name_two),30," "), ;
					PADR(ALLTRIM(address),36," "),;
					PADR(LEFT(ALLTRIM(city),24)+[ ]+ALLTRIM(state)+[ ]+ALLTRIM(zip),36," ")
				SKIP
			ENDDO
			SET CONSOLE ON
*? [@export2trim done printing]  *				?? PADR(ALLTRIM(fname)+[ ]+ALLTRIM(lname),30," "),;
SET PRINTER OFF
			SET PRINTER TO
			SET SPACE ON
*			USE
*on key label ALT+F1
		ENDIF

TEXT
	IF (yesno([OK to write (USPS) corrected addresses from the current TBILL2MM file to the merge file O-BILL__.DA_?]))
		SET SPACE OFF
		SET PRINTER TO o-bill__.new
		SET PRINTER ON
		SET CONSOLE OFF
		SELECT 12
&&			USE trim_bill.DBF  EXCLUSIVE
		USE tbill2mm.DBF  EXCLUSIVE
		SET ORDER TO
		GOTO TOP
		DO WHILE (.NOT. EOF())
			?? PADR(ALLTRIM(lname)+[ ]+ALLTRIM(fname),30," "),;
				PADR(ALLTRIM(address2),36," "),;									&& had to swap vs TAX layout (addr 2 precedes addr)  wsh 10/3/04
			PADR(ALLTRIM(address),30," "), ;
				PADR(LEFT(ALLTRIM(city),24)+[ ]+ALLTRIM(state)+[ ]+ALLTRIM(zip),36," ")
			SKIP
		ENDDO
		SET PRINTER OFF
		SET PRINTER TO
		SET CONSOLE ON
		SET SPACE ON
*			USE
	ENDIF
ENDTEXT
		CLEAR
		CLOSE DATA
		CLEAR
		ON ERROR
		STORE .T. TO izdos
		ON ERROR STORE .F. TO izdos
&&		RUN perl trim_o_bill_act2dat.pl
		RUN perl  trim_o_tax_act2dat.pl
* | * ON ERROR DO syserror WITH LINENO()
		IF (.NOT. izdos )
			IF (yesno([EXTERNAL ROUTINES FAILED!  Run trim_o_bill_act2dat.pl and  trim_o_tax_act2dat.pl manually and then proceed.  SDFs Ready?]))
&& wait while user hand preps sdf's
			ENDIF
		ENDIF
		DO view_set

		CLEAR
TEXT

****************************  Finish TRIM (Export DA_) *****************************
***  Merge (USPS) Corrected Address Files and Make TRIM DA_ file.  ****
*
*   This routine has finished.
*
*   You have merged fixed addresses with  the current TRIM_TAX files.
*  O_TAX___.DAT   makes O_TAX___.DAT.DA_
*
*,  The DA_ file is an address corrected substitute for the
*  original TRIM DAT file.  To use it, BACKUP YOUR TRIM FILES,
*  then copy the NEW DA_ file to the  original DAT file, then  re-index TRIM
*
*
******************************************************************************

ENDTEXT

		STORE [] TO estr_var
		ACCE ([Press ENTER to continue ]) TO estr_var
		CLEAR
		RETURN

*===========================================================================
	PROCEDURE edit_cityrates
*===========================================================================
		PRIVATE e_i, e_j
		CLEAR
		SELECT 15
		USE tax_cityrates EXCL
		IF RECCOUNT()>1			&& make sure only 1 rec in file
			? [Extra Rate Record Found & Removed]
			GOTO TOP
			SKIP
			DELE REST
			PACK
		ENDIF
		GOTO TOP
		EDIT TITLE [Enter Tax Rates as decimals per dollar, IE:  a 0.5% per thousand rate is 0.000005.]
&& set rates in act_line from tax-cityrates
		SELE 9
		USE act_line SHARED ORDER TAG invoice
		SELE act_line
		GOTO TOP
		DO WHILE .NOT.EOF()
			IF LEN(ALLTRIM(act_line.i1))>0
				az=[tax_cityrates.]+ALLTRIM(act_line.i1)
				REPL p1 WITH &az
			ENDIF
			IF LEN(ALLTRIM(act_line.i2))>0
				az=[tax_cityrates.]+ALLTRIM(act_line.i2)
				REPL p2 WITH &az
			ENDIF
			IF LEN(ALLTRIM(act_line.i3))>0
				az=[tax_cityrates.]+ALLTRIM(act_line.i3)
				REPL p3 WITH &az
			ENDIF
			SKIP
		ENDDO
		USE
		SELE tax_cityrates

		IF yesno([Print the Current City Rates to the default printer?])
			GOTO TOP
			SET PRINTER TO DEFAULT
			SET PRINTER ON
			?
			?
			?
			? [Current City Rates as Decimals per Dollar. IE:  0.5% per thousand is 0.000005]
			?
			? DATE()
			?
			?[===========================]
			FOR e_i=1 TO FCOUNT()
				e_j=FIELD(e_i)
				? ALLTRIM(FIELD(e_i))+[:], &e_j
			ENDFOR
			?[===========================]

			SET PRINTER OFF
			SET PRINTER TO FILE junk.txt
			SET PRINTER TO
*			DISPLAY NEXT 1 TO PRINTER
		ENDIF
		DO view_set

		RETURN


*===========================================================================
	PROCEDURE show_addr_chg
*===========================================================================
		PRIVATE s_i, s_ok,s_k, s_dir,s_drv,s_cur
		SELECT 11
		USE ttax2mm.DBF
		GOTO TOP
		CLEAR
TEXT
***   P(rint or V(iew Address Changes   ***
*
*	Changes have been made to the addressing
* 	data from TRIM.  Enter V to view the old and new
*	data.  Enter P to print the Address Changes Report
*	to the default printer (NB: Very large  report).
*
*	Two batches of changes may have occurred, or
*	only one if the Trim menu option "USPS ADDRESS
*	FIX" (BCC's MailMan) was not applied.  View the
*	files before BCC to see the first batch, after for all.
*
*	The first batch makes the City State and Zip codes
*	and cleans up the first/last name order, & state abbvns.
*	The second (MM) fixes USPS addresses & zip+4's.
*

ENDTEXT

		s_cur=ALLTRIM(SYS(5))+ALLTRIM(SYS(2003))

		s_ok=.T.


		ACCE ([   Review TRIM TAX or TRIM BILL?  Enter T or B => ]) TO s_i
		IF ([T]$UPPER(s_i))
			SELECT 11
			USE ttax2mm.DBF
		ELSE
			SELECT 12
			USE tbill2mm.DBF
		ENDIF

		GOTO TOP
		CLEAR


		ACCE ([   P(rint or V(iew the Adddress Change Report.  Enter P or V=> ]) TO s_i
		CLEAR
		IF ([P]$UPPER(s_i))
			REPO FORM show_addr_chg.frx TO PRINTER
			SET DEFA TO &s_cur										&& recover from dir changes during printing
		ENDIF
		IF ([V]$UPPER(s_i))
			BROWSE FIELDS name_one, fname,lname,name_two,address2,address,mail_add,cty_st_zip,city,state,zip NOEDIT	TITLE [Compare esp Address & Mail_Add, Cty_st_zip & City, State, Zip]
		ENDIF
		USE
		DO view_set
		RETURN

*===========================================================================
*===========================================================================
*===========================================================================
*===========================================================================


******==========================================================*******
	FUNCTION in_x
******==========================================================*******
		PARAMETER a_pw
		PRIVATE uz_pw
		STORE a_pw TO uz_pw
*xform db2 tex
		PRIVATE old_u_r
		PRIVATE l_ch
		PRIVATE l_,i_
*store[] to new_u_r
*use act_y shared
*set order to 1
*store act_Y->U_R to old_u_r
		STORE uz_pw TO old_u_r
		STORE LEN(ALLTRIM(old_u_r)) TO l_
		IF (l_>0)
			FOR i_=1 TO l_
				STORE ASC(SUBSTR(old_u_r,i_,1)) TO l_ch
				IF (l_ch<ASC([L]))
					new_u_r=new_u_r+CHR(l_ch+20)
				ELSE
					new_u_r=new_u_r+CHR(l_ch-20)
				ENDIF
			ENDFOR
		ENDIF
		USE
		uz_pw=new_u_r
		RETURN uz_pw

******==========================================================*******
	PROCEDURE out_x
******==========================================================*******
*xform tex2db
		PRIVATE old_u_r
		PRIVATE who_to
		PRIVATE new_u_r
		PRIVATE l_ch
		PRIVATE l_,i_
		CLEAR
		STORE [       ] TO who_to
		ACCE [Enter the User Name (6 ch or less) =>] TO who_to
		STORE UPPER(ALLTRIM(who_to)) TO who_to
		CLEAR
		STORE[] TO new_u_r
		ACCE [Enter up to 8 characters for a new Password (A..Z,0..9) =>] TO old_u_r
*store act_Y->U_R to old_u_r
		STORE ALLTRIM(UPPER(old_u_r)) TO old_u_r
		STORE LEN(ALLTRIM(old_u_r)) TO l_
		IF (l_>0)
			FOR i_=1 TO l_
				STORE ASC(SUBSTR(old_u_r,i_,1)) TO l_ch
				IF (l_ch<ASC([L]))
					new_u_r=new_u_r+CHR(l_ch-20)
				ELSE
					new_u_r=new_u_r+CHR(l_ch+20)
				ENDIF
			ENDFOR
		ENDIF
		USE act_y SHARED
		SET ORDER TO 1
		SEEK who_to
		IF FOUND()
			? [Old user found, changing Password]
			REPLACE u_r WITH new_u_r
		ELSE
			APPEND BLANK
			? [New User Added]
			REPLACE u_r WITH new_u_r
			REPLACE u_name WITH who_to
		ENDIF
		USE
		RETURN

***********************************************************************
* function Pay_set  && valids for ACT_cust and any char list
***********************************************************************
	FUNCTION pay_set
		a_a=.T.
* STOR SELE() TO cur_sele
		SELE 25
		USE act_x SHARED
		APPEND BLANK
		REPL u_name WITH ur
		REPL DATE WITH DATE()
		REPL u_when WITH TIME()
		REPL u_what WITH [Pb]
		REPL u_where WITH LEFT(SYS(0),10)
		REPL u_seq WITH RECNO(5)
		USE
		SELE 5
		RETURN a_a


	PROCEDURE QUIT_ACT
		PARAMETERS u_said

		DO CASE
		CASE u_said=[Q]
			STORE .F. TO in_orderin
			SET SAFETY OFF
			CLEAR READ ALL
			CLOSE DATA
			USE act_x SHARED
			APPEND BLANK
			REPL u_name WITH ur
			REPL DATE WITH DATE()
			REPL u_when WITH TIME()
			REPL u_what WITH [Out]
			REPL u_seq WITH RECNO()

			USE
			FLUSH
*			SET printer to config.fpw
*			SET printer on
*			? [title=  ACT.EXE  V2.12                              Copyright (C) 2002 WS Herrick]
*			? [tmpfiles=c:\temp]
*			SET printer off
			CLEAR
			RELEASE ALL
			CLOSE DATA
			QUIT

		CASE u_said=[S]
			SET ECHO ON
			SET DEBUG ON
			SUSPEND

		ENDCASE
		RETURN
******==========================================================*******


******==========================================================*******
	PROCEDURE commerbill
******==========================================================*******
		PRIVATE hokay, iz_restart, iz_once,iz_temp, m2_temp, cp_30_temp, cs_30_temp, zz_tt
		STORE [01/06/2000] TO hokay
		STORE .F. TO iz_restart
		STORE .F. TO iz_once
		STORE [        ] TO iz_temp

		CLEAR
TEXT
                             Welcome to the Commercial Bill Printing Routine.

   This will print Commercial Bills for all commercial customers  that  owe
   more than one dollar,  showing ONLY invoices for the given month.
   The statement presents the current balance  as due.   Enter
   commercial receipts as they are payed.  Enter commercial bills (invoices)
   ONLY AFTER the regular residential Generate Bill step and DO NOT run the
   Generate     Bill step again. Print the commercial bills BEFORE the end of the
    month.   Enter 01  for the day of the month.

    Please prepare the default printer.

ENDTEXT

		ACCE ([Enter month as MM/01/YYYY, ie:  12/01/2003 ==>  ]) TO hokay
		m2run = CTOD(ALLTRIM(hokay))
		? [Printing Monthly Statement for ],DTOC(m2run)
		?

&& pick billingoption
		CLOSE DATA
		SELE 1
		USE act_cust ORDER TAG pickup_id
		SELE 2
		USE act_main ORDER TAG pickup_id
*  SELE 4
*  USE act_scr ORDER TAG invoice
		SELE 3
		USE act_pay ORDER TAG pic_id_i
****
		SELE act_cust
		SET RELATION TO pickup_id INTO act_main
		SELE act_main
		SET RELA TO pickup_id INTO act_pay  && relate pay to invoice to customer
*  SET RELA TO invoice INTO act_scr ADDITIVE
***
		SELE act_cust
		GOTO TOP
		iz_temp=[                ]
		ACCE [R)estart partial run, O)ne Customer only, Q)uit, or Press <Enter> to proceed.  ==>] TO iz_temp
		IF (LEN(ALLTRIM(iz_temp))>0)
			IF ([R] $ ALLTRIM(UPPER(iz_temp)))
				ACCE [Enter Customer PickupID# to Restart From ==>] TO iz_temp
				STORE .T. TO iz_restart
				SEEK ALLTRIM(iz_temp)
				BROW LAST TITLE [Select Customer to Restart From.  <ESC> to Continue.]
			ELSE
				IF ([O] $ ALLTRIM(UPPER(iz_temp)))
					ACCE [Enter Customer PickupID# to Print ==>] TO iz_temp
					STORE .T. TO iz_once
					SEEK ALLTRIM(iz_temp)
					BROW LAST TITLE [Select Customer to Print.  <ESC> to Continue.]
				ELSE
					IF ([Q] $ ALLTRIM(UPPER(iz_temp)))
						GOTO BOTTOM
						SKIP
					ENDIF
				ENDIF
			ENDIF
		ENDIF
&&**EOF billing option********************


		ACTIVATE SCREEN
		? [Preparing  Commercial Bills... Please Wait]
		DO WHILE .NOT. EOF()
			IF act_cust.cust_type$[cC]

				STORE act_cust.pickup_id TO c_tmp  && c_tmp is pickup ID

				SELECT act_main

*  WSH 09/04/2004	&& from calc_one-faster
				STORE 0 TO cs_n
				SEEK c_tmp
				DO WHILE (pickup_id=c_tmp) .AND. ( .NOT. EOF())
					cs_n=cs_n+total_amt
					SKIP
				ENDDO
				SELE act_cust  && reset relations, & go back to starting act_main record
				SELE act_main

*  WSH 09/04/2004	&& from calc_one-faster				&&	SUM total_amt TO cs_n ALL FOR pickup_id=c_tmp  && sum all invoiced debts
*  WSH 09/04/2004
				STORE 0.0 TO cs_30
				SEEK c_tmp
				DO WHILE (pickup_id=c_tmp) .AND. ( .NOT. EOF())   && found customer, now sum invoices for month
					IF ( BETWEEN( act_main.srvc_dat,m2run,GOMONTH(m2run,1) ))
						cs_30=cs_30+total_amt
					ENDIF
					SKIP
				ENDDO
				SELE act_cust  && reset relations, & go back to starting act_main record
				SELE act_main
*  WSH 09/04/2004	&& from calc_one-faster	&& SUM total_amt TO cs_30 ALL FOR ((pickup_id=c_tmp) .and. between( act_main.srvc_dat,M2Run,gomonth(M2Run,1) ) )   && as above, but only for invoices dated  in statement month
				STORE cs_30 TO cs_30_temp  && hold on to it, it's been getting lost
*  WSH 09/04/2004
*  WSH 09/04/2004 &&				GOTO top
*  WSH 09/04/2004 &&				SELE act_pay
*  WSH 09/04/2004	&& from calc_one-faster
				SELE act_pay
				STORE 0. TO cp_n
				SEEK c_tmp
				DO WHILE (id_of_payr=c_tmp) .AND. ( .NOT. EOF())
					cp_n=cp_n+amt_paid
					SKIP
				ENDDO
				SELE act_cust  && reset relations, & go back to starting act_main record
*  WSH 09/04/2004	&& from calc_one-faster			&& 	SUM amt_paid TO cp_n ALL FOR id_of_payr=c_tmp  && total all payments ever made
*  WSH 09/04/2004
				SELE act_pay
				STORE 0. TO cp_30
				SEEK c_tmp
				DO WHILE (id_of_payr=c_tmp) .AND. ( .NOT. EOF())
					IF  (BETWEEN( act_pay.date_paid,m2run,GOMONTH(m2run,1) ) )
						cp_30=cp_30+amt_paid
					ENDIF
					SKIP
				ENDDO
*  WSH 09/04/2004	&& from calc_one-faster			&&SUM amt_paid TO cp_30 ALL FOR ((id_of_payr=c_tmp) .and. (between( ACT_PAY.DATE_PAID,M2Run,gomonth(M2Run,1) ) ) ) && as above, but for statment month
				STORE cp_30 TO cp_30_temp
*  WSH 09/04/2004
&& set the totals to the act_cust rec
				UNLOCK ALL  && FREE NETWORK LOCKS
				SELE act_cust  && reset act_main by relation
				REPLACE act_cust.totl_amt WITH cs_n-cp_n, act_cust.last_calc WITH DATE()  && assign the billed amount ot the customer record
				m2_temp=m2run		&&snag the m2run  *************  WSH 09/02/04 ************
				SET SKIP TO act_main  && 1:many from cust to invoice
&& do all invoices for a customer

				SELE act_main  &&start invoice processing
&&				SET filter to ((ALLTRIM(act_main.pickup_id)=ALLTRIM(act_cust.pickup_id)) .and. (between( act_main.srvc_dat,M2Run,gomonth(M2Run,1) ) ) )


&&  				IF (.not. eof()) .And. (act_cust.totl_amt>1.00)
&&				IF (act_cust.totl_amt>1.00)
				IF (act_cust.totl_amt>1.00)
* wsh 09/04/2004 dumb fix for cp_30 vaporz
					STORE cp_30_temp TO cp_30
					STORE cs_30_temp TO cs_30
* wsh 09/04/2004 dumb fix for cp_30 vaporz
					REPO FORM act_cbil ALL FOR( (act_main.pickup_id=act_cust.pickup_id)  ) TO PRINTER
				ENDIF
&&				ENDIF
&&				M2Run=m2_temp		&&restore the m2run  *************  WSH 09/02/04 ************

&&				SET filter to  && release the filter on act_main
				SELE act_cust
				SET SKIP TO
			ENDIF

			IF (iz_once)  && bag out of printing
				GOTO BOTTOM
			ENDIF

			SKIP		&& do next commercial cust til eof
		ENDDO
		CLOSE DATA
		DO view_set
		ACTIVATE SCREEN
		CLEAR
		RETURN

***********************************************************************
* view set
***********************************************************************
	PROCEDURE view_set
		SET TALK OFF
*set status on
		SET SCOREBOARD OFF
		UNLOCK ALL
		CLOSE DATA
		FLUSH
		SELE 1
		USE act_main SHARED ORDER TAG invoice
		SELE 2
*		USE act_code SHARED ORDER TAG CODE     && wsh kill inde order 10/8/2004
		USE act_code SHARED
		SELE 3
		USE act_cust SHARED ORDER TAG pickup_id
*SELE 4
*USE sw_add shared ORDER TAG cust_id
		SELE 5
		USE act_pay SHARED ORDER TAG invoice
*SELE 6
*USE act_prov shared ORDER TAG id_provid
		SELE 7
		USE act_scr SHARED ORDER TAG invoice
		SELE 8
		USE act_uniq SHARED ORDER TAG ID
* SELE 9
* USE act_line shared ORDER TAG invoice
*****$*$**$*$*$**$*$*!*!*!*!**!*!*!*!*!*!*!*!*!*!*!**!*!*!
		SELE 1
		SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO act_cust ADDITIVE
		SET RELATION TO invoice INTO act_scr ADDITIVE
		SET RELATION TO VAL(ALLTRIM(invoice)) INTO act_pay ADDITIVE
		SET TALK OFF
		SET SCOREBOARD OFF
		RETURN


	PROCEDURE order_set
		SET TALK OFF
* set status on
		SET SCOREBOARD OFF

		SELE act_main
		SET ORDER TO invoice
&&		SELE act_code
		SELE act_cust
		SET ORDER TO pickup_id
*SELE sw_add
*SET ORDER TO cust_id
		SELE act_pay
		SET ORDER TO invoice
*SELE act_prov
*SET ORDER TO id_provid
		SELE act_scr
		SET ORDER TO invoice
		SELE act_uniq
		SET ORDER TO ID
*SELE act_line
*SET ORDER TO invoice

		SELE act_main

*SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO act_cust ADDITIVE
*SET RELATION TO invoice INTO act_scr ADDITIVE
*SET RELATION TO VAL(ALLTRIM(invoice)) INTO act_pay ADDITIVE
		UNLOCK ALL
		SET TALK OFF
		SET SCOREBOARD OFF
		RETURN


***********************************************************************
* re index all data files
***********************************************************************
	PROCEDURE reindxm
		PRIVATE u_ok2pack
		CLOSE DATA
** ||  ** ON ERROR
		PRIV A
		USE act_y SHARED
		SET ORDER TO 1
		SEEK [P2]
		STORE act_y->u_r TO u_ok2pack
		USE
		CLEAR
		PRIV e_nfound
		STORE .T. TO e_nfound
** ||  ** ON ERROR STORE .F. TO e_nfound
		SET EXCL ON
		USE act_main EXCL  && CAN i GET EXLUSIVE USE?
		USE act_cust EXCL
		USE act_pay EXCL
		CLOSE DATA
		SET EXCLUSIVE OFF
** ||  ** ON ERROR
		IF e_nfound=.T.
			?
			IF yesno( [ ReIndex Data Files? Yes/No])
				CLOSE ALL
*IF  nw_sft
*!*	      ! /n1 act_pac1.bat
*!*	      WAIT [Please wait while the original files are backed up.  Press <ENTER> to Continue]
*!*	      *ENDIF
				SET RESOURCE OFF
				SET EXCLUSIVE ON
				ACTIVATE SCREEN
				? [Reindexing data files...Please Wait.]
				SELE 1
				USE act_main
				SELE 2
				USE act_code
				SELE 3
				USE act_cust  &&*!*!*!
				SELE 5
				USE act_pay
*     SELE 6
*     USE act_prov ORDER TAG id_provid
				SELE 7
				USE act_scr
				SELE 8
				USE act_uniq
				SELE 9
				USE act_line   &&SET VIEW TO ACT
				SELE 10
				USE act_y
				PUBLIC count_var, temp,u_t
				SELE 1
				count_var=0
				DO WHILE .NOT. EMPTY(DBF())
					CLEAR
					STORE DBF() TO temp
					REINDEX
					count_var=count_var+1
					IF (count_var=4) .OR. (count_var=6)
						STORE count_var+1 TO count_var
					ENDIF
					SELE (count_var)
				ENDDO
				CLOSE DATA


				CLOSE DATA
				SELE 0
				USE ttax2mm EXCL
				INDE ON ALLTRIM(name_one)+" "+ALLTRIM(map) TAG name1map
				INDE ON  ALLTRIM(compound) TAG compound
				INDE ON ALLTRIM(lname)+" "+ALLTRIM(fname) TAG lnamefname
				INDE ON ALLTRIM(address)+" "+LEFT(zip,5)  TAG addrzip5
				INDE ON ALLTRIM(lname)+" "+LEFT(ALLTRIM(fname),3)+" "+LEFT(ALLTRIM(zip),5)  TAG LNAMEZIP5
				INDE ON ALLTRIM(lname)+" "+LEFT(ALLTRIM(fname),3) TAG LNAMEFN3





				SET EXCLUSIVE OFF
				IF nw_sft
					! /n1 act_pac2.bat
				ENDIF
			ENDIF  &&p
		ELSE
			WAIT [Unable to get exclusive use of the data files.]
		ENDIF  && if e_nfound

		SET EXCL OFF
		CLEAR
		DO view_set

		RETURN


***********************************************************************
* purgem
***********************
************************************************
	PROCEDURE purgem
		CLOSE DATA
** ||  ** ON ERROR
		PRIV A
		CLEAR
		PRIV e_nfound
		STORE .T. TO e_nfound
** ||  ** ON ERROR STORE .F. TO e_nfound
		SET EXCL ON
		USE act_main EXCL  && CAN i GET EXLUSIVE USE?
		USE act_cust EXCL
		USE act_pay EXCL
		CLOSE DATA
		SET EXCLUSIVE OFF
** ||  ** ON ERROR
		IF e_nfound=.T.
			?
			?
			?
			? [  Purge database files ? ]
			? [  This REQUIRES (!) single user access.  Single Access available ==>],e_nfound
			?
			ACCE [    Enter P TO Purge, OR press <ENTER>] TO A
			IF LEFT(A,1)$[Pp]
				CLOSE ALL
*IF  nw_sft
				! /n1 act_pac1.bat
				WAIT [Please wait while the original files are backed up.  Press <ENTER> to Continue]
*ENDIF
				SET RESOURCE OFF
				SET EXCLUSIVE ON
				ACTIVATE SCREEN
				? [Packing and Reindexing... Please Wait.]
				SELE 1
				USE act_main  ORDER TAG invoice
				SELE 2
				USE act_code
				SELE 3
				USE act_cust ORDER TAG pickup_id  &&*!*!*!
				SELE 5
				USE act_pay ORDER TAG invoice
*     SELE 6
*     USE act_prov ORDER TAG id_provid
				SELE 7
				USE act_scr  ORDER TAG invoice
				SELE 8
				USE act_uniq ORDER TAG ID
*      SELE 9
*      USE act_line ORDER TAG invoice  &&SET VIEW TO ACT

				PUBLIC count_var, temp,u_t
				SELE 1
				count_var=0
				DO WHILE .NOT. EMPTY(DBF())
					CLEAR
					STORE DBF() TO temp
					PACK
					REINDEX
					count_var=count_var+1
					IF (count_var=4) .OR. (count_var=6)
						STORE count_var+1 TO count_var
					ENDIF
					SELE (count_var)
				ENDDO
				CLOSE DATA
				SET EXCLUSIVE OFF
			ENDIF  &&p
		ELSE
			WAIT [Unable to get exclusive use of the data files.]
		ENDIF  && if e_nfound

		SET EXCL OFF
		CLEAR
		DO view_set

		RETURN





*********************************************************************************************
	PROCEDURE add_act
*********************************************************************************************
		PARAMETERS u_said
		PRIVATE ar_i, ar_j
* case support for the main menu options.
		UNLOCK ALL
		SET RESOURCE ON
		DO CASE
		CASE u_said=[A]  && Walk In from Records Menu
			SELE act_main
			SET ORDER TO TAG pickup_id  &&*!*!@

			SET RELATION OFF INTO act_cust
			SET RELATION OFF INTO act_pay

			SELE act_cust
			SET RELATION TO pickup_id INTO act_main
			SET RELATION TO pickup_id INTO act_pay

&& activate screen
*		DO act_inpa.spr  &&reutrns cur_cust,cur_invoice, and cur_claim
			DO FORM act_inpa


			CLOSE DATA

			DO view_set
*reset relations to default
*SELE act_cust
*SET RELATION OFF INTO act_main
*SET RELATION OFF INTO act_pay
*SET ORDER TO TAG pickup_id

* SELE act_pay
* SET ORDER TO TAG invoice

* SELE act_main
* SET ORDER TO TAG invoice

* SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO act_cust ADDITIVE

* SET RELATION TO VAL(ALLTRIM(invoice)) INTO act_pay ADDITIVE

		CASE u_said=[I]  &&Bills and Credits from Records menu

&& sele act_main  && WSH 9/7/1999 !@##@!

			SET ORDER TO TAG pickup_id  &&*!*!@
			SET RELATION OFF INTO act_cust
			SET RELATION OFF INTO act_pay

			SELE act_cust
			SET RELATION TO pickup_id INTO act_main
			SET RELATION TO pickup_id INTO act_pay

			SELE act_main
			CLEAR

* DO act_inpa.spr  &&reutrns cur_cust,cur_invoice, and cur_claim

*		DO act_main.spr  && was act_invo
			DO FORM act_main

&&  do act_invo.spr




*reset relations to default
			SELE act_cust
			SET RELATION OFF INTO act_main
			SET RELATION OFF INTO act_pay
			SET ORDER TO TAG pickup_id

			SELE act_pay
			SET ORDER TO TAG invoice
			SELE act_main
			SET ORDER TO TAG invoice
			SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO act_cust ADDITIVE
*SET RELATION TO VAL(ALLTRIM(invoice)) INTO act_pay ADDITIVE

			SELE act_main

		CASE u_said=[P]  && Post Payments from Record Menu
			SELE act_pay
			ar_i=add_1([PY])
			REPL act_pay.pay_rec_n WITH ar_i
*		DO act_pay.spr
			DO FORM act_pay
			SELE act_main
		CASE u_said=[C]  &&
			SELE act_cust
			ar_i= add_1([CU])
			REPL act_cust.pickup_id WITH ar_i  &&assign new ID
			REPL act_cust.district WITH [0]  && default to dist 0
*		DO act_adds.spr
			DO FORM act_adds
			SELE act_main
		ENDCASE

&& activate screen
&& flush
		CLEAR
		UNLOCK ALL
		SET RESOURCE OFF
		RETURN
***************************************************************************************
	PROCEDURE edit_act
**************************************************************************************
		PARAMETERS u_said
		PRIV az,bz,cz,iii
		SET RESOURCE ON
		DO CASE
		CASE u_said=[I]
			IF EOF()
				GOTO BOTTOM
			ENDIF
			SELE act_main
*		DO act_main.spr  &&  WAS ACT_INVO
			DO FORM act_main
			SELE act_main
			ACTIVATE SCREEN
			CLEAR
			DO scr_subtot  && sum up the counts, make the lists and values
			SELE act_main
*   IF EOF()
*      GOTO BOTTOM
*   ENDIF
*   DO act_find.spr
*   SELE act_clam
*!*	    CASE u_said=[P]
*!*	      SELE act_main
*!*	      SET ORDER TO TAG cust_id

*!*	      SET RELATION OFF INTO act_cust
*!*	      *  SET RELATION OFF INTO ACT_pay

*!*	      SELE act_cust
*!*	      SET RELATION TO pickup_id INTO act_main

*!*	      DO act_edpa.spr  &&reutrns cur_cust,cur_invoice, and cur_claim

*!*	      *reset relations to default
*!*	      SELE act_cust
*!*	      SET RELATION OFF INTO act_main
*!*	      SET ORDER TO TAG pickup_id
*!*	      SELE act_pay
*!*	      SET ORDER TO TAG invoice
*!*	      SELE act_main
*!*	      SET ORDER TO TAG invoice
*!*	      SET RELATION TO VAL(ALLTRIM(pickup_id)) INTO act_cust ADDITIVE
*!*	      SET RELATION OFF INTO act_pay    &&                     ??????????????????????????????????????????????
*!*	      SET RELATION TO VAL(ALLTRIM(invoice)) INTO act_pay ADDITIVE


		CASE u_said=[u]  &&Customer from Record Menu
			SELE act_cust
			STORE INT(RAND()*RECCOUNT()) TO iii &&goto random record!*!*!**!*!*!*!*!*!
			GOTO iii
			IF EOF()
				GOTO BOTTOM
			ENDIF
*		DO act_adds.spr
			DO FORM act_adds
			SELE act_main
		ENDCASE
		ACTIVATE SCREEN
		FLUSH
		UNLOCK ALL  &&*!*!..
		SET RESOURCE OFF

		CLEAR
		RETURN


**********************************************************************************************************
	PROCEDURE report_act
***********************************************************************************************************
		PARAMETERS u_said
		PRIV start_, end_i,wuz_near,wuz_xact, daze_a, daze_b,n_part,c_part,n_tmp,city_part,R_I,r_j,r_k
		STOR SELE() TO cur_sele
		STORE ORDER() TO curorder
		oldrec=RECNO()

		DO CASE

		CASE u_said=[o]
			SELE act_cust
			STORE ORDER() TO c_tmp
			SET FILTER TO
			REPL ALL compound WITH ""
			REPL ALL compound WITH ALLTRIM(street)
			SET FILTER TO LEN(ALLTRIM(street))>0
			REPL ALL compound WITH UPPER(SUBSTR(ALLTRIM(street),AT(' ',ALLTRIM(street))+1)+PADL(LEFT(ALLTRIM(street),AT(' ',ALLTRIM(street))),8,' ')) FOR (SUBSTR(ALLTRIM(street), 1,1 )$[0123456789])

&&repl all compound with alltrim(upper(substr(alltrim(street),at(' ',alltrim(street)))+padl(left(alltrim(street),at(' ',alltrim(street))),6,' ')) for (substr(alltrim(street), 1,1 )$[0123456789]))
			SET FILTER TO
			SET ORDER TO TAG compound
			GO TOP
			REPORT FORM act_cusp TO PRINTER
			SET ORDER TO (c_tmp)

		CASE u_said=[p]
			SELE act_cust
			STORE ORDER() TO c_tmp
			SET FILTER TO
			REPL ALL compound WITH ""
			REPL ALL compound WITH ALLTRIM(street)
			SET FILTER TO LEN(ALLTRIM(street))>0
			REPL ALL compound WITH UPPER(ALLTRIM(city)+SUBSTR(ALLTRIM(street),AT(' ',ALLTRIM(street))+1)+PADL(LEFT(ALLTRIM(street),AT(' ',ALLTRIM(street))),8,' ')) FOR (SUBSTR(ALLTRIM(street), 1,1 )$[0123456789])
&& repl all compound with alltrim(upper(alltrim(city)+substr(alltrim(street),at(' ',alltrim(street)))+padl(left(alltrim(street),at(' ',alltrim(street))),6,' ')) for (substr(alltrim(street), 1,1 )$[0123456789]))
			SET FILTER TO
			SET ORDER TO TAG compound
			GO TOP
			REPORT FORM act_cusp TO PRINTER
			SET ORDER TO (c_tmp)

		CASE u_said=[G]
			SELE act_pay
			STORE ORDER() TO c_tmp
			DO msg2user WITH [ ]
			ACTIVATE WINDOW msg2user
			CLEAR
			STORE DTOC(DATE()) TO daze_a
			ACCE [Enter Paid Date to start reporting Payments (]+daze_a+[) ==>] TO daze_a
			IF (LEN(daze_a)>5)
				STORE CTOD(daze_a) TO start_d
			ELSE
				STORE DATE() TO start_d
			ENDIF
			ACCE [Enter Paid Date to stop reporting Payments (]+daze_a+[) ==>] TO daze_a
			IF (LEN(daze_a)>5)
				STORE CTOD(daze_a) TO end_d
			ELSE
				STORE DATE() TO end_d
			ENDIF
			CLEAR
			DO msg2user WITH [CLOSE]

			SET ORDER TO TAG date_paid
&&  SET FILTER TO pay_src=1
			REPORT FORM act_acda TO PRINTER FOR BETWEEN(act_pay.date_paid,start_d,end_d)
			SET FILTER TO
			SET ORDER TO (c_tmp)
			SELE act_main

		CASE u_said=[C]
			SELE act_code
			GO TOP
			REPORT FORM act_code TO PRINTER
			SELE act_main
		CASE u_said=[P]
*   SELE act_prov
*   STORE ORDER() TO c_tmp
*
*   SET ORDER TO TAG id_provid
*   REPORT FORM act_prov TO PRINTER
*   SET ORDER TO (c_tmp)
*   SELE act_main
		CASE u_said=[I]
			SELE act_main
			STORE ORDER() TO c_tmp

			SET ORDER TO TAG invoice
			SET SKIP TO act_scr
			GO BOTTOM
			STORE invoice TO end_i
			GO TOP
			STOR invoice TO start_i

			DO msg2user WITH [ ]
			ACTIVATE WINDOW msg2user
			CLEAR
			ACCE [  Enter the Invoice # to start printing. (Numeric Order)==>] TO start_i
			CLEAR
			ACCE [  Enter the Invoice # to stop printing ==>] TO end_i
			CLEAR
			DO msg2user WITH [CLOSE]
			R_I="SEEK VAL(ALLTRIM(["+ALLTRIM(start_i)+"]))"
			&R_I
			IF FOUND()
				REPORT FORM act_invo TO PRINTER FOR BETWEEN(VAL(ALLTRIM(act_main.invoice)),VAL(ALLTRIM(start_i)),VAL(ALLTRIM(end_i)))
			ELSE
				OK=yesno([ERROR:  starting invoice NOT found.  Invoice=>]+invoice)
			ENDIF
			SET ORDER TO (c_tmp)
			SELE act_main
			SET SKIP TO

		CASE u_said=[u]
			SELE act_main
			STORE ORDER() TO c_tmp
&& was cust_id wsh 10/01/04
			SET ORDER TO TAG pickup_id
			GO BOTTOM
			STORE cust_id TO end_i
			GO TOP
			STOR cust_id TO start_i
			DO msg2user WITH [ ]
			ACTIVATE WINDOW msg2user
			CLEAR
			ACCE [ Enter Customer ID to start. (Lexical Order)==>] start_i
			CLEAR
			ACCE [ Enter the Customer ID to stop printing ==>] TO end_i
			CLEAR
			DO msg2user WITH [CLOSE]
			SEEK start_i
			IF FOUND()
				SET SKIP TO act_cust
				REPORT FORM act_invo TO PRINTER FOR BETWEEN(ALLTRIM(cust_id),ALLTRIM(start_i),ALLTRIM(end_i))
				SET SKIP TO
			ELSE
				OK=yesno([ERROR: Starting Customer NOT found.  Customer ID=>]+start_i)
			ENDIF
			SET ORDER TO (c_tmp)
		CASE u_said=[s]

			SELE act_cust
			STORE ORDER() TO c_tmp

			SET ORDER TO TAG pickup_id

			GO BOTTOM
			STORE pickup_id TO end_i
			GO TOP
			STOR pickup_id TO start_i
			DO msg2user WITH [ ]
			ACTIVATE WINDOW msg2user
			CLEAR
			ACCE [ Enter Customer ID to start. (Numeric Order)==>] TO  start_i
			CLEAR
			ACCE [ Enter the Customer ID to stop printing ==>] TO end_i
			CLEAR
			DO msg2user WITH [CLOSE]
			SEEK VAL(ALLTRIM(start_i))
			IF FOUND()
				REPORT FORM act_cust TO PRINTER FOR BETWEEN(VAL(ALLTRIM(pickup_id)),VAL(ALLTRIM(start_i)),VAL(ALLTRIM(end_i)))
			ELSE
				OK=yesno([ERROR: Starting Customer NOT found.  Customer ID=>]+start_i)
			ENDIF
			SET ORDER TO (c_tmp)
			SELE act_main
		CASE u_said=[A]

			SELE act_pay
			STORE ORDER() TO c_tmp

			SET ORDER TO TAG invoice

			GO BOTTOM
			STORE invoice TO end_i
			GO TOP
			STOR invoice TO start_i
			DO msg2user WITH [ ]
			ACTIVATE WINDOW msg2user
			CLEAR
			ACCE  [ Enter the Invoice to start. (Numeric Order)==>] TO start_i
			CLEAR
			ACCE [ Enter the Invoice to stop printing Payments ==>] TO end_i
			CLEAR
			DO msg2user WITH [CLOSE]
			R_I="SEEK VAL(ALLTRIM(["+ALLTRIM(start_i)+"]))"
			&R_I
			IF FOUND()
				REPORT FORM act_paya TO PRINTER FOR BETWEEN(VAL(ALLTRIM(invoice)),VAL(ALLTRIM(start_i)),VAL(ALLTRIM(end_i)))
			ELSE
				OK=yesno([ERROR: Starting Invoice not found.  Invoice=>]+start_i)
			ENDIF
			SET ORDER TO (c_tmp)

			SELE act_main
		CASE u_said=[y]
			SELE act_pay
			STORE ORDER() TO c_tmp

			SET ORDER TO TAG payr_id_in
			GO BOTTOM
			STORE id_of_payr TO end_i
			GO TOP
			STOR id_of_payr TO start_i
			DO msg2user WITH [ ]
			ACTIVATE WINDOW msg2user
			CLEAR
			ACCE [ Enter the Customer ID to start printing Payments ==>] TO start_i
			CLEAR
			ACCE [ Enter the Customer ID to stop printing Payments ==>] TO end_i
			CLEAR
			DO msg2user WITH [CLOSE]
			STORE SET("Near") TO wuz_near
			STORE SET("exact") TO wuz_xact
			SET NEAR OFF
			SET EXACT OFF
			SEEK ALLTRIM(start_i)+[.]
			IF FOUND()
				REPORT FORM act_payy TO PRINTER FOR BETWEEN(ALLTRIM(id_of_payr)+[.],ALLTRIM(start_i)+[.],ALLTRIM(end_i)+[.])
			ELSE
				OK=yesno([ERROR: Starting Payer not found.  Payer ID=>]+ALLTRIM(start_i)+[.])
			ENDIF
			SET NEAR &wuz_near
			SET EXACT &wuz_xact

			SET ORDER TO (c_tmp)

			SELE act_main

		CASE u_said=[m]
			SELE act_pay
			STORE ORDER() TO c_tmp
			SET ORDER TO TAG date_paid
			GO BOTTOM
			DO msg2user WITH [ ]
			ACTIVATE WINDOW msg2user
			CLEAR

			STORE DTOC(DATE()) TO daze_a
			ACCE [Enter Paid Date to start reporting Payments ]+daze_a+[ ==>] TO daze_a
			IF (LEN(daze_a)>5)
				STORE CTOD(daze_a) TO start_d
			ELSE
				STORE DATE() TO start_d
			ENDIF
			ACCE [Enter Paid Date to stop reporting Payments (]+daze_a+[) ==>] TO daze_a
			IF (LEN(daze_a)>5)
				STORE CTOD(daze_a) TO end_d
			ELSE
				STORE DATE() TO end_d
			ENDIF
			CLEAR
			DO msg2user WITH [CLOSE]

			SEEK start_d
			IF FOUND()
				REPORT FORM act_paym TO PRINTER FOR BETWEEN(act_pay.date_paid,start_d,end_d)
			ELSE
				OK=yesno([ERROR: Starting date not found.  Date=>]+DTOC(start_d))
			ENDIF
			SET ORDER TO (c_tmp)
			SELE act_main

		CASE u_said=[E]
			SELE act_pay
			STORE ORDER() TO c_tmp
			SET ORDER TO TAG pic_id_i  && *!*!*!
			GO BOTTOM
			STORE pickup_id TO end_i
			GO TOP
			STOR pickup_id TO start_i
			DO msg2user WITH [ ]
			ACTIVATE WINDOW msg2user
			CLEAR
			ACCE  [ Enter the Pickup ID to start. (Lexical Order)==>] TO start_i
			CLEAR
			ACCE [ Enter the Pickup ID to stop printing Payments ==>] TO end_i
			CLEAR
			DO msg2user WITH [CLOSE]
			STORE SET("Near") TO wuz_near
			STORE SET("exact") TO wuz_xact
			SET NEAR OFF
			SET EXACT OFF

			SEEK ALLTRIM(start_i)+[.]
			IF FOUND()
				REPORT FORM act_paye TO PRINTER FOR BETWEEN(ALLTRIM(pickup_id)+[.],ALLTRIM(start_i)+[.],ALLTRIM(end_i)+[.])
			ELSE
				OK=yesno([ERROR: Starting Pickup not found.  Pickup ID=>]+ALLTRIM(start_i)+[.])
			ENDIF

			SET NEAR &wuz_near
			SET EXACT &wuz_xact

			SET ORDER TO (c_tmp)
			SELE act_main
		ENDCASE

		CLEAR

		SELECT (cur_sele)
		SET ORDER TO (curorder)
		UNLOCK ALL
		RETURN



******************************************************************************
	PROCEDURE util_res
		CLOSE DATA
** ||  ** ON ERROR
		PRIV A
		CLEAR
		PRIV e_nfound
		STORE .T. TO e_nfound
** ||  ** ON ERROR STORE .F. TO e_nfound
		SET EXCL ON
		USE act_main EXCL  && CAN i GET EXLUSIVE USE?
		USE act_cust EXCL
		USE act_pay EXCL
		CLOSE DATA
		SET EXCLUSIVE OFF
** ||  ** ON ERROR
		IF e_nfound=.T.
			?
			?
			?
			? [  Restore database files ? ]
			? [  This REQUIRES (!) single user access.  Single Access available ==>],e_nfound
			? [  WARNING!!  This procedure will destroy your current data files and replace them]
			? [  with the backup files.]
			?
			ACCE [    Enter R TO Restore or press <ENTER>] TO A
			IF LEFT(A,1)$[Rr]
				CLOSE ALL
				! /n1 act_res.bat
				WAIT [Please wait while the original files are backed up.  Press <ENTER> to Continue]
*ENDIF
			ENDIF  &&p
		ELSE
			WAIT [Unable to get exclusive use of the data files.]
		ENDIF  && if e_nfound

		SET EXCL OFF
		CLEAR
		DO view_set

		RETURN








*********************************************************************************************
*********************************************************************************************
	PROCEDURE util_pla
*********************************************************************************************
*********************************************************************************************
		PRIVATE ua,ub,uc,ud,ue

* make a new playground

		CLOSE DATA
** ||  ** ON ERROR
		PRIV A
		CLEAR
		PRIV e_nfound
		STORE .T. TO e_nfound
** ||  ** ON ERROR STORE .F. TO e_nfound
		SET EXCL ON
		USE act_main EXCL  && CAN i GET EXLUSIVE USE?
		USE act_cust EXCL
		USE act_pay EXCL
		CLOSE DATA
		SET EXCLUSIVE OFF
** ||  ** ON ERROR
		IF e_nfound=.T.
TEXT
		Create a new playground ?

		When you run this routine, you will get an error message popup
		telling you that a file cannot be copied.  Answer Ignore to that
		popup.  We have to move this program by hand, when we make the icon,
		below

		The Playground is a working copy of the ACT program in a safe
		directory.  You can try out ideas, practice, and test anything you like
		in the playground.  It is best to keep your playground current, to keep
		up with any changes to the ACT system, and to get the most accurate
		testing.

		You must give a Drive: letter for the playground.  It is typically C:,
		but any drive with enough free space will do. You will duplicate
		your system as it is right now.

		You must make your own shortcut/link/icon to the playground
		and copy act_.exe there by hand.  Do this from "My Computer",
		when this program is not running.

		If you choose drive C:, create playground with:
		     copy act_.exe C:\playground\playground.exe
		or use drag and drop to do the same copy.

		Run Playground as:
			C:\playground\playground.exe
		This is also the application to shortcut to when you add the icon
		to your desktop. If you have chosen a different drive letter,
		use that instead of the C: above.

		This REQUIRES (!) Single User User Access.

ENDTEXT

			?   [Single Access available  ==>], e_nfound
			ACCE [    Enter Drive Letter (C:) to make a new playground, or press <ENTER> to quit ==> ] TO A
			STORE  UPPER(LEFT(A,1)) TO ua
			IF ua $ [CDEFGHIJKLMNOPQRSTUVWXYZ]
				CLOSE ALL
				ub=ua+[:\playground]
				uc=ub+[\*.*]
				IF (.NOT. DIRECTORY([&ub]))

					MKDIR [&ub]
				ELSE
					DELETE FILE &uc
					WAIT [Please wait while the original files are backed up.  Press <ENTER> to Continue]
				ENDIF
				COPY FILE *.* TO &uc
			ENDIF  &&p
		ELSE
			WAIT [Unable to get exclusive use of the data files.]
		ENDIF  && if e_nfound

		SET EXCL OFF
		CLEAR
		DO view_set
		RETURN










**********************************************************************************************
	PROCEDURE util_bak

		CLOSE DATA
** ||  ** ON ERROR
		PRIV A
		CLEAR
		PRIV e_nfound
		STORE .T. TO e_nfound
** ||  ** ON ERROR STORE .F. TO e_nfound
		SET EXCL ON
		USE act_main EXCL  && CAN i GET EXLUSIVE USE?
		USE act_cust EXCL
		USE act_pay EXCL
		CLOSE DATA
		SET EXCLUSIVE OFF
** ||  ** ON ERROR
		IF e_nfound=.T.
			?
			?
			?
			? [  Backup database files ? ]
			? [  This REQUIRES (!) Single User User Access.  Single Access available ==>],e_nfound
			?
			ACCE [    Enter B to Backup the data files, or press <ENTER>] TO A
			IF LEFT(A,1)$[Bb]
				CLOSE ALL
				IF (.NOT. (DIRECTORY([.\bak1])))
					MKDIR [.\bak1]
					MKDIR [.\bak1\bak2]

				ELSE
					! /n1 act_bak.bat
					WAIT [Please wait while the original files are backed up.  Press <ENTER> to Continue]
				ENDIF
			ENDIF  &&p
		ELSE
			WAIT [Unable to get exclusive use of the data files.]
		ENDIF  && if e_nfound

		SET EXCL OFF
		CLEAR
		DO view_set
		RETURN


	PROCEDURE util_act
		PARAMETERS u_said
		PRIVATE u_t,u_tt
		DO CASE
		CASE u_said=[A]  && add new provider record
*
*   SELE act_uniq
*   SEEK [PR]
*   IF (FOUND() .AND. RLOCK())
*      REPL COUNT WITH COUNT+1
*      STORE COUNT TO count_var
*      UNLOCK
*   ENDIF
*   SELE act_prov
*  APPEND BLANK
*   REPL id_provid WITH count_var
*   DO act_prov.spr

		CASE u_said=[D] && Utility Menu, Edit Services and Price
			SELE act_code
			APPEND BLANK
			GOTO BOTTOM
			BROWSE TITLE [Add/Edit Items, Services, Codes and Prices]
			FLUSH
			DO build_inv_screen  &&copy the info in codes dbf into ACT_line,
&&3cols wide, this copys to ACT_scr and invoice
		CASE u_said=[E]
*   SELE act_prov
*   SET ORDER TO tad id_provid
*   BROWSE FIELDS  name,ssn  NOAPPEND TITLE [Edit Service Provider Information]
		CASE u_said=[d]  && Add services Utility Menu
			SELE act_code
			BROW TITLE [Edit Items, Services, Codes and Prices]
			FLUSH
			DO build_inv_screen
		CASE u_said=[P]  && Reindex Utility Menu
			DO reindxm
		CASE u_said=[a]  &&Pack and Purge, Utility Menu
			DO purgem
		ENDCASE
		CLEAR
		UNLOCK ALL
		RETURN




***********************************************************************
* END MAIN Menu Support
***********************************************************************
***********************************************************************
* MAIN Menu Support
**********************************************************************
***********************************************************************
* MAIN Menu Support
***********************************************************************

	PROCEDURE scr_subtot
* Returns subtotal of current invoice, sets global subdisc
		PRIVATE mrecno, t_sub, subtot, area, curorder, cur_disc,cur_filter,s1,s2,s3,nd,ns,ib_z
		PRIV s_l,p_l,c_l,d_l
		STORE [] TO s_l,p_l,c_l,d_l
* SET STATUS BAR OFF

		STORE 0 TO ns,s1,s2,s3
		STORE 0 TO nd
		STORE 0 TO subtot,t_sub
		STORE 0 TO subdisc
		SELE act_main
		STORE invoice TO area
		IF ( .NOT. BOF())  && SNAG FIRST RELATED SCR
			SKIP-1
			SKIP
		ELSE
			SKIP
			SKIP-1
		ENDIF
		SELE act_scr

*set skip to ACT_scr

&&get a total for all scr across invoice  i-many....
*     SELE ACT_scr  &&should reset to top of list
		DO WHILE (act_scr->invoice =area) .AND. ( .NOT. EOF())
			IF ( .NOT. EMPTY(act_scr.c1))
				IF act_scr.p1<=0.
					nd=nd+1
					d_l=act_scr.code1+[|]+d_l
				ELSE
					ns=ns+1
					s1=s1+act_scr.c1*act_scr.p1
					s_l=act_scr.code1+[ *|* ]+s_l
					p_l=STR(act_scr.p1,16,6)+[ =|= ]+p_l
					c_l=STR(act_scr.c1,16,6)+[ + ]+c_l      &&  NB HEY THESE PLUS SIGNS ARE IMPORTANT TO ACT_WHI TAX BILL REPORTS
*					p_l=STR(act_scr.p1,7,2)+[ |]+p_l
*					c_l=STR(act_scr.c1,7,2)+[|]+c_l
				ENDIF
			ENDIF
			IF ( .NOT. EMPTY(act_scr.c2))
				IF act_scr.p2<=0.
					nd=nd+1
					d_l=act_scr.code2+[|]+d_l
				ELSE
					ns=ns+1
					s2=s2+act_scr.c2*act_scr.p2
					s_l=act_scr.code2+[ *|* ]+s_l
					p_l=STR(act_scr.p2,16,6)+[ =|= ]+p_l
					c_l=STR(act_scr.c2,16,6)+[ + ]+c_l     &&  NB HEY THESE PLUS SIGNS ARE IMPORTANT TO ACT_WHI TAX BILL REPORTS
*					p_l=STR(act_scr.p2,7,2)+[ |]+ p_l
*					c_l=STR(act_scr.c2,7,2)+[|]+c_l
				ENDIF
			ENDIF
			IF ( .NOT. EMPTY(act_scr.c3))
				IF act_scr.p3<=0.
					nd=nd+1
					d_l=act_scr.code3+[|]+d_l
				ELSE
					ns=ns+1
					s3=s3+act_scr.c3*act_scr.p3
					s_l=act_scr.code3+[ *|* ]+s_l
					p_l=STR(act_scr.p3,16,6)+[ =|= ]+p_l
					c_l=STR(act_scr.c3,16,6)+[ + ]+c_l		     &&  NB HEY THESE PLUS SIGNS ARE IMPORTANT TO ACT_WHI TAX BILL REPORTS
*					p_l=STR(act_scr.p3,7,2)+[ |]+ p_l
*					c_l=STR(act_scr.c3,7,2)+[|]+c_l
				ENDIF
			ENDIF
			IF .NOT. EOF()
				SKIP
			ENDIF
		ENDDO
&& GET ALL THE service x price
		subtot=s1+s2+s3

*set skip to      &&turn off the one to many...

		SELE act_main

*seek area    &&get back to orig rec

		REPLACE act_main.total_amt WITH subtot
		REPLACE act_main.srvc_list WITH s_l
		REPLACE act_main.pric_list WITH p_l
		REPLACE act_main.coun_list WITH c_l
		REPLACE act_main.item_list WITH d_l
		REPLACE act_main.num_item WITH nd
		REPLACE act_main.num_srvcs WITH ns

		RETURN

***********************************************************************
* function in_set  && valids for ACT_cust and any char list
***********************************************************************
	FUNCTION in_set
		PARAMETER a_a, a_b
		IF .NOT. (a_a$a_b)
			??CHR(7),CHR(7)
			a_a=[ ]
		ENDIF
		RETURN a_a

***********************************************************************
* procedure load_Inv_screen
***********************************************************************
	PROCEDURE load_inv_screen
		PRIVATE l_i,l_j,l_k
		FOR l_i=1 TO ALEN(l_a,1)
			l_a(l_i,1)=act_main->invoice
		ENDFOR
		SELE act_scr
		APPEND FROM ARRAY l_a
		RETURN

********************************************************************************
********************************************************************************
********************  Support  for              ********************************
********************  Invoice Browsers          ********************************
********************                            ********************************
********************************************************************************
********************************************************************************

********************************************************************************
********************************************************************************
********************  END                      ********************************
********************  Invoice Browsers          ********************************
********************                            ********************************
********************************************************************************
********************************************************************************

	PROCEDURE build_inv_screen
		PRIVATE l_i,l_j,l_k
		CLEAR
		? [PLEASE WAIT:  REBUILDING INVOICE SCREEN...]
*loads the new invoice screen codes,items, and prices to the invoice page.

		SELE 9
		USE act_line SHARED ORDER TAG invoice

*SELE act_line
		GO TOP
		DELE REST
		APPEND BLANK
*    REPL invoice WITH ACT_main->invoice
		SELE act_code
		GO TOP

		l_i=1
		DO WHILE .NOT. EOF()
			IF .NOT. EOF()
*      REPL ACT_line->c1 WITH ACT_code->COUNT
				REPL act_line->i1 WITH ITEM
				REPL act_line->code1 WITH CODE
				REPL act_line->p1 WITH price
				SKIP
			ENDIF
			IF .NOT. EOF()
*      REPL ACT_line->c2 WITH COUNT
				REPL act_line->i2 WITH ITEM
				REPL act_line->code2 WITH CODE
				REPL act_line->p2 WITH price
				SKIP
			ENDIF
			IF .NOT. EOF()
*      REPL ACT_line->c3 WITH COUNT
				REPL act_line->i3 WITH ITEM
				REPL act_line->code3 WITH CODE
				REPL act_line->p3 WITH price
				SKIP
			ENDIF
			IF .NOT. EOF()
				SELE act_line
				APPEND BLANK
*      REPL invoice WITH ACT_main->invoice
				SELE act_code
			ENDIF
		ENDDO
		CLEAR
*loads the new invoice screen codes ,items and prices to the invoice page.
		SELE act_line
		COPY TO ARRAY l_a
		FOR l_i=1 TO ALEN(l_a,1)
			l_a(l_i,1)=act_main->invoice
		ENDFOR

		USE

		SELE act_main
		RETURN



&&******************************************************************************************************
	PROCEDURE act_filz
		PARAMETER action
		PRIVATE lz_a,lz_b
		DO CASE
		CASE action=1
			IF .NOT. EOF()
				SKIP
				SHOW GETS
				UNLOCK ALL
			ENDIF
*next record
		CASE action=2
			IF .NOT. BOF()
				SKIP -1
				SHOW GETS
				UNLOCK ALL
			ENDIF
*Previous record
		CASE action=3
			GO TOP
			SHOW GETS
			UNLOCK ALL
*Top
		CASE action=4
			GO BOTTOM
			SHOW GETS
			UNLOCK ALL
* go bottom
*Bottom
		CASE action=5
			STORE SELECT() TO lz_a
			DO CASE
			CASE lz_a=1 &&main
				SELE act_scr
				DELE REST FOR invoice=act_main.invoice
				SELE act_main
				DELE NEXT 1
				IF EOF()
					GOTO BOTTOM
				ENDIF
			CASE lz_a=2 &&code
				DELETE NEXT 1
				IF EOF()
					GOTO BOTTOM
				ENDIF
			CASE lz_a=3  &&cust
				DELETE NEXT 1
				IF EOF()
					GOTO BOTTOM
				ENDIF
*CASE lz_a=4  &&clam
*  DELETE NEXT 1
*  IF EOF()
*     GOTO BOTTOM
*  ENDIF
			CASE lz_a=5  &&pay

				STOR SELE() TO cur_sele
				SELE 25
				USE act_x SHARED
				APPEND BLANK
				REPL u_name WITH ur
				REPL DATE WITH DATE()
				REPL u_when WITH TIME()
				REPL u_what WITH [Pd]
				REPL u_where WITH LEFT(SYS(0),10)
				REPL u_seq WITH act_pay.pickup_id
				USE
				SELECT cur_sele

				DELETE NEXT 1
				IF EOF()
					GOTO BOTTOM
				ENDIF
			CASE lz_a=6  &&prov
				DELETE NEXT 1
				IF EOF()
					GOTO BOTTOM
				ENDIF
			ENDCASE
			SHOW GETS
			UNLOCK ALL
		ENDCASE

		RETURN .T.

***********************************************
	PROCEDURE act_finz
***********************************************
		PARAMETER subchoice
		PRIVATE mrecno, subtot, area, curorder,custm,custordr,cpullinv,ho_k,partt,;
			cur_x, cur_sele,c_tmp, c_date, c_old, cur_win
		ho_k=.F.
		SET RESOURCE OFF
		STOR SELE() TO cur_sele
		STORE ORDER() TO curorder
		oldrec=RECNO()
*store wontop() to cur_win
*activate screen

		SET EXACT OFF
		SET NEAR ON
DEFINE WINDOW syserror   FROM 05,00 TO 16,77 FLOAT GROW ZOOM CLOSE COLOR SCHEME 7
DO CASE

CASE subchoice=1
TEXT  &&*!*!*!
   * CUST X SSN

   SELE act_cust
   STORE ORDER() TO c_tmp

   SET ORDER TO cu_ssn
   STORE RECNO() TO c_old
   DO msg2user WITH [FIND:  ]
   STORE SPACE(16) TO cpullinv
   activate window msg2user
   clear gets
   @ 1,3 SAY 'What SSN number do you want?' GET cpullinv  COLOR SCHEME 7
   READ
   DO msg2user WITH [CLOSE]
   IF ((cpullinv<=[      ]) .OR. (LASTKEY()=27))
      GOTO c_old
   ELSE
      ON KEY LABEL f10 KEYBOARD CHR(23)
      SEEK ALLTRIM(cpullinv)
      IF  FOUND()
   		DO FORM act_adds
*   		DO act_adds.spr
*         !* !*         DO act_cuae.spr
      ELSE
         BROWSE NORMAL NODELETE window syserror;
            FIELDS ssn, pickup_id, lname:15, fname:15,phone,dob;
            TITLE act_titl
      ENDIF
   ENDIF
   SET ORDER TO (c_tmp)
   SELECT (cur_sele)
   SET ORDER TO (curorder)
ENDTEXT  && *!*!*!
CASE subchoice=2
	SELE act_cust
	STORE ORDER() TO c_tmp
	SET ORDER TO TAG Phone  &&*!*!*!
	STORE RECNO() TO c_old
	DO msg2user WITH [FIND:  ]

	STORE SPACE(16) TO cpullinv
	ACTIVATE WINDOW msg2user
	CLEAR GETS
	@ 1,3 SAY 'What phone number do you want?' GET cpullinv  COLOR SCHEME 7
	READ
	DO msg2user WITH [CLOSE]
	IF ((cpullinv<=[      ]) .OR. (LASTKEY()=27))
		GOTO c_old
	ELSE
		ON KEY LABEL f10 KEYBOARD CHR(23)
		SEEK ALLTRIM(cpullinv)
		IF  FOUND()
*			DO act_adds.spr
			DO FORM act_adds
		ELSE
			BROWSE NORMAL NODELETE WINDOW syserror;
				FIELDS Phone, pickup_id, lname:15, fname:15,zip,dob NOEDIT ;
				TITLE act_titl
		ENDIF
	ENDIF
	SET ORDER TO (c_tmp)
	SELECT (cur_sele)
	SET ORDER TO (curorder)


CASE subchoice=3
	SELE act_cust
	STORE ORDER() TO c_tmp
	SET ORDER TO TAG dob  &&*!*!*!
	STORE RECNO() TO c_old
	DO msg2user WITH [FIND:  ]

	STORE DATE() TO c_date
	ACTIVATE WINDOW msg2user
	CLEAR GETS
	@ 1,3 SAY 'What Date of Birth do you want?' GET c_date  COLOR SCHEME 7
	READ
	DO msg2user WITH [CLOSE]
	IF ((EMPTY(c_date)) .OR. (LASTKEY()=27))
		GOTO c_old
	ELSE
		SEEK c_date
		IF  FOUND()

*			DO act_adds.spr
			DO FORM act_adds

		ELSE
			ON KEY LABEL f10 KEYBOARD CHR(23)

			BROWSE NORMAL NODELETE WINDOW syserror;
				FIELDS dob, pickup_id, lname:15, fname:15,Phone,zip NOEDIT ;
				TITLE act_titl

		ENDIF

	ENDIF
	SET ORDER TO (c_tmp)
	SELECT (cur_sele)
	SET ORDER TO (curorder)

CASE subchoice = 4
	SELE act_cust
	STORE ORDER() TO c_tmp
	SET ORDER TO TAG lname  &&*!*!*!*!
	STORE RECNO() TO c_old
	DO msg2user WITH [FIND:  ]

	STORE SPACE(25) TO cpullinv
	ACTIVATE WINDOW msg2user
	CLEAR GETS
	@ 1,3 SAY 'What Last Name do you want?' GET cpullinv  COLOR SCHEME 7
	READ
	DO msg2user WITH [CLOSE]
	IF ((cpullinv<=[      ]) .OR. (LASTKEY()=27))
		GOTO c_old
	ELSE
		SEEK cpullinv
		IF  FOUND()
			DO FORM act_adds
*			DO act_adds.spr
		ELSE
			BROWSE NORMAL NODELETE WINDOW syserror;
				FIELDS pickup_id, lname:15, fname:15, Phone,zip,dob NOEDIT ;
				TITLE act_titl

		ENDIF
	ENDIF
	SET ORDER TO (c_tmp)
	SELECT (cur_sele)
	SET ORDER TO (curorder)


CASE subchoice=5
	SELE act_main
	STORE ORDER() TO c_tmp
	SET ORDER TO TAG invoice  &&*!*!*!*
	STORE RECNO() TO c_old
	DO msg2user WITH [FIND:  ]

	STORE SPACE(10) TO cpullinv
	ACTIVATE WINDOW msg2user
	CLEAR GETS
	@ 1,3 SAY 'What Invoice do you want?' GET cpullinv  COLOR SCHEME 7
	READ
	DO msg2user WITH [CLOSE]
	IF ((cpullinv<=[      ]) .OR. (LASTKEY()=27))
		GOTO c_old
		SET ORDER TO (c_tmp)
	ELSE
		SEEK VAL(ALLTRIM(cpullinv))
		ON KEY LABEL f10 KEYBOARD CHR(23)
		BROWSE NORMAL NODELETE LAST;
			FIELDS invoice, pickup_id, lname:15, fname:15,Phone,srvc_dat,rev_date,item_list NOEDIT ;
			TITLE act_titl
		IF (EOF() .OR. BOF()) && avoid eof/bof condition
			GOTO TOP
		ENDIF

		STORE act_main.pickup_id TO fnz_rtn  &&grab ID

		SET ORDER TO (c_tmp)  && restore state
		SELECT (cur_sele)     && restore state

		SET ORDER TO TAG pickup_id  && try to find ID
		SEEK ALLTRIM(fnz_rtn)  && end up somewhere
	ENDIF

	STOR SELE() TO cur_sele
	STORE ORDER() TO (curorder)


CASE subchoice=6
	SELE act_main
	STORE ORDER() TO c_tmp
	SET ORDER TO TAG srvc_dat  && *!*!*!*
	STORE RECNO() TO c_old

	DO msg2user WITH [FIND:  ]

	STORE DATE() TO c_date
	ACTIVATE WINDOW msg2user
	CLEAR GETS
	@ 1,3 SAY 'What Invoice Date do you want?' GET c_date  COLOR SCHEME 7
	READ
	DO msg2user WITH [CLOSE]
	IF ((EMPTY(c_date)) .OR. (LASTKEY()=27))
		GOTO c_old
		SET ORDER TO (c_tmp)
	ELSE
		SEEK c_date
		ON KEY LABEL f10 KEYBOARD CHR(23)
		BROWSE NORMAL NODELETE LAST;
			FIELDS srvc_dat,invoice, pickup_id, lname:15, fname:15,Phone,rev_date,item_list NOEDIT ;
			TITLE act_titl


		IF (EOF() .OR. BOF()) && avoid eof/bof condition
			GOTO TOP
		ENDIF

		STORE act_main.pickup_id TO fnz_rtn  &&grab ID

		SET ORDER TO (c_tmp)  && restore state
		SELECT (cur_sele)     && restore state

		SET ORDER TO TAG pickup_id  && try to find ID
		SEEK ALLTRIM(fnz_rtn)  && end up somewhere

	ENDIF

	SELECT (cur_sele)
	SET ORDER TO (curorder)


CASE subchoice=7

	SELE act_main
	STORE ORDER() TO c_tmp
	SET ORDER TO TAG pickup_id  && *!*!*!
	STORE RECNO() TO c_old
	DO msg2user WITH [FIND:  ]

	STORE SPACE(10) TO cpullinv
	ACTIVATE WINDOW msg2user
	CLEAR
	ACCE [What Pickup ID # do you want? ] TO cpullinv
	CLEAR
	DO msg2user WITH [CLOSE]
	IF ((cpullinv<=[      ]) .OR. (LASTKEY()=27))
		GOTO c_old
	ELSE
		SEEK cpullinv
		ON KEY LABEL f10 KEYBOARD CHR(23)
		BROWSE NORMAL NODELETE LAST;
			FIELDS pickup_id,invoice,  lname:15, fname:15,Phone,srvc_dat,rev_date,item_list NOEDIT ;
			NOMENU NOAPPEND TITLE act_titl

	ENDIF
	SET ORDER TO (c_tmp)
	SELECT (cur_sele)
	SET ORDER TO (curorder)

CASE subchoice=8
	SELE act_main
	STORE ORDER() TO c_tmp
	SET ORDER TO TAG cust_id
	STORE RECNO() TO c_old
	DO msg2user WITH [FIND:  ]

	STORE SPACE(10) TO cpullinv
	ACTIVATE WINDOW msg2user
	CLEAR GETS
	@ 1,3 SAY 'What Customer ID # do you want?' GET cpullinv  COLOR SCHEME 7
	READ
	DO msg2user WITH [CLOSE]
	IF ((cpullinv<=[      ]) .OR. (LASTKEY()=27))
		GOTO c_old
	ELSE
		SEEK cpullinv
		ON KEY LABEL f10 KEYBOARD CHR(23)
		BROWSE NORMAL NODELETE WINDOW syserror;
			FIELDS cust_id,invoice,  lname:15, fname:15,Phone,srvc_dat,rev_date,item_list NOEDIT ;
			NOMENU NOAPPEND TITLE act_titl

	ENDIF
	SET ORDER TO (c_tmp)
	SELECT (cur_sele)
	SET ORDER TO (curorder)

CASE subchoice=9
	SELE act_main
	STORE ORDER() TO c_tmp
	SET ORDER TO TAG Phone  && *!*!*!
	STORE RECNO() TO c_old

	DO msg2user WITH [FIND:  ]
	STORE SPACE(10) TO cpullinv
	ACTIVATE WINDOW msg2user
	CLEAR GETS
	@ 1,3 SAY 'What Phone do you want?' GET cpullinv  COLOR SCHEME 7
	READ
	DO msg2user WITH [CLOSE]
	IF ((cpullinv<=[      ]) .OR. (LASTKEY()=27))
		GOTO c_old
	ELSE
		SEEK cpullinv
		ON KEY LABEL f10 KEYBOARD CHR(23)
		BROWSE NORMAL NODELETE LAST;
			FIELDS Phone,pickup_id,invoice,  lname:15, fname:15,srvc_dat,rev_date,item_list NOEDIT ;
			TITLE act_titl

	ENDIF
	SET ORDER TO (c_tmp)
	SELECT (cur_sele)
	SET ORDER TO (curorder)



CASE subchoice=10
	SELE act_main
	STORE ORDER() TO c_tmp
	SET ORDER TO TAG dob && *!*!*!
	STORE RECNO() TO c_old
	DO msg2user WITH [FIND:  ]

	STORE DATE() TO c_date
	ACTIVATE WINDOW msg2user
	CLEAR GETS
	@ 1,3 SAY 'What Date of Birth do you want?' GET c_date  COLOR SCHEME 7
	READ
	DO msg2user WITH [CLOSE]
	IF ((EMPTY(c_date)) .OR. (LASTKEY()=27))
		GOTO c_old
	ELSE
		SEEK c_date
		BROWSE NORMAL NODELETE LAST;
			FIELDS dob,pickup_id,invoice,  lname:15, fname:15,Phone, srvc_dat,rev_date,item_list NOEDIT ;
			TITLE act_titl

	ENDIF
	SET ORDER TO (c_tmp)
	SELECT (cur_sele)
	SET ORDER TO (curorder)


CASE subchoice=11
	SELE act_main
	STORE ORDER() TO c_tmp
	SET ORDER TO TAG total_amt  &&  *!*!*!
	STORE RECNO() TO c_old
*  DEFINE BAR 6 OF pullinv PROMPT 'Invoice \<amount'
	PRIVATE monies, fnz_rtn

	DO msg2user WITH [FIND:  ]

	STORE 0.0 TO monies
	ACTIVATE WINDOW msg2user
	CLEAR GETS
	@ 1,3 SAY 'Enter the Dollar amount to look for: ' GET monies PICTURE '9999999.99' COLOR SCHEME 7
	READ
	DO msg2user WITH [CLOSE]
	IF (monies=0)
		GOTO c_old
		SELECT (cur_sele)     && restore state

	ELSE
		SEEK monies
		BROWSE NORMAL NODELETE NOMENU NOAPPEND LAST;
			FIELDS total_amt,pickup_id,invoice,  lname:15, fname:15,srvc_dat,rev_date,item_list NOEDIT ;
			TITLE act_titl

		IF (EOF() .OR. BOF()) && avoid eof/bof condition
			GOTO TOP
		ENDIF

		STORE act_main.pickup_id TO fnz_rtn  &&grab ID

		SET ORDER TO (c_tmp)  && restore state
		SELECT (cur_sele)     && restore state

		SET ORDER TO TAG pickup_id  && try to find ID
		SEEK ALLTRIM(fnz_rtn)  && end up somewhere

	ENDIF
*!*	      SELECT act_main
*!*	      SET ORDER TO (curorder)
	SELECT (cur_sele)     && restore state
	SET ORDER TO (curorder)

ENDCASE
RELE WINDOW syserror
*activate window (cur_win)
SET EXACT ON
SET NEAR OFF
SHOW GETS
UNLOCK ALL
SET RESOURCE ON
RETURN

********************************************************************************
********************************************************************************
********************  END                       ********************************
********************  Invoice Browsers          ********************************
********************                            ********************************
********************************************************************************
***************
*****************************************************************



*!*	FUNCTION prov_val
*!*	  PARAMETERS C

*!*	TEXT
*!*	PRIVATE cur_set, cur_setn,win_var,first_co
*!*	PRIVATE cur_sele
*!*	cur_sele=SELE()
*!*	ic=UPPER(TRIM(C))
*!*	SELE act_prov
*!*	IF EMPTY(C)  					&& if user comes in with blank customer name
*!*	   IF yesno([Making new Provider Entry])
*!*	      DO act_prov.spr
*!*	      STORE id_provid TO C
*!*	   ENDIF
*!*	ELSE							&&otherwise  try and find it.
*!*	   ON KEY LABEL f10 KEYBOARD CHR(23)

*!*	   SEEK C      				&& try and find customer
*!*	   ON KEY LABEL f3 DO act_prov.spr
*!*	   ON KEY LABEL f10 KEYBOARD CHR(23)
*!*	   IF .NOT. FOUND()
*!*	      BROWSE NORMAL NODELETE NOEDIT ;
*!*	         TITLE act_titl LAST
*!*	   ENDIF
*!*	   ON KEY LABEL f3
*!*	   &&cur_setn
*!*	   STORE id_provid TO C
*!*	ENDIF
*!*	comp_val_rx=RECNO()    			&&save the current cust record in comp_val_rx
*!*	SELECT (cur_sele)

*!*	ENDTEXT

*!*	  RETURN C  					&& wsh 02/28/92

	FUNCTION cust_val
		PARAMETERS c
		PRIVATE cur_set, cur_setn,win_var,first_co, c_i, cur_rec
		PRIVATE cur_sele
		cur_sele=SELE()
		STORE RECNO() TO cur_rec
		ic=UPPER(ALLTRIM(c))
		SELE act_cust
		IF EMPTY(ic)
			IF yesno([Making new Customer ID Entry])
				c_i=add_1([CU])					&& if user comes in with blank customer name
				REPL act_cust->pickup_id WITH c_i
				REPL act_cust.pickup_id WITH PADL(c_i,6,'0')
*			DO act_adds.spr
				DO FORM act_adds
			ENDIF
		ELSE							&&otherwise  try and find it.
			SET NEAR ON
			SET EXACT OFF

&& try and find customer
			ON KEY LABEL f10 KEYBOARD CHR(23)
*  SEEK VAL(ALLTRIM(IC))
			SEEK ic
			IF ( .NOT. FOUND() )
				BROWSE NORMAL NODELETE FIELDS pickup_id, lname:20, fname:20,Phone,dob,zip NOEDIT ;
					TITLE act_titl LAST
			ENDIF

			SET EXACT ON
			SET NEAR OFF              &&cur_setn

		ENDIF
		comp_val_rx=RECNO()    			&&save the current cust record in comp_val_rx
		c_i=act_cust->pickup_id
		SELECT (cur_sele)
		GOTO cur_rec  && ** !!  !! ! ! !! !! !!! ! ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*repl cust_id with c_i
		RETURN c_i    					&& wsh 02/28/92

	FUNCTION cust_nam
		PARAMETERS c
		PRIVATE cur_set, cur_setn,win_var,first_co, c_i
		PRIVATE cur_sele
		SET RESOURCE OFF
		cur_sele=SELE()
		ic=UPPER(TRIM(c))
		SELE act_cust

		IF EMPTY(c)
			IF yesno([Making new Customer.])
				c_i=add_1([CU])					&& if user comes in with blank customer name
				REPL act_cust->pickup_id WITH c_i
				DO FORM act_adds
*			DO act_adds.spr
			ENDIF
		ELSE
			SELE act_cust
			SET ORDER TO TAG lname							&&otherwise  try and find it.

			SET NEAR ON
			SET EXACT OFF

&& try and find customer
			ON KEY LABEL f10 KEYBOARD CHR(23)
			SEEK c
			SET RESOURCE OFF
			IF ( .NOT. FOUND() )
				BROWSE NORMAL NODELETE FIELDS lname:20, fname:20,Phone,dob,zip NOEDIT ;
					WINDOW syserror TITLE act_titl LAST
			ENDIF
			SET RESOURCE ON
			SET ORDER TO TAG pickup_id  &&*!*!*!*

			SET EXACT ON
			SET NEAR OFF              &&cur_setn

		ENDIF
		comp_val_rx=RECNO()    			&&save the current cust record in comp_val_rx
		c_i=act_cust->lname
		SELECT (cur_sele)
		SET RESOURCE ON
		RETURN c_i    					&& wsh 02/28/92



***************************************************************************************
*
*
*
*    Misc subroutines and queries
*
*
****************************************************************************************


*********************************************


	PROCEDURE calc_one
*********************************************
		STORE act_cust.pickup_id TO c_tmp
		SELECT act_main
		STOR ORDER() TO cidx
		SET ORDER TO TAG pickup_id
		STORE 0. TO cs_n
		SEEK c_tmp
		IF FOUND()
			DO WHILE (pickup_id=c_tmp) .AND. ( .NOT. EOF())
				cs_n=cs_n+total_amt
				SKIP
			ENDDO
		ENDIF
*SUM total_amt TO cs_n ALL FOR PICKUP_id=c_tmp
		SET ORDER TO cidx

		SELE act_pay
		STOR ORDER() TO cidx
		SET ORDER TO TAG pic_id_i
		STORE 0. TO cp_n
		SEEK c_tmp
		IF FOUND()
			DO WHILE (id_of_payr=c_tmp) .AND. ( .NOT. EOF())
				cp_n=cp_n+amt_paid
				SKIP
			ENDDO
		ENDIF

*SUM amt_paid TO cp_n ALL FOR id_of_payr=c_tmp
		SET ORDER TO cidx
		RETURN


	PROCEDURE calc_balance
*********************************************
		PRIVATE paid_this_month
		STORE 0.0 TO paid_this_month

		ACTIVATE SCREEN
		? [Recomputing all account balances... Please Wait]
		CLOSE DATA
		USE act_cust ORDER TAG pickup_id
		SELE 0
		USE act_main ORDER TAG pickup_id
		SELE 0
		USE act_scr ORDER TAG invoice
		SELE 0
		USE act_pay ORDER TAG pic_id_i
****
		SELE act_cust
		SET RELATION TO pickup_id INTO act_main
		SELE act_main
		SET RELA TO pickup_id INTO act_pay
		SET RELA TO invoice INTO act_scr ADDITIVE
***

		SELE act_cust
		GOTO TOP
		DO WHILE .NOT. EOF()
****************************
** COMPUTE BALANCE
****************************
			STORE act_cust.pickup_id TO c_tmp
			SELECT act_main
			SUM total_amt TO cs_n ALL FOR pickup_id=c_tmp
			SELE act_pay
			SUM amt_paid TO cp_n ALL FOR id_of_payr=c_tmp
&& fixup for "late penalties"- capture payments made  the month
			STORE 0.0 TO paid_this_month
			SUM amt_paid TO paid_this_month ALL FOR (id_of_payr=c_tmp) WHILE (MONTH(act_pay.date_paid)=MONTH(DATE()))  &&  sum up the client's payments made this month
&& write the dollar amount to the cust record- will be read later by the billing logic
			UNLOCK ALL
			SELE act_cust
			REPLACE totl_amt WITH cs_n-cp_n, last_calc WITH DATE(), prec_nam WITH STR(paid_this_month,8,2)
			SKIP
		ENDDO
		CLOSE DATA
		CLEAR
		DO view_set
		RETURN


	FUNCTION custpaym
* custpaym() == returns total of all payments for customer currently
*               pointed to in customer file, payments must be open,
*               all pointers will be restored
		PRIVATE mtotal, mrecno
		STORE SUBSTR('ABCDEFGHIJKLMNOPQRSTUVWXYZ',SELECT(),1) TO marea
		SELECT act_pay
		SET ORDER TO TAG pic_id_i   &&*!*!*!

		IF EOF()
			GO BOTTOM
		ENDIF

		mrecno = RECNO()
		SEEK act_cust->pickup_id

		IF FOUND()
			SUM REST amt_paid TO mtotal WHILE id_of_payer = act_cust->pickup_id
		ENDIF

		IF .NOT. BOF() .AND. mrecno <= RECCOUNT() .AND. mrecno > 0
			GOTO mrecno
		ENDIF
		SELECT (marea)
		RETURN mtotal

*******************************************************************************************
	FUNCTION custsales
***********************************************************************************************
* custsales() == returns total of all invoices for customer currently
*                pointed to in customer file, lineitems must be open
*                as alias lines, all pointers will be restored
*
		PRIVATE mtotal, mrecno1, mrecno2
		STORE SUBSTR('ABCDEFGHIJKLMNOPQRSTUVWXYZ',SELECT(),1) TO area
		STORE 0 TO mtotal
		SELECT act_scr
		STORE RECNO() TO mrecno2
		SELECT act_cust
		STORE pickup_id TO mcust_id
		SELECT act_main
		STORE RECNO() TO mrecno1
		SET ORDER TO TAG cust_id  &&*!*!*!
		SEEK mcust_id
		SUM REST invsub() TO mtotal WHILE pickup_id = mcust_id
*SUM REST invsub() + invtax() TO mtotal WHILE cust_id = mcust_id
		SELECT act_main
		SET ORDER TO TAG invoice &&*!*!*!*
		IF .NOT. BOF() .AND. mrecno1 <= RECCOUNT() .AND. mrecno1 # 0
			GOTO mrecno1
		ENDIF
		SELECT LINES
		IF .NOT. BOF() .AND. mrecno2 <= RECCOUNT() .AND. mrecno2 # 0
			GOTO mrecno2
		ENDIF
		SELECT act_cust
		SEEK mcust_id
		SELECT (area)
		RETURN mtotal

	FUNCTION invsub
* Returns subtotal of current invoice, sets global subdisc
		PRIVATE mrecno, t_sub, subtot, area, curorder, cur_disc,cur_filter
		STORE SUBSTR('ABCDEFGHIJKLMNOPQRSTUVWXYZ',SELECT(),1) TO area
		STORE ORDER() TO curorder
		SELECT act_scr
		SET ORDER TO TAG invoice &&  *!*!*!*
		mrecno = RECNO()
		SEEK act_main->invoice
		STORE 0 TO subtot,t_sub
		STORE 0 TO subdisc
		STORE invoice->DISCOUNT TO cur_disc


&& GET ALL THE diagsxprice
		SUM REST price*n_instok TO subtot WHILE (LINES->invoice = invoice->invoice)



		IF .NOT. BOF() .AND. mrecno <= RECCOUNT() .AND. mrecno # 0
			GOTO mrecno
		ENDIF



*subdisc=.01*cur_disc*subtot   && compute the current discount.
*subdisc=ROUND(subdisc,2)   && round off to two places after decimal
*subtot=subtot-subdisc   && and deduct it from the subtotal


		SELECT (area)
		SET ORDER TO (curorder)
		RETURN subtot


	FUNCTION ready2pr
		DO WHILE .NOT. PRINTSTATUS()
			IF .NOT. yesno('Printer not ready! I will keep trying...')
				RETURN .F.
			ENDIF
		ENDDO
		RETURN .T.

	FUNCTION yesno
		PARAMETERS MESSAGE
		PRIVATE yes_no
		STORE 'Yes' TO yes_no
		ACTIVATE WINDOW msg2user
		CLEAR GETS
		@ 00,01 SAY MESSAGE
		@ 02,01 SAY 'Continue? Yes/No:' GET yes_no PICTURE '@M Yes,No '
		READ
		DEACTIVATE WINDOW msg2user
		STORE IIF(yes_no='Yes',.T.,.F.) TO retval
		RETURN retval

	FUNCTION flash
		PARAMETERS MESSAGE
		ACTIVATE WINDOW msg2user
		@ 00,01 SAY MESSAGE
		FOR ii_ii=1 TO 100
		ENDFOR
		DEACTIVATE WINDOW msg2user
		RETURN


	FUNCTION wintitle
		PARAMETERS ctitle
		STORE WCOLS() TO clen
		STORE INT((clen - LEN(ctitle))/2) TO padding
		STORE SPACE(padding) + ctitle + SPACE((clen-LEN(ctitle))-padding) TO padtitle
		RETURN padtitle


	PROCEDURE msg2user
		PARAMETERS message1, message2, message3
		IF message1 = 'CLOSE'
			DEACTIVATE WINDOW msg2user
		ELSE
			ACTIVATE WINDOW msg2user
			CLEAR
			@ 00,00 SAY SPACE(1) + LEFT(message1 + SPACE(71),71) + SPACE(1)
			@ 01,00 SAY SPACE(1) ;
				+ LEFT(IIF(PARAMETERS() < 2, SPACE(71), message2) + SPACE(71),71) + SPACE(1)
			@ 02,00 SAY SPACE(1) ;
				+ LEFT(IIF(PARAMETERS() < 3, SPACE(71), message3) + SPACE(71),71) + SPACE(1)
		ENDIF
		RETURN
	FUNCTION msg4user
		PARAMETERS message1, message2, message3
		ACTIVATE WINDOW msg2user
		CLEAR
		@ 00,00 SAY SPACE(1) + LEFT(message1 + SPACE(71),71) + SPACE(1)
		@ 01,00 SAY SPACE(1) ;
			+ LEFT(IIF(PARAMETERS() < 2, SPACE(71), message2) + SPACE(71),71) + SPACE(1)
		@ 02,00 SAY SPACE(1) ;
			+ LEFT(IIF(PARAMETERS() < 3, SPACE(71), message3) + SPACE(71),71) + SPACE(1)
		WAIT '                < Press a key or click the mouse to continue. > '
		DEACTIVATE WINDOW msg2user
		RETURN [ ]
	PROCEDURE standby
		PARAMETERS msgwords
		ACTIVATE WINDOW msg2user
		@ 00,01 SAY msgwords
		@ 01,01
		WAIT '                < Press a key or click the mouse to continue. > '
		DEACTIVATE WINDOW msg2user
		RETURN
******************              ***************************************
******************    I_Count   ***************************************
***********************************************************************
	FUNCTION i_count
		PARAMETERS idz        	  && ID=IN,LI,CU. Count=# to date
		PRIVATE orig_dbf,flag,hey
&& wsh added 7/21/92*******************
		SET REPROCESS TO AUTOMATIC
&& wsh added 7/21/92*******************
		orig_dbf=SELECT()		  && get orig workarea
		SELE act_uniq			  && select the counting file
		flag=.F.				  && assume the worst
		SEEK idz
		recry=.T.
		DO WHILE recry
			IF RLOCK()			  && only ok if we can lock
				recry=.F.
				flag=.T.
				REPLACE act_uniq.COUNT WITH act_uniq.COUNT+1
*FLUSH			  && put the info to the net
				count_var=act_uniq.COUNT
			ELSE				  && cannot lock
				flag=.F.
				IF yesno([The I_Count RECORD is locked BY another. RETRY=Y, QUIT=N. ])
					recry=.T.
				ELSE
					DO QUIT_ACT WITH [Q]
				ENDIF
			ENDIF
		ENDDO
		UNLOCK      			  && free up all record locks
		SELECT (orig_dbf)			  && go back to orig workarea
&& wsh added 7/21/92  *******************
&& SET REPROCESS TO repr_tim

		SET REPROCESS TO AUTOMATIC

&& WSH TESTED FROM 1-100, 60 SEEMS BEST 3/31/92&& wsh added 7/21/92  *******************
		RETURN flag  				  && signal success t/f


***********************************************************************
***********************************************************************
***********************************************************************
***********************************************************************
	FUNCTION add_1
		PARAMETERS id_type
		PRIVATE LAST,l_rec
		LAST=[]
		IF (i_count(id_type))   && fetch valid cust # from I_Count
			LAST=STR(count_var,10)
			APPEND BLANK  && to file
		ENDIF
		RETURN ALLTRIM(LAST)     &&Presumes success of i_count and valid id_type


* SHOWGETS - Invoked from BROWSE WHEN clause, refresh gets on the screen.
*
******************************************************************************
	FUNCTION showgets
		SHOW GETS
		UNLOCK ALL


***********************************************************************
***********************************************************************
***********************************************************************
***********************************************************************
***********************************************************************
	PROCEDURE culdupes
		SELE act_cust

		USE
** ||  ** ON ERROR
		PRIV A
		CLEAR
		PRIV e_nfound
		STORE .T. TO e_nfound
** ||  ** ON ERROR STORE .F. TO e_nfound
		SET EXCL ON
&& CAN i GET EXLUSIVE USE?
		USE act_cust EXCL
		USE
		SET EXCLUSIVE OFF
** ||  ** ON ERROR
		IF e_nfound=.T.
			?
			?
			?
			? [  Cull Duplicate Customers? ]
			? [  This REQUIRES (!) single user access.  Single Access available ==>],e_nfound
			?
			ACCE [    Enter C TO Cull, or press <ENTER>] TO A
			IF A$[cC]
				USE act_cust EXCL
				SET ORDER TO
				COPY ALL TO cust_bak
				GOTO TOP
				DELE REST FOR lname<"!"

				PACK
				CLEAR
				?
				? [Choose the following option to purge commas from the Name, Street, City, and Phone fields.]
				? [Commas will prevent the succesful import and export to other systems like PeachTree.]
				?
				IF yesno([Cull Commas from the Customer data? ])
* Lines like the below indicate code that only needs to run once per db
*********^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
*********^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
					?
					? [This procedure only gets up to 3 commas from each record.  Run it again to ]
					? [cull more commas.]
					?
					SET ORDER TO 0
*set filter to cust_type$[Rr]
					REPLA ALL mthly_rate WITH 9.00
					GOTO TOP  && clean up the commas in the data set--thrice for three commas

					REPLA ALL FOR ([,]$fname) fname WITH STUFF(fname,AT([,],fname),1,[ ])
					REPLA ALL FOR ([,]$fname) fname WITH STUFF(fname,AT([,],fname),1,[ ])
					REPLA ALL FOR ([,]$fname) fname WITH STUFF(fname,AT([,],fname),1,[ ])

					REPLA ALL FOR ([,]$lname) lname WITH STUFF(lname,AT([,],lname),1,[ ])
					REPLA ALL FOR ([,]$lname) lname WITH STUFF(lname,AT([,],lname),1,[ ])
					REPLA ALL FOR ([,]$lname) lname WITH STUFF(lname,AT([,],lname),1,[ ])

					REPLA ALL FOR ([,]$street) street WITH STUFF(street,AT([,],street),1,[ ])
					REPLA ALL FOR ([,]$street) street WITH STUFF(street,AT([,],street),1,[ ])
					REPLA ALL FOR ([,]$street) street WITH STUFF(street,AT([,],street),1,[ ])

					REPLA ALL FOR ([,]$Phone) Phone WITH STUFF(Phone,AT([,],Phone),1,[ ])
					REPLA ALL FOR ([,]$Phone) Phone WITH STUFF(Phone,AT([,],Phone),1,[ ])
					REPLA ALL FOR ([,]$Phone) Phone WITH STUFF(Phone,AT([,],Phone),1,[ ])

					REPLA ALL FOR ([,]$city) city WITH STUFF(city,AT([,],city),1,[ ])
					REPLA ALL FOR ([,]$city) city WITH STUFF(city,AT([,],city),1,[ ])
					REPLA ALL FOR ([,]$city) city WITH STUFF(city,AT([,],city),1,[ ])

*********^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
*********^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

				ENDIF  && cull commas

				CLEAR
				?
				?
				? [**********************************************************************]
				? [*** W A R N I N G ***    *** W A R N I N G ***   *** W A R N I N G ***]
				? [**********************************************************************]
				?
				? [Do Not Run This Procedure Unless You Want to Zap Duplicate Customers]
				? [====================================================================]
				? [Choose the next procedure to Cull Duplicate Customers.  This procedure]
				? [will search for records that have the same lname, first 3 characters]
				? [of the first name, last three characters of the first name (initial etc),]
				? [the first 10 characters of the street, the first 4 characters of the city,]
				? [and the same zip code.]
				?
				? [   When such records are found to be the same, the second instance of the]
				? [of the record is marked for deletion.  The deleted records are copied to]
				? [the file \TEMP\COMPCULZ.DBF and will remain in the original file until it is next]
				? [PACKED.  You can restore the records to the original file by issuing the]
				? [command RECALL ALL from the FOXPRO Command Line.  If you do not issue the]
				? [RECALL ALL, the duplicates will be purged from the file.]
				?

				IF yesno([ZAP All Duplicate Customers ? ])
					REPL ALL lname WITH ALLTRIM(UPPER(lname)), fname WITH ALLTRIM(UPPER(fname)), street WITH ALLTRIM(UPPER(street)), city WITH ALLTRIM(UPPER(city)), st WITH ALLTRIM(UPPER(st))

					? [Cull by compound field <<=======]
					REPLACE ALL compound WITH ALLTRIM(lname)+LEFT(fname,3)+;
						RIGHT(ALLTRIM(fname),3)+LEFT(street,10)+;
						LEFT(city,4)+ALLTRIM(zip)
					INDE ON compound TAG compound
					GOTO BOTTOM
					DO WHILE ( .NOT. BOF())
						STORE ALLTRIM(lname)+LEFT(fname,3)+;
							RIGHT(ALLTRIM(fname),3)+LEFT(street,10)+;
							LEFT(city,4)+ALLTRIM(zip) TO a_zns
						SKIP -1
						IF BOF()
							EXIT
						ENDIF
						IF ALLTRIM(lname)+LEFT(fname,3)+;
								RIGHT(ALLTRIM(fname),3)+LEFT(street,10)+;
								LEFT(city,4)+ALLTRIM(zip)=a_zns  && zap dup street #'s
							SKIP
							REPLACE cust_type WITH [z]
							DELETE NEXT 1
							? RECNO(), [z]
							SKIP -1
						ENDIF
					ENDDO

					GOTO TOP
					COPY ALL FOR DELETED() TO \temp\act_culz.DBF

					? [			***  Duplicate search complete. ***]
					?
					? [	Records marked for deletion are probably duplicates.  Issue the]
					? [RECALL ALL  command if you want to keep the records in the file, otherwise]
					? [they will be deleted when the file is next PACKED.  Duplicate records]
					? [are copied to the file ACT_CULZ.DBF in the \TEMP directory.]
					?
					WAIT([Press <ENTER> to Continue.])
				ENDIF  && zap dupes
			ENDIF &&ok to cull a$[cC]
		ENDIF &&excl avail
		DO view_set
* | * ON ERROR DO syserror WITH LINENO()

		RETURN

************************************************************************************
	PROCEDURE act2peat
************************************************************************************
&&v1.3
		CLEAR
		?
		? [     This program migrates data from the ACT_CUST dbf format to]
		? [Peachtree.  It is currently setup for 1995.  It requires]
		? [the header file CUSHEADR.TXT in the default directory.]
		?
&&
&&  USAGE:  Do ACT2PEAT after issuing the SET DEFA TO
&&          command and naming the default data dir.
&&

		?
		?
		? [PeachTree Information is written to files CUSTOMER.CSV,JNL_YTD.CSV]
		? [and JNLRECUR.CSV.  This procedure writes data for all remaining months]
		? [in the calendar year. That is:  the Customer file and all Journal]
		? [entries.  The Journal Entries have a starting balance, and then]
		? [monthly sales recurring through the year.]
		?
		? [Use PeachTree to I(mport the CUSTOMER.CSV file, then the]
		? [JNL_YTD.CSV and lastly the JNLRECUR.CSV]
		?
		? [Once the files have imported, Post Sales to reflect account balances.]

&&

		SET SPACE OFF
		SET CONSOLE OFF
		SET STATUS OFF
		SET SCOREBOARD OFF
		SET HISTORY OFF
		SET TALK OFF

		SELE act_cust &&*!

		CLOSE DATA
** ||  ** ON ERROR
		PRIV A
		CLEAR
		PRIV e_nfound
		STORE .T. TO e_nfound
** ||  ** ON ERROR STORE .F. TO e_nfound
		SET EXCL ON
		USE act_main EXCL  && CAN i GET EXLUSIVE USE?
		USE act_cust EXCL
		USE act_pay EXCL
		CLOSE DATA
		SET EXCLUSIVE OFF
** ||  ** ON ERROR
		IF e_nfound=.T.
			?
			?
			?
			? [  Import database files ?  ]
			? [  This REQUIRES (!) single user access.  Single Access available ==>],e_nfound
			?
			ACCE [    Enter I to Import and Reindex, or press <ENTER>] TO A

			IF A$[Ii]

				USE act_cust EXCL


*********************************************************************
*******		Migrate Customer records to CUSTOMER.CSV
*********************************************************************
				SET ORDER TO TAG pickup_id  &&*!was 2
				SET FILTER TO district$[1345]
				GOTO TOP
				SET PRINTER TO Customer.tmp
				SET PRINTER ON
*for i=1 to 10
				DO WHILE ( .NOT. EOF())
&&*,ID,Customer Name,
&&*Address Line 1,Address Line 2,
&&*,,,,Category
&&*,FaxNumber,Our AcntNum,Ship to Name,Address Line 1,Address Line 2,,
&& zip,ship2country&&*,,,Inactive,Contact,Phone Number,
&&*Resale Number,Std Terms,Due Days,Discount Days,Discount Percent,
&&     Credit Limit,*Interest (y/n),COD,Prepay,DayIsActual,
&&     Sales Account,Balance,Date Added,TaxID,
&&*Sales Period 0,Sales Period 1,Sales Period 2,Sales Period 3,Sales Period 4,Sales Period 5,Sales Period 6,Sales Period 7,Sales Period 8,Sales Period 9,Sales Period 10,Sales Period 11,Sales Period 12,Sales Period 13,Sales Period 14,Sales Period 15,Sale
*s period 16,sales period 17,sales period 18,sales period 19,sales period 20,sales period 21,sales period 22,sales period 23,sales period 24,sales period 25,sales period 26,sales period 27,sales period 28,sales period 29,sales period 30,sales period 31,s


*         les period 32,sales period 33,sales period 34,sales period 35,sales period 36,sales period 37,sales period 38,sales period 39,sales period 40,sales period 41



&&,Payments Period 0,Payments Period 1,Payments Period 2,Payments Period 3,Payments Period 4,Payments Period 5,Payments Period 6,Payments Period 7,Payments Period 8,Payments Period 9,Payments Period 10,Payments Period 11,Payments Period 12,Payments Peri
*od 13,payments period 14,payments period 15,payments period 16,payments period 17,payments period 18,payments period 19,payments period 20,payments period 21,payments period 22,payments period 23,payments period 24,payments period 25,payments period 26,

*pments period 27,payments period 28,payments period 29,payments period 30,payments period 31,payments period 32,payments period 33,payments period 34,payments period 35,payments period 36,payments period 37,payments period 38,payments period 39,payments

*         period 40,payments period 41



*,Last Invoice Date,Last Invoice Amount,
*      Last Payment Date,Last Payment Amount,Last Statement Date
&&?[,]+phone+[,,,,]+[,,,]+[,,N,,,]+[,Y,15,15,]


*v05.00,1,bt,bt,bt,btBT11111,bt,111 111 1111,,Y,15,0,0.00,99999.99,Y,N,N,N,ACT_Sales,27.00,2/16/95,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,18.00,9.00,9.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00


*,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,9.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.

					0
*         0,0.00,0.00,0.00,3/1/95,9.00,1/1/95,9.00,


*v06.00,999991,ThisIs1BillToNameFirst Last012,ThisIsTheAddressLine1_01234567,ThisIsTheAddressLine2_01234567,ThisIsTheCity0123456,KY,999999999999,ThisIsTheCountr,TypeCust,(999) 999-9999 99999,,ThisIsAShipToNameFirst Last012,ThisIsTheShipToAddress1_012345;


*,thisistheshiptoaddress2_012345,thisisshiptocity0123,ky,999999999999,thisisshiptocou,N,thisisthecontactfiel,(999) 999-9999 99999,01234567890123456789,y,15,0,0.00,0.00,y,N,N,N,11100,1.11,2/4/95,,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,;
*0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,;
*0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,1/1/95,9.00,,0.00,



					?[v06.00,]+PADL(cust_id,6,[0])+[,]+UPPER(ALLTRIM(fname))+[ ]+UPPER(ALLTRIM(lname))
					?[,]+UPPER(ALLTRIM(street))+[,,]+UPPER(ALLTRIM(city))
					?[,]+st+[,]+zip+[,,]+cust_type+district+route+SOURCE+data_quali
					?[,,,,,]+[,,,]+[,,N,,]+Phone+[,,Y,15,15,]
					?[0.00,9999.99,Y,N,N,N,ACT_Sales,]+[0.00]+[,]+[01/01/95]+[,,]
					?[0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,]
					?[0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,]
					?[0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,]
					?[0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,]
					?[0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,]
					?[0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,]
					?[0.00,0.00,0.00,0.00,0.00,0.00,12/31/94,]+[0.00,12/15/94,0.00,12/31/94]

					SKIP
				ENDDO
*next

				SET PRINTER OFF
				SET PRINTER TO

*********************************************************************
*******  Migrate ACT Year To Dates to JOURNAL.CSV
*********************************************************************



				GOTO TOP
				SET PRINTER TO jnl_ytd.csv
				SET PRINTER ON

				??[,Journal,Date,Ledger ID,Account,Description,Amount,Reference,Recur #,Recur Freq,SalesRepID,Posted,Prepayment,Number of Distributions,Distributions Follow]
				?[,,,,,,,,,,,]

				DO WHILE ( .NOT. EOF())
* v05.00,Sales Journal,1/1/95,1,,bt,9.00,,Y,N,1,,1/16/95,1/1/95,0.00,0.00,ACT_Sales,,-9.00,1.00,
* v06.00,Sales Journal,1/1/95,    999999,              2,  99999,ThisIsABillToNameFirst Last012,                      999999999.99,                    99999999,            0,N, ,Y,N,1,  999999               ,1/16/95,1/1/95,0.00,,N,999999999.99,11100,,-99


*         9999999.99,0.00,beginning balances,N,0,



					?[v06.00,Sales Journal,1/1/95,]+PADL(cust_id,6,[0])+[,,]+UPPER(ALLTRIM(fname))+[ ]+UPPER(ALLTRIM(lname))+[,]+ALLTRIM(STR(pastyrdebt,7,2))+[,]+PADL(cust_id,6,[0])+[,0,N,1,Y,N,1,]+PADL(cust_id,6,[0])+[,1/15/95,1/1/95,0.00,,N,0.00,ACT_Sales,,]+;
						[-]+ALLTRIM(STR(pastyrdebt,7,2))+[,0.00,Beginning Balances,N,0,]



					SKIP
				ENDDO


				SET PRINTER OFF
				SET PRINTER TO

*********************************************************************
******  Migrate ACT Billing to JNLRECUR.CSV
* ********************************************************************
*
*  NB:  These records must accurately reflect _ALL_ sales, whether prepaid or not.
*

				GOTO TOP
				SET PRINTER TO jnlrecur.csv
				SET PRINTER ON

				??[,Journal,Date,Ledger ID,Account,Description,Amount,Reference,Recur #,Recur Freq,SalesRepID,Posted,Prepayment,Number of Distributions,Distributions Follow]
				?[,,,,,,,,,,,]

*for i=1 to 10
				DO WHILE ( .NOT. EOF())
&&,      Journal,      Date,    Ledger ID,Account, Description,  Amount,  Reference, Recur #,Recur Freq,SalesRepID,Posted,Prepayment,Number of Distributions,Distributions Follow,,,,,,,,,,,
&&v06.00,Sales Journal,12/31/94,999999,, ThisIsABillToNameFirst Last012, 27.00,   101, 0,N,1,Y,N,1,,1/15/95,12/31/94,0.00,Net 15 Days,N,0.00,11100,,   -  27.00, 1.00,Accounts Receivable,N,0,
&&v06.00,Sales Journal,2/1/95,000295,,CLAUDETTE ADAMS, 9.00,, 1,Y,,Y,N,1,,2/16/95,2/1/95,0.00,Net 15 Days,N,0.00,10100,,  -  9.00,                  1.00,,N,0,
					?[v06.00,Sales Journal,2/1/95,]+PADL(cust_id,6,[0])+[,,]+UPPER(ALLTRIM(fname))+[ ]+UPPER(ALLTRIM(lname))+[,]+ALLTRIM(STR(mthly_rate,7,2))+[,]+[95A]+PADL(cust_id,6,[0])+[,12,Y,,Y,N,1,,2/16/95,2/1/95,0.00,Net 15 Days,N,0.00,ACT_Sales,,];
						+[-]+ALLTRIM(STR(mthly_rate,7,2))+[,1.00,,N,0,]
					SKIP
				ENDDO

*next

				SET PRINTER OFF
				SET PRINTER TO

*********************************************************************
******
*********************************************************************



				SET DELETED ON  && nail the inactive records
				SET ORDER TO TAG pickup_id  && *!*!*!
*district$[1345] .and.
				SET FILTER TO (compound<[*])  && * means had all recurring recs for 1995 so does deleted()



*********************************************************************
******  Recur ACT Monthly Billing to jnlrcr??.CSV as recurring Sales
*********************************************************************
				GOTO TOP
				PRIVATE pt_month,pt_year,pr_recur
				STORE MONTH(DATE()) TO pt_month
				STORE YEAR(DATE()) TO pt_year
				SET PRINTER TO jnl4onfx.csv
				SET PRINTER ON
				??[,Journal,Date,Ledger ID,Account,Description,Amount,Reference,Recur #,Recur Freq,SalesRepID,Posted,Prepayment,Number of Distributions,Distributions Follow]
				?[,,,,,,,,,,,]

				DO WHILE ( .NOT. EOF())
&&,      Journal,      Date,    Ledger ID,Account,Description, Amount, Reference, Recur #,Recur Freq,SalesRepID,Posted,Prepayment,Number of Distributions,Distributions Follow,,,,,,,,,,,

&&v06.00,Sales Journal,12/31/94,999999,,  ThisIsABillToNameFirst Last012,                             27.00,                           101, 0,N,1,Y,N,1,,1/15/95,12/31/94,0.00,Net 15 Days,N,0.00,11100,,   -  27.00,1.00,Accounts Receivable,N,0,

&&v06.00,Sales Journal,2/1/95,000295,,CLAUDETTE ADAMS, 9.00 ,, 1,Y,,Y,N,1,,2/16/95,2/1/95,0.00,Net 15 Days,N,0.00,10100,,-  9.00, 1.00,,N,0,
&& thru December

					FOR pt_recur=pt_month TO 12
						?[v06.00,Sales Journal,]+pt_recur+[/1/]+pt_year+[,]+PADL(cust_id,6,[0])+[,,]+UPPER(ALLTRIM(fname))+[ ]+UPPER(ALLTRIM(lname))+[,]+ALLTRIM(STR(mthly_rate,7,2))+[,]+[95C]+PADL(cust_id,6,[0])+[,12,Y,,Y,N,1,,;
3/16/95,3/1/95,0.00,net 15 days,N,0.00,act_sales,,];
							+[-]+ALLTRIM(STR(mthly_rate,7,2))+[,1.00,,N,0,]

					ENDFOR
					SKIP
				ENDDO
*next
				SET PRINTER OFF
				SET PRINTER TO
*********************************************************************
*********************************************************************
				USE

				!act2peat  &&execute routine to cleanup Client File
			ENDIF && a$[Ii]-->ok to export
		ENDIF&&excl avail
		DO view_set
* | * ON ERROR DO syserror WITH LINENO()
		RETURN
**finis
***************************************************************************




	PROCEDURE  act_fast


**************************** Set The Environment **************************
***************************************************************************

		PUBLIC ok2add,root2bo,repr_tim
		ok2add=[F]    && OK TO ADD FLAG FOR INVOICE.PRG
		root2bo=[F]   && default to not print BO's connected to an invoice


*************************************************************************
*************************************************************************
***********************  Begin main routine  ****************************
***********************  Begin main routine  ****************************
*************************************************************************
*************************************************************************


		PUBLIC seg, this_one
		seg = 1
* SET STATUS ON
* | * ON ERROR DO syserror WITH LINENO()
*************************************************************************
*************************************************************************
******************************   MAIN CALL  *****************************
*************************************************************************
*************************************************************************
		SELE act_cust
		SET ORDER TO 0
		DO FORM act_adds
*	DO act_adds.spr

		SELE act_main
*************************************************************************
*************************************************************************
******************************EOF MAIN CALL *****************************
*************************************************************************
*************************************************************************

*QUIT*

		RETURN

******==========================================================*******
******==========================================================*******
******==========================================================*******
******===========                                ===============*******
******===========     E N D  O F  M A I N        ===============*******
******===========                                ===============*******
******==========================================================*******
******==========================================================*******
******==========================================================*******
******==========================================================*******


***********************************************************************
* END MAIN Menu Support
***********************************************************************
***********************************************************************
* MAIN Menu Support
**********************************************************************
***********************************************************************
* MAIN Menu Support
***********************************************************************



********************************************************************************
********************************************************************************
********************  Support  for              ********************************
********************  Invoice Browsers          ********************************
********************                            ********************************
********************************************************************************
********************************************************************************

	PROCEDURE act_butn
		PARAMETER buttn
		PUBLIC A,bb,ccc
		SELE act_cust
		DO CASE
		CASE buttn=1

			ar_i =add_1([CU])
			STORE ar_i TO bb
			STORE PADL(bb,6,[0]) TO bb
			REPL pickup_id WITH  bb, cust_type WITH [R], state WITH [KY],data_quali WITH [1], SOURCE WITH [R], first_star WITH DATE(), last_updat WITH DATE(),last_calc WITH DATE()
**!*!*!*!*! !*  INSERT THE CUST_ID HERE TOO  *!*!*!*!**!*!*!
		CASE buttn=2
			IF .NOT. BOF()
				SKIP -1
			ENDIF
		CASE buttn=3
			IF .NOT. EOF()
				SKIP
			ENDIF
		CASE buttn=4
			REPL last_updat WITH DATE()
			DELETE
		CASE buttn=5
			GOTO TOP
		CASE buttn=6
			GOTO BOTTOM
		CASE buttn=7
			DO QUIT_ACT WITH [Q]
		CASE buttn=8
			BROWSE LAST
		CASE buttn=9
			CLOSE DATA
*   SELE act_cust
*   USE
			!act_bak.bat
			DO view_set
*   USE act_cust shared
			SELE act_cust
			SET ORDER TO 0
			GOTO BOTTOM
		ENDCASE
		UNLOCK ALL
		SHOW GETS
		RETURN


********************************************************************************
********************************************************************************
********************  CUSTOMER TYPE VALIDATION  ********************************
********************                            ********************************
********************************************************************************
********************************************************************************

	PROCEDURE act_cust  &&VALIDATE THE CUSTOMER PRICING.
		PARAMETER c_type

		c_type =ALLTRIM(c_type)
		IF c_type<=[ ]
			REPLACE cust_type WITH [R]
			STORE [R] TO c_type
		ENDIF

		IF mthly_rate<0.01


&&			SELE act_code  &&if no price then set from
&&			SEEK c_type
&&			IF FOUND()
&&				REPL act_cust.mthly_rate WITH act_code.price   &&
			REPL act_cust.mthly_rate WITH mth_rate_r   &&				WSH 8/24/03  USE ACT_LOCAL vals to configure, not act_code's
&&			ENDIF
			SELE act_cust
		ENDIF

		UNLOCK ALL
		SHOW GETS
		RETURN


********************************************************************************
********************************************************************************
********************  SEEK                      ********************************
********************************************************************************
********************************************************************************

	PROCEDURE act_seek
		PARAMETER buttn
		PUBLIC l,S,P,c
		STORE [                                    ] TO l,S,P,c
		STORE [ ] TO c

		SET NEAR ON
		ACTIVATE WINDOW msg2user
		CLEAR

		DO CASE
		CASE buttn=1
			SET ORDER TO TAG bothnames
			?
			ACCE [Enter lastname+" "+firstname =====>] TO l
			SEEK l
		CASE buttn=2
			SET ORDER TO TAG Phone
			?
			ACCE [Enter Phone ========>] TO P
			SEEK P
		CASE buttn=3
			SET ORDER TO TAG address
			?
			ACCE [Enter Street Address =======>] TO S
			SEEK S
		CASE buttn=4
			SET ORDER TO TAG pickup_id
			?
			ACCE [Enter Customer ID ==>] TO c
			SEEK c
		CASE buttn=5
			SET ORDER TO TAG map
			?
			ACCE [Enter PVA Map # ==>] TO c
			SEEK ALLTRIM(c)
		CASE buttn=6
			SET ORDER TO TAG pva_acct
			?
			ACCE [Enter PVA Account # ==>] TO c
			SEEK ALLTRIM(c)
		ENDCASE
		DEACTIVATE WINDOW msg2user
		SHOW GETS
		RETURN

********************************************************************************
********************************************************************************
******************** print                    ********************************
********************************************************************************
********************************************************************************

	PROCEDURE act_print
		PARAMETER buttn
		PUBLIC yn
		STORE [N] TO yn

		?
		ACCE [Are you sure that you want to print the entire Customer list? y/n==>] TO yn
		IF yn$[Yy]
			SET ORDER TO TAG lname  && *!*!*!*
			REPO FORM act_cusl TO PRINTER
			!DIR
		ENDIF
		SHOW GETS
		RETURN

********************************************************************************
********************************************************************************
******************** No Order                     ********************************
********************************************************************************
********************************************************************************

	PROCEDURE act_order
		PARAMETER buttn
		SET ORDER TO 0
		SHOW GETS
		RETURN

********************************************************************************
********************************************************************************
******************** End of ACT_Fast********************************************
********************************************************************************
********************************************************************************




********************************************************************************
********************************************************************************
	PROCEDURE genlatefees 	&& Late Charges Applied to all overdue residential customers
********************************************************************************
********************************************************************************
&& run this from a menu command button to add late fees to customer records.


&& if an inactive customer has a past due of more than 12.50 (current m rate) & is reactiveated in the first two weeks of the
&& month- they will get a late charge ??
		PRIVATE MONTH,c,r,A,b,due,YEAR,distrix,m_t,m_r, ok2go,w_a,w_b,w_c,w_d,w_e,w_flag,w_m, w_res_rate
		PRIVATE cp,ct,t_t,p_p
		PRIVATE mnth_tot, mnth_res, mnth_com, mnth_ina,mth_allc,mth_resc,mth_inac,mth_comc
		PRIVATE type_of_run, jjuunnkk,w_qr
		STORE [ ] TO type_of_run
		STORE [ ] TO jjuunnkk
		STORE 1.0 TO w_qr  &&1=monthly, 3=quarterly
		STORE [          ] TO MONTH
		STORE [    ] TO YEAR
		STORE [           ] TO due
		STORE [012345] TO distrix
		STORE [B] TO c
		STORE [0] TO bill_num
		STORE [M] TO m_t
		STORE 1.000 TO m_r  && this has to be tweeked for counties that hav different interest rates for C vs R
		STORE .F. TO ok2go

&&		SELE ACT_CODE
&&		        SEEK [R]
&& store act_code.price to w_res_rate  && snag the regular residential monthly charge as $nnnnnn.nn
		STORE mth_rate_r TO w_res_rate  && snag the regular residential monthly charge as $nnnnnn.nn
&&			SEEK [L]  && snag the montly late fee %age
&&			IF FOUND()
&& STORE act_code.price TO w_d
		STORE late_rate_res TO w_d
		CLOSE DATA
		CLEAR
		? [**  C H A R G E       R E S I D E N T I A L      L A T E        F E E S   **]
		? [    This procedure applies late fees for customers that have not paid their most ]
		? [recent bill within 2 weeks of our mailing them.  They must have outstanding balances.]
		? [The balance must equal or exceed the monthly Residential Fee to incur the late fee.]
		? [This is a one time fee.]
		? [    Caution!  There are few safeguards on the Late Charges.  Do NOT run this  twice]
		? [in the same month or you will overcharge the penalized cutomer. ]
		? [    Only Residential customers are charged late fees.  Inactive customers will not ]
		? [be charged. ]
		? [    Use the Utility Menu to A)dd or E)dit Services to change the Late Rate Charge.]
		? [ It is listed in the PRICE column as a percentile, i.e: 10.0=10.0% of one month's bill]
		? [ The current rate is:]+STR(w_d,6,2)+[% of one months bill.]

		STORE [R] TO type_of_run

		DO view_set
		STORE 0 TO w_m
		SELE act_cust            &&  of the CODE "M" item.
		GO TOP

		IF yesno ([Proceed to apply Late Charges ? ])
			CLEAR
TEXT


 				        PLEASE WAIT:  Late Charges Are Being Applied


ENDTEXT
			SET STATUS BAR OFF
			SET TALK OFF
			DO reindxm       && reindex prior to accounting
			DO calc_balance  && computes the current account balance per customer
			SELE act_main
			SET RELA OFF INTO act_cust

			SELE act_cust
			SET ORDER TO cust_type
			SET FILTER TO (cust_type$type_of_run)  &&Commercial or Residential?
			STORE 1 TO w_qr		&& presume monthly (commercials)

			GOTO TOP
			DO WHILE .NOT. EOF()
* APPLY LATE FEE TO CURRENT CUSTOMER  (INVOICE COMES NEXT).
				STORE act_cust.pickup_id TO c_tmp
&& harvest the dollars paid this month from the customer's record
				IF act_cust->mthly_rate>0.0  && accomodate late fees as %ages of regular rates.
					w_m=act_cust->mthly_rate  &&CUST HAS OWN PRICE IE:  SR. CITIZENS
				ELSE
					w_m=w_res_rate  && THE STANDARD MONTHLY
				ENDIF
				IF (act_cust.totl_amt>w_m)  .AND. (VAL(act_cust.prec_nam)<w_m) && recycle prec_nam field to reflect if user has paid this month
&& only charge residentials with due>mthly rate and only if they haven't paid this months bill yet
*CREATE NEW invoice RECORD IN MAIN
					REPLACE rev_date WITH DATE() && assign the latest billing date to the cust record
&&    M A K E   I N V O I C E
					SELE act_main
					ar_i=add_1([IN])
					UNLOCK ALL
					REPL invoice WITH ar_i
					REPL srvc_dat WITH DATE()
					REPL rev_date WITH DATE()  && billing date
					REPL pickup_id WITH act_cust.pickup_id
					REPL cust_id WITH act_cust.pickup_id  &&  wh 7/03
					REPL lname WITH act_cust->lname
					REPL fname WITH act_cust->fname
					REPL INITIAL WITH act_cust->INITIAL
					REPL Phone  WITH act_cust->Phone
					REPL address WITH act_cust->address
					REPL address2 WITH act_cust->address2
					REPL city WITH act_cust->city
					REPL zip WITH act_cust->zip
					REPL state WITH act_cust->state
					REPL dob WITH act_cust->dob
					UNLOCK ALL
*CREATE NEW RECORD IN SCR
					SELE act_scr
					APPEND BLANK
					REPLACE invoice WITH act_main.invoice
					REPL act_scr->c1 WITH 1
					REPL act_scr->i1 WITH [LATE CHARGE]
					REPL act_scr->code1 WITH [L]
					IF act_cust->mthly_rate>0.0  && accomodate late fees as %ages of regular rates.
						w_m=act_cust->mthly_rate  &&CUST HAS OWN PRICE IE:  SR. CITIZENS
					ELSE
						w_m=w_res_rate  && THE STANDARD MONTHLY
					ENDIF
					REPL act_scr->p1 WITH (w_m*(0.01*w_d))    &&charge for residential per month
					UNLOCK ALL
					DO scr_subtot  &&build service strings and invoice total
				ENDIF  && w_flag--was [CcRc] with past debt
				UNLOCK ALL
				SELE act_cust
				SKIP  && next
			ENDDO  &&all customers
			CLOSE DATA

			DO view_set
			DO calc_balance  &&apply the new charges to all accounts
			CLEAR
			?[ Late Fees have been charged.]
			? []
			WAIT
			CLEAR

		ENDIF

&&		ELSE  &&NOT FOUND [L]
&&			?[ERROR:  Late Rate not found. Please set this value.]
&&			?[ Use the Utility Menu to A)dd or E)dit Services to change the rate. ]
&&			?[ It is listed in the PRICE column as a percentile:  i.e.. 0.83=0.83%/month (=10%/yr)]
&&			WAIT
&&			Clear
&&		ENDIF
		CLOSE DATA
		DO view_set
		CLEAR
		RETURN






********************************************************************************
********************************************************************************
	PROCEDURE genbills  && Finance Charges Applied to all active current customers       *******
		PRIVATE month_string, months,quarters
		STORE [JANUARYAPRILJULYOCTOBER] TO quarters
		STORE [JANUARYFEBRUARYMARCHAPRILMAYJUNEJULYAUGUSTSEPTEMBEROCTOBERNOVEMBERDECEMBER] TO months
		STORE quarters TO month_string

		PUBLIC MONTH,c,r,A,b,due,YEAR,distrix,m_t,m_r, ok2go,w_a,w_b,w_c,w_d,w_e,w_flag,w_m
		PUBLIC cp,ct,t_t,p_p
		PUBLIC mnth_tot, mnth_res, mnth_com, mnth_ina,mth_allc,mth_resc,mth_inac,mth_comc
		PUBLIC type_of_run, jjuunnkk,w_qr
		STORE [ ] TO type_of_run
		STORE [ ] TO jjuunnkk
		STORE 1.0 TO w_qr  &&1=monthly, 3=quarterly
		STORE [          ] TO MONTH
		STORE [    ] TO YEAR
		STORE [           ] TO due
		STORE [12345] TO distrix
		STORE [B] TO c
		STORE [0] TO bill_num
		STORE [M] TO m_t
		STORE 1.000 TO m_r  && this has to be tweeked for counties that hav different interest rates for C vs R
		STORE .F. TO ok2go
&&		SELE act_code
&&SET MONTHLY RATE
&&		SEEK m_t
&&		IF FOUND()
&&			STORE (.01*price) TO m_r    && THE MONTHLY Finance Charge RATE IS CODED AS 1.5=1.5%/MONTH, in the PRICE column
		STORE (.01*int4mnth) TO m_r    && THE MONTHLY Finance Charge RATE IS CODED IE:1.5=1.5%/MONTH, in ACT_LOCAL.INT4MNTH
&&			SEEK [R]
&&			IF FOUND()
&&				STORE act_code.price TO w_d
		STORE mth_rate_r TO w_d
		CLOSE DATA
		CLEAR
		? [**  C h a r g e   I n t e r e s t    a n d    G e n e r a t e    B i l l s   **]
		?[    This procedure sets charges & computes account balances for customers.]
		?[ You must choose either Residential charges, or Commercial charges.  Choosing]
		?[ R)esidential creates  bills for active residential customers after applying  their]
		?[ payments & late charges.  Create commercial bills from the Main Menu, using ]
		?[ R)ecords, Bills/Cr)edits, anytime during the month. Run the Commercial ]
		?[ procedure to apply their finance charges.]
		?[ NO INTEREST IS CHARGED TO BILLS PAST DUE UNTIL ONE MONTH AFTER THEY ARE ]
		?[ BILLED, ie: a bill printed 1/31 and not paid by 2/31, is not overdue.]
		?[    Monthly vs Quarterly billing is changed by setting the VAR Billing_Cycle to M|Q]
		?[and recompiling the program, currently set to=> ],billing_cycle
		?[    Caution!  There are few safeguards on the Finance Charges.  The data ]
		?[ files are backed up- Save the files .\BAK1\*.ZIP before running this]
		?[ procedure (you can switch windows right now and copy the files if you ]
		?[ need to, switch back when you are done). ]
		?[    Inactive customers will not be charged.  Other past accounts will be.]
		?[ ONLY the customer type, C or R, that you select will be charged (not both).]
		?[ The current Finance Charge rate is:]+STR(100*m_r,6,2)+[% per month.]
		?
		?
		? [Compute charges for C)ommercial or R)esidential customers?]
		ACCE [  Enter 'C' or 'R'==>] TO type_of_run
		DO view_set
		STORE w_d TO w_m
		SELE act_cust            &&  of the CODE "M" item.
		GO TOP
		STORE UPPER(ALLTRIM(type_of_run)) TO type_of_run
		IF .NOT. (type_of_run$[CR])
			ACCE [Please choose C)ommercial or R)esidential customers.  Enter 'C' or 'R'==>] TO type_of_run
		ENDIF

		IF ([M] $ billing_cycle)
			STORE months TO month_string
		ELSE
			STORE quarters TO month_string
		ENDIF

		IF ((type_of_run$[R]).AND.(.NOT.(UPPER(CMONTH(DATE()))$month_string)))
			CLEAR
			?[]
			?[You can only run Residential Bills in JANUARY, APRIL, JULY, or OCTOBER.]  && can only get this error w/ Quarterly billing
			?[]
			ACCE[Press <ENTER> to continue.] TO jjuunnkk
		ELSE
			IF yesno ([Proceed to apply Charges and Monthly Rates to Customer Type ]+type_of_run+[?])
				SET STATUS BAR OFF
				SET TALK OFF
				? [** Reindex **]
				DO reindxm       && reindex prior to accounting
				? [** Calculate Balances **]
				DO calc_balance  && computes the current account balance per customer
				? [** Begin Billing  **]
				SELE act_main
				SET RELA OFF INTO act_cust

				SELE act_cust
				SET ORDER TO cust_type

				SET FILTER TO (cust_type$type_of_run)  &&Commercial or Residential?
&& T H E    R U L E S
&&just bill commercial OR regular customers that have balances due
&& --if they are prepaid, they will not be computed, or billed.
&& Residential bills will be generated by constructing an invoice for 1 (M) or 3 (Q) months of services.
&& Commercial billing invoices have aleady been made.
&& Ignore inactive customers.
				STORE 1 TO w_qr		&& presume monthly (commercials)


&& add logic to NOT charge interest
				? [ Flag setting for No Residential Interest ==>],no_int4res
				? [ Flag setting for No Commercial Interest ==>],no_int4c
				IF (type_of_run$[R])  && Here is where the residentials get their monthly interest rate adjusted for quarterly billing
					IF ([T]$no_int4res )
						STORE 0 TO m_r
					ENDIF  &&set interest charge to 0
				ELSE  && its a commercial run
					IF ([T]$no_int4c )
						STORE 0 TO m_r
					ENDIF  &&set interest charge to 0
				ENDIF

&& fix the interest rate for quarterly as 3x monthly rate
				STORE 1.0+m_r TO w_a  && Commercials & Monthlys
				IF (type_of_run$[R])  && Here is where the residentials get their monthly interest rate adjusted for quarterly billing
					IF ([Q] $ billing_cycle)    && if billing quarterly, triple the monthly interest rate
						STORE 3 TO w_qr	 && assign three months to account for the quarterly billing
					ENDIF
					STORE 1.0+(w_qr*m_r) TO w_a  && muliply by three for quarterly billing
				ENDIF

				STORE 0 TO mnth_tot && prep accumulator for monthly finance charges
				STORE 0 TO mnth_com  && ditto for commercial fin .
				STORE 0 TO mnth_res && finance charege on Residentials owing >0.00
				STORE 0 TO mth_allc && count all recs of all tyoes
				STORE 0 TO mth_comc  && Com count
				STORE 0 TO mth_resc && res count
				GOTO TOP
				DO WHILE .NOT. EOF()
					STORE mth_allc+1 TO mth_allc  &&count this record
* APPLY MONTHLY RATE TO CURRENT BALANCE AND ASSIGN TO CUSTOMER RECORD (INVOICE COMES NEXT).
					STORE .F. TO w_flag
					STORE 0.0 TO w_c
					STORE 0.0 TO w_b
					STORE act_cust.pickup_id TO c_tmp


					IF ((cust_type=[R]) .AND. (totl_amt>0.0))  && Charge Interest:  residential customer with past due
						STORE totl_amt*w_a TO w_b  &&NEW TOTAL AMOUNT INCLUDING FINANCE CHARGE
						STORE totl_amt*(w_qr*m_r) TO w_c  &&FINANCE CHARGE
						REPLACE totl_amt WITH w_b  &&ADD THE NEW AMOUNT TO THE TOTAL
						STORE mnth_tot+w_c TO mnth_tot
						STORE mnth_res+w_c TO mnth_res
						STORE mth_resc+1 TO mth_resc  && count in the residential count
						w_flag=.T.
					ELSE
						IF ((cust_type=[C]) .AND. (totl_amt>0.0))  &&commercial customer with past due
							STORE totl_amt TO t_t
							SELECT act_main
							STOR ORDER() TO cidx
							SET ORDER TO TAG pickup_id
							STORE 0. TO ct
							SEEK c_tmp
							IF FOUND()
								DO WHILE pickup_id=c_tmp  &&This rule only works for monthly billing
&&  HERE T=C-P=(Ct-Cp)-P AND T-Ct=Cp-P,where T=Total, C=Costs,P=Payments
&& IF T-Ct IS POS THEN PAST COSTS EXCEED ALL PAYMENTS, and they owe interest
									IF (MONTH(act_main.rev_date)>=MONTH(GOMONTH(DATE(),-1)) )
&& if the month the bill was printed is this month or last month, it's a Ct.
*for current month, add charges and deduct from pre calculated total
										ct=ct+total_amt
									ENDIF
									SKIP
								ENDDO
&& now holds Ct, the current months charges, deduct it from total for customer
							ENDIF
							SET ORDER TO cidx
							SELE act_cust
							IF totl_amt-ct > 0  &&past costs > than all payments
								STORE totl_amt+((totl_amt-ct)*m_r) TO w_b  &&NEW TOTAL AMOUNT INCLUDING FINANCE CHARGE
								STORE (totl_amt-ct)*m_r TO w_c  &&FINANCE CHARGE
								REPLACE totl_amt WITH w_b  &&ADD THE NEW AMOUNT TO THE TOTAL
								STORE mnth_tot+w_c TO mnth_tot  && add to total finance charge for month
								STORE mnth_com+w_c TO mnth_com  && add for commercial only
								STORE mth_comc+1 TO mth_comc  && commercial count
								w_flag=.T.
							ENDIF
						ENDIF
					ENDIF


					IF (w_c>0.0) .OR. (cust_type=[R])  && [R] will MAKE INVOICE FOR ALL CHARGES
*NOW CREATE AN INVOICE FOR THIS FINANCE CHARGE
*CREATE NEW invoice RECORD IN MAIN    * (from orig invoice add line in menu)

						REPLACE rev_date WITH DATE() && assign the latest billing date to the cust record
&&we are billing this one--put billing date into cust record
&&     D O N E    W I T H    A C T _ C U S T

&&    M A K E   I N V O I C E
						SELE act_main
						ar_i=add_1([IN])
						UNLOCK ALL
						REPL invoice WITH ar_i
						REPL srvc_dat WITH DATE()
						REPL rev_date WITH DATE()  && billing date
						REPL pickup_id WITH c_tmp
						REPL cust_id WITH c_tmp  &&  added WSH WSH WSH 9/7/1999
						REPL lname WITH act_cust->lname
						REPL fname WITH act_cust->fname
						REPL INITIAL WITH act_cust->INITIAL
						REPL Phone  WITH act_cust->Phone
						REPL address WITH act_cust->address
						REPL address2 WITH act_cust->address2
						REPL city WITH act_cust->city
						REPL zip WITH act_cust->zip
						REPL state WITH act_cust->state
						REPL dob WITH act_cust->dob
						UNLOCK ALL

*CREATE NEW RECORD IN SCR
						SELE act_scr
						APPEND BLANK
						REPLACE invoice WITH act_main.invoice
						IF (w_c>0.0)  &&THERE IS A FINANCE CHARGE
							REPL act_scr->c1 WITH 1  &&either 1 or 3, if commercial (monthly) vs quarterly  && Fixed 3x interest bug wsh 10/21/05
							REPL act_scr->i1 WITH [FINANCE CHARGE ]
							REPL act_scr->code1 WITH [F]
							REPL act_scr->p1 WITH w_c  &&the finance charge computed above
							IF act_cust.cust_type=[R]  &&plow IN residential bills
								REPL act_scr->c2 WITH w_qr && w_qr=3 is the quarterly count of monthly services (was 1)
								REPL act_scr->i2 WITH [RESIDENTIAL]
								REPL act_scr->code2 WITH [R]
								IF act_cust->mthly_rate>0.0  &&CUSTOMER HAS OWN PRICE, IE:  SR.  CITIZENS
									w_m=act_cust->mthly_rate
								ELSE
									w_m=w_d  &&THE STANDARD MONTHLY
								ENDIF
								REPL act_scr->p2 WITH w_m  &&charg for residential per month
							ENDIF
						ELSE  &&MAYBE ONLY RESIDENTIAL CHARGE
							IF act_cust.cust_type=[R]
								REPL act_scr->c1 WITH w_qr && 3 is the quarterly count of monthly services (was 1)
								REPL act_scr->i1 WITH [RESIDENTIAL]
								REPL act_scr->code1 WITH [R]
								IF act_cust->mthly_rate>0.0
									w_m=act_cust->mthly_rate  &&CUST HAS OWN PRICE IE:  SR. CITIZENS
								ELSE
									w_m=w_d  && THE STANDARD MONTHLY
								ENDIF
								REPL act_scr->p1 WITH w_m  &&charg for residential per month
							ENDIF
						ENDIF
						UNLOCK ALL
						DO scr_subtot  &&build service strings and invoice total
					ENDIF  && w_flag--was [CcRc] with past debt
					UNLOCK ALL
					SELE act_cust
					SKIP  && next
					?? [.]
				ENDDO  &&all customers
				CLOSE DATA
				? [** Finished Processing Customers, Make Summary Record **]
				USE act_mfin  && use monthly billing record
				APPE BLANK  && add a record for this billing

				REPLACE tot_fin WITH mnth_tot && prep accumulator for monthly finance charges
				REPLACE tot_com WITH mnth_com  && ditto for commercial fin .
				REPLACE tot_res WITH mnth_res && finance charege on Residentials owing >0.00
				REPLACE countall WITH mth_allc && count all recs of all tyoes
				REPLACE countcom WITH mth_comc  && Com count of folks getting finance charges
				REPLACE countres WITH mth_resc && count of residentials getting finance charges
				REPL act_mfin.run_time WITH TIME()
				REPL act_mfin.run_date WITH DATE()
				USE

				DO view_set
				DO calc_balance  &&apply the new charges to all accounts
				CLEAR
				?[  Finance Charges have been applied to all customers of type: ]+type_of_run+[.]
				? []
				IF ([R]$type_of_run)
					?[  Bills were generated for all active Residents.  You are ready to print ]
					?[  the generated bills.]
					?
					?[  Please prepare the printer(s) and select M)onthly Bills from the ]
					?[  Main Menu, Select P)rint when you are ready to start.]
				ELSE
					?[  Finance charges were generated for all active Customers.   ]
					?[  You are ready to print the generated bills.]
					?
					?[  Please prepare the printer(s) and select M)onthly Bills from the ]
					?[  Main Menu, Select C)ommercials when you are ready to start.]
				ENDIF
				?
				?
				WAIT


			ENDIF
		ENDIF  && r type & not month 1,4,7,or 10
&&			ELSE  &&NOT FOUND [R]
&&				? [ERROR! Cannot find Residential Price in ACT_CODE.DBF, billing generation canceled.]
&&				? " Use Utility Menu A)dd or E)dit Services to create.  Set CODE=[R] and the price.  "
&&				WAIT

&&			ENDIF
&&		ELSE  &&NOT FOUND [M]
&&			?[ERROR:  Monthly Interest Rate not found. Please set this value.]
&&			?[ Use the Utility Menu to A)dd or E)dit Services to change the rate. ]
&&			?[ It is listed in the PRICE column as a percentile:  i.e.. 1.5=1.5%/month]
&&			WAIT

&&		ENDIF
		CLOSE DATA
		DO view_set
		CLEAR
		RETURN


********************************************************************************
********************************************************************************
**************************** Print Bill  ***************************************
********************************************************************************
********************************************************************************
	PROCEDURE printbill


&& ====>  THIS PROC HAS BEEN HACKED TO COERCE A 6 LPI CARD FACE, DUMPING THE 8 LPI INSTRUCTIONS  <======


* THESE COMMENTS APPLY ONLY TO THE RESIDENTIAL BILLS
*  THIS PROC IS SET UP FOR A 4.25 INCH PAGE PRINTED AS 26 6" LINES.  THE FIRST
*  24 LINES ARE AT 6 LPI AND THE LAST 2 ARE AT 8 LPI.
*
*     TWO TYPES OF PRINTERS ARE SUPPORTED:  EPSON DFX 5000 AND PANASONIC 1180.
*  THE PANASONIC IS A BASIC SETTING, HOWEVER WE GENERALLY USE THE EPSON DFX 5000.
*
*  THE BILL IMAGE IS IN THE FILE ACT_FORM.  BROWSE THIS FILE (W/ TERMINAL FONT) TO EDIT.
*  DO NOT ADD LINES TO ACT_FORM.  YOU MAY ADJUST THE TEXT AND THE LOCATION OF
*  FIELDS BY MOVING THE @ TOKENS EMBEDDED IN ACT_FORM.  IF YOU LEAVE OUT CRITICAL FIELDS
*  A RUNTIME ERROR WILL OCCUR WHEN YOU PRINT THE BILLS, INDICATING AN 'OPERATOR/OPERAND'
*  MISMATCH.  RESTORE THE @ FIELDS TO ACT_CUST TO REPAIR THIS ERROR.
*
*  BILLS ARE ULTIMATELY FILTERED TO BE EITHER [R] OR [C] TYPES.  THEY ARE LIMITED TO $
*  AMOUNTS >1.00, AND TO THE DISTRICTS YOU INDICATE AT RUN TIME.
*
*  BILLS ARE PRINTED TO TEXT FILES ON \TEMP.  LSW_BILL.001 HOLDS THE RESIDENTIAL IMAGES,
*  LSW_BILL.002 HOLDS THE COMMERCIALS.
		ACTIVATE SCREEN
		PUBLIC b_mo,b_mo1,b_mo2,b_du,b_du1,b_du2,b_am,b_am1,b_am2,b_id,b_id1,;
			b_id2,b_na,b_na1,b_na2,b_ad,b_ad1,b_ad2
		PUBLIC b_ci,b_ci1,b_ci2,b_di,b_di1,b_nu,b_nu1,b_co,b_co1,l_n,l_j,l_m  && Bill fields
		PUBLIC zipout, sequence_number
		STORE [N] TO zipout
		STORE 0 TO sequence_number
		PRIVATE iziz
		STORE [] TO iziz
&&ASSIGN HIGH LINE NUMBERS TO CODES THAT MAY GET PULLED FROM CARD

		STORE 99999 TO b_co
		STORE 99999 TO b_ci
		STORE 99999 TO b_di
		STORE 99999 TO b_nu

		PUBLIC MONTH,c,r,A,b,due,YEAR,distrix,m1,p1,p2,p3,p4,p5,p_order
		PUBLIC bidir,COMP,uncomp,lpi8,lpi6,noskip, lpi8eps,lpi6eps
		PUBLIC tot_m,avg_m
		PUBLIC make_a_dun_file
		STORE [N] TO make_a_dun_file
		STORE 0 TO tot_m
		STORE 0 TO avg_m

		STORE [Z] TO p_order
		STORE [          ] TO MONTH
		STORE [    ] TO YEAR
		STORE [           ] TO due
		STORE [12345] TO distrix
		STORE [B] TO c
		STORE [0] TO bill_num
		STORE [A] TO m1

		STORE CHR(27)+CHR(85)+CHR(0) TO  bidir     && {panasonic 1180 PRINTER codes}
		STORE  CHR(15) TO COMP
		STORE  CHR(18) TO uncomp


&&		STORE  CHR(27)+CHR(48) TO lpi8
		STORE  CHR(27)+CHR(50) TO lpi8  && WSH 9/26/03 :  CHEAT HACK TO CHANGE TO ALL 6 LPI FORM.... MAKE ALL 8LPI into 6LPI...


		STORE  CHR(27)+CHR(50) TO lpi6
		STORE  CHR(27)+CHR(79) TO noskip           &&  {END OF panasonic codes}

		STORE  CHR(27)+CHR(64) TO lpi6eps     && {epson 5000dfx PRINTER codes}

&& 		STORE  CHR(27)+CHR(48) TO lpi8eps
		STORE  CHR(27)+CHR(64) TO lpi8eps   && WSH 9/26/03 :  CHEAT HACK TO CHANGE TO ALL 6 LPI FORM.... MAKE ALL 8LPI into 6LPI...


		PRIVATE w_res_rate ,w_d
		STORE 0.0 TO w_res_rate
		STORE 0.0 TO w_d

&&		SELE ACT_CODE
&&		        SEEK [R]
&&		          store act_code.price to w_res_rate  && snag the regular residential monthly charge
		STORE mth_rate_r TO w_res_rate  && snag the regular residential monthly charge  WSH 8/24/03
&&			SEEK [L]  && snag the montly late fee %age
&&			IF FOUND()
&&				STORE act_code.price TO w_d
		STORE late_rate_res TO w_d		&& WSH 8/24/03
&&			endif
		DO view_set
		CLEAR
		? [   *************   Solid Waste Billing   ************]
		?
		IF (act_cust.last_calc<DATE())
			?[ Balances are out-of-date. They were written ]+DTOC(act_cust.rev_date)
			?[ Warning:  Generated bills are old and must be recalculated.  Please wait...]
&& wsh 4/10/2001
			CLOSE DATA
			DO view_set
			DO calc_balance  &&apply new charges to all accounts
			CLEAR
			? [  Welcome back, the bills are calculated & ready to print.  ]
			?

		ENDIF

		?
		? [This procedure prints the bills generated with the ]
		? [Main Menu option M)onthly Bills, G)enerate Bills.]
		? [   You may choose to print the bills directly from this machine,]
		? [make dbf and txt files to be printed elsewhere,  or send the data]
		? [ to the MailMan program to print them with bar codes.]
		? [                         ****]
		? [Bills last generated on:],act_cust.last_calc
		? []

&&repaint user screen--wsh 4/10/2001
		IF yesno([OK? N)o will quit the Bill Printing procedure.])
			CLEAR
			?
			? [   *************   Solid Waste Billing   ************]
			? []
			? [                 Billing and Due Date Menu]
			? []
			? []
			? [    Enter the Month and Year for this billing and the due date.]
			? []

			ACCE [Enter Month (ie: May ) to print on bill=>] TO MONTH
			?
			ACCE [Enter Year (ie:  1999) to print on bill=>] TO YEAR
			my=ALLTRIM(MONTH)+[  ]+YEAR
			? my
			ACCE [Enter Date Due (ie:  01/15/99) to print on bill=>] TO due
			?
			ACCE [Print C(ommercial, R(esidential or B(oth bills (C, R, or B)=>] TO c
			?
			ACCE [Enter the Districts to print (ie: 012345), just numbers, no spaces=>] TO distrix
			?
			ACCE [Set the print order of the Bills: Z)ip or R)oute=>]  TO p_order
			IF .NOT. (p_order$[ZzRr])
				STORE [Z] TO  p_order
			ENDIF
			?
			ACCE [S)end data to MailMan for Bar Coding, or N)ot =>] TO zipout
			IF .NOT. (zipout$[SsNn])
				STORE [S] TO  zipout
			ENDIF

&&    ACCE [Make a D)un File or N)ot (NB:  You MUST still run LSW_DUN later) =>] TO Make_a_Dun_File
&&    IF .NOT. (Make_a_Dun_File$[DdNn])
			STORE [N] TO  make_a_dun_file
&&    ENDIF
			?

			CLEAR
			? [ PLEASE WAIT.  STARTED AT:],TIME(), DATE()
			?

&&				SET TALK OFF
&&				SET STATUS BAR OFF
&&				SET HISTORY OFF
&&				SET CONSOLE OFF

			SELE 0

			USE act_form SHARED  &&  *!**!*!*!**!**! LOAD BILL IMAGE FROM ACT_FORM.DBF
&&  NB funny @9 tag fixedup below--@9 lies in the @8 line, not in it's own line.
			COPY TO ARRAY l_b    &&  *!*!*!*!*!**!   AND COPY IT TO L_B
			COPY TO ARRAY l_c
			USE
			ACTIVATE SCREEN
			? [ Done Prepping, Press Enter to Continue]  && dummy prompt to get user to hit enter.
			IF zipout $ [Ss]
				IF c$[RrBb]
					SELE act_cust
					IF p_order$[Zz]
						SET ORDER TO TAG zip && *!*!*! &&zip order
					ELSE
						SET ORDER TO TAG route  && or route order
					ENDIF
					GOTO TOP
					ERASE \temp\lsw_bil1.DBF

					SELECT 0  &&grab open workspace
					USE act_mbil EXCL  && use monthly billing record
					APPE BLANK  && add a record for this billing
					SELE act_cust

&& capture bill run info into act_mbil
					REPL act_mbil.bill_time WITH TIME()
					REPL act_mbil.bill_date WITH DATE()
					REPL act_mbil.bill_distx WITH distrix
					REPL act_mbil.bill_type WITH c
					REPL act_mbil.bill_2zip WITH zipout
					REPL act_mbil.bill_due WITH due
					REPL act_mbil.bill_for WITH my
					REPL act_mbil.blz_calcd WITH act_cust.last_calc
					ACTIVATE SCREEN
					? [** Made Entry  For This Monthly Billing**]
&& w_res_rate, w_d
					COPY TO \temp\lsw_bil1.DBF FIELDS lnamefname,pickup_id, lname, fname, INITIAL, address, address2, city,;
						state, zip,totl_amt,compound,data_stg,prec_num,prec_nam,dob,location ALL FOR ((LEFT(ALLTRIM(district),1)$distrix));
						.AND. (totl_amt>1.00) .AND. (cust_type$[Rr]) && don't send bills less than 1 dollar, or to inactive customers.

					USE \temp\lsw_bil1.DBF
					REPL ALL lnamefname WITH ALLTRIM(fname)+[ ]+INITIAL+[ ]+ ALLTRIM(lname),; && lnamefname with last first
					data_stg WITH my, ; && service term, ie :August...the month of service being billed.
					prec_num WITH STR(w_res_rate*(w_d/100),5,2), ; &&  compute & report the late charge
					prec_nam WITH STR(w_res_rate,5,2), ; &&  compute & report the monthly residential charge
					compound WITH ALLTRIM(due)  && send due date as fname, dodge the ctod bugs.
					REPL ALL fname WITH STR(w_res_rate*((w_d/100))+totl_amt,10,2)  && compute & report total due after late fee
					REPL ALL lname WITH ALLTRIM(location)  && transfer location as char field, not memo.
					USE  && close the monthly billing dbf
					USE \temp\lsw_bil1.DBF
					STORE [\temp\lsw_bill_]+ALLTRIM(STR(MONTH(DATE())))+[_]+ALLTRIM(STR(DAY(DATE())))+[_]+ALLTRIM(STR(YEAR(DATE())))+[.txt] TO iziz
					COPY TO \temp\lsw_4bcc.txt TYPE DELIMITED  && make a comma delimited file for mailman.
					COPY TO (iziz) TYPE DELIMITED  && make a comma delimited file for mailman, with date name.
					STORE [\temp\lsw_bill_]+ALLTRIM(STR(MONTH(DATE())))+[_]+ALLTRIM(STR(DAY(DATE())))+[_]+ALLTRIM(STR(YEAR(DATE())))+[.dbf] TO iziz
					COPY TO (iziz)   && save a second copy with the unique date name
&&  wsh 10/27/97
					ACTIVATE SCREEN
					? [ **  Copied Billing Data to \TEMP **]
					REPL act_mbil.tot_count WITH RECCOUNT(lsw_bil1)  && count # of rex
					SUM lsw_bil1.totl_amt ALL TO  tot_m
					REPL act_mbil.tot_amt  WITH tot_m&&all $
					AVERAGE lsw_bil1.totl_amt ALL TO avg_m
					REPL act_mbil.avg_bill WITH avg_m  &&avg $/bill
					USE
					SELE act_mbil
					USE  && close the monthly billing dbf
					ACTIVATE SCREEN
					? [ ** Closed Billing Record **]
				ENDIF
				? [**if c$CcBb**]
				IF c$[CcBb]
					SELE act_cust
					IF p_order$[Zz]
						SET ORDER TO TAG zip && *!*!*! &&zip order
					ELSE
						SET ORDER TO TAG route  && or route order
					ENDIF

					GOTO TOP
					ERASE \temp\lsw_bil2.DBF
					SELECT 0  &&grab open workspace
					USE act_mbil EXCL  && use monthly billing record
					APPE BLANK  && add a record for this billing
					SELE act_cust

&& capture bill run info into act_mbil
					REPL act_mbil.bill_time WITH TIME()
					REPL act_mbil.bill_date WITH DATE()
					REPL act_mbil.bill_distx WITH distrix
					REPL act_mbil.bill_type WITH c
					REPL act_mbil.bill_2zip WITH zipout
					REPL act_mbil.bill_due WITH due
					REPL act_mbil.bill_for WITH my
					REPL act_mbil.blz_calcd WITH act_cust.last_calc

					COPY TO \temp\lsw_bil2.DBF FIELDS lnamefname,pickup_id, lname, fname, INITIAL, address, address2, city,;
						state, zip,totl_amt,compound,data_stg,prec_num,prec_nam,dob,location  ALL FOR ((cust_type$[Cc]) ;
						.AND. (LEFT(ALLTRIM(district),1)$distrix))  ;
						.AND. (totl_amt>1.00)  && don't send bills less than 1 dollar

					USE \temp\lsw_bil2.DBF
					REPL ALL lnamefname WITH ALLTRIM(fname)+[ ]+INITIAL+[ ]+ ALLTRIM(lname),; && lnamefname with last first
					data_stg WITH my, ; && service term, ie :August...the month of service being billed.
					prec_num WITH STR(w_res_rate*(w_d/100),5,2), ; &&  compute & report the late charge
					prec_nam WITH STR(w_res_rate,5,2), ; &&  compute & report the monthly residential charge
					compound WITH   ALLTRIM(due)  && send due date
					REPL ALL fname WITH    STR(w_res_rate*((w_d/100))+totl_amt,10,2)  && compute & report total due after late fee
					REPL ALL lname WITH ALLTRIM(location)  && transfer location as char field, not memo.
					USE  && close the monthly billing dbf
					USE \temp\lsw_bil2.DBF
					STORE [\temp\lsw_bill_C_]+ALLTRIM(STR(MONTH(DATE())))+[_]+ALLTRIM(STR(DAY(DATE())))+[_]+ALLTRIM(STR(YEAR(DATE())))+[.txt] TO iziz
					COPY TO \temp\lsw_4bc2.txt TYPE DELIMITED  && make a comma delimited file for mailman.
					COPY TO (iziz) TYPE DELIMITED  && make a comma delimited file for mailman, with date name.
					STORE [\temp\lsw_bill_C_]+ALLTRIM(STR(MONTH(DATE())))+[_]+ALLTRIM(STR(DAY(DATE())))+[_]+ALLTRIM(STR(YEAR(DATE())))+[.dbf] TO iziz
					COPY TO (iziz)   && save a second copy with the unique date name
&&  wsh 10/27/97

					REPL act_mbil.tot_count WITH RECCOUNT(lsw_bil2)  && count # of rex
					SUM lsw_bil2.totl_amt ALL TO  tot_m
					REPL act_mbil.tot_amt  WITH tot_m &&all $
					AVERAGE lsw_bil2.totl_amt ALL TO avg_m
					REPL act_mbil.avg_bill WITH avg_m  &&avg $/bill
					USE
					SELE act_mbil
					USE  && close the monthly billing dbf

				ENDIF

				DO view_set
				ACTIVATE SCREEN
				CLEAR
				? [! DONE !]
				? [The billing routine is complete, The data base has been prepared for the Mail Manager program.]
				? [The Residential bills are in \TEMP\LSW_BIL1.DBF, the Commercials are in LSW_BIL2.DBF]
				? [Now quit this program,  and run Mail Manager.  Use the LSW_BIL1.DBF file in \TEMP for]
				? [the source data for Residential billings in the Mail Manager program.]
				?
			ENDIF

			ACTIVATE SCREEN

			IF ((zipout $ [Nn]) .OR. (make_a_dun_file$[Dd]))  && Not Zipout, nor sending data to ZCR2000
				IF c$[RrBb]  && residential or both
					STORE 1 TO l_m
					STORE 1 TO sequence_number
					SET PRINTER TO \temp\lsw_bill.001
					FOR l_i=1 TO ALEN(l_b,1)  &&INSERT FIELDS
						ar_p=AT('@',l_b(l_i,1))  &&hey is there an @ in your line?
						IF ar_p>0
							STORE SUBSTR(l_b(l_i,1),ar_p,2) TO ar_l   &&grab @ and char next to it
							ar_p2=AT('@',l_b(l_i,1),2)  &&hey is there another @ in your line?
							DO CASE   &&what @ are you
							CASE ar_l='@1'  &&month billed
								STORE l_i TO b_mo
								STORE ar_p TO b_mo1
								STORE STUFF(l_b(l_i,1),ar_p,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								IF ar_p2>0
									STORE ar_p2 TO b_mo2
									STORE STUFF(l_b(l_i,1),ar_p2,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								ENDIF
							CASE ar_l='@2'  &&Due Date
								STORE l_i TO b_du
								STORE ar_p TO b_du1
								STORE STUFF(l_b(l_i,1),ar_p,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								IF ar_p2>0
									STORE ar_p2 TO b_du2
									STORE STUFF(l_b(l_i,1),ar_p2,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								ENDIF
							CASE ar_l='@3'  &&totl_amt due
								STORE l_i TO b_am
								STORE ar_p TO b_am1
								STORE STUFF(l_b(l_i,1),ar_p,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								IF ar_p2>0
									STORE ar_p2 TO b_am2
									STORE STUFF(l_b(l_i,1),ar_p2,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								ENDIF
							CASE ar_l='@4'  && Pickup_id
								STORE l_i TO b_id
								STORE ar_p TO b_id1
								STORE STUFF(l_b(l_i,1),ar_p,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								IF ar_p2>0
									STORE ar_p2 TO b_id2
									STORE STUFF(l_b(l_i,1),ar_p2,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								ENDIF
							CASE ar_l='@5'  &&name
								STORE l_i TO b_na
								STORE ar_p TO b_na1
								STORE STUFF(l_b(l_i,1),ar_p,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								IF ar_p2>0
									STORE ar_p2 TO b_na2
									STORE STUFF(l_b(l_i,1),ar_p2,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								ENDIF
							CASE ar_l='@6'   &&address
								STORE ar_p TO b_ad1
								STORE l_i TO b_ad
								STORE STUFF(l_b(l_i,1),ar_p,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								IF ar_p2>0
									STORE ar_p2 TO b_ad2
									STORE STUFF(l_b(l_i,1),ar_p2,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								ENDIF
							CASE ar_l='@7' && city state zip
								STORE l_i TO b_ci
								STORE ar_p TO b_ci1
								STORE STUFF(l_b(l_i,1),ar_p,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								IF ar_p2>0
									STORE ar_p2 TO b_ci2
									STORE STUFF(l_b(l_i,1),ar_p2,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								ENDIF
							CASE ar_l='@8'  &&district
								STORE l_i TO b_di
								STORE ar_p TO b_di1
								STORE STUFF(l_b(l_i,1),ar_p,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								IF ar_p2>0  &&  case ar_l='@9'.  bill num
									STORE l_i TO b_nu
									STORE ar_p2 TO b_nu1
									STORE STUFF(l_b(l_i,1),ar_p2,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
								ENDIF
							CASE ar_l='@0'  && return code, ie '*DIST1*'
								STORE l_i TO b_co
								STORE ar_p TO b_co1
								STORE STUFF(l_b(l_i,1),ar_p,2,[  ]) TO l_b(l_i,1)  &&clean out the token from the print image
							ENDCASE
						ENDIF  &&@
					ENDFOR &&for all l_i
&&now have all locii of fields in bill image from ACT_BILL.TXT

					SELE act_cust
					IF p_order$[Zz]
						SET ORDER TO TAG zip && *!*!*! &&zip order
					ELSE
						SET ORDER TO TAG route  && or route order
					ENDIF
					GOTO TOP

					SELECT 0  &&grab open workspace
					USE act_mbil EXCL  && use monthly billing record
					APPE BLANK  && add a record for this billing
					SELE act_cust

&& capture bill run info into act_mbil
					REPL act_mbil.bill_time WITH TIME()
					REPL act_mbil.bill_date WITH DATE()
					REPL act_mbil.bill_distx WITH distrix
					REPL act_mbil.bill_type WITH c
					REPL act_mbil.bill_2zip WITH zipout
					REPL act_mbil.bill_due WITH due
					REPL act_mbil.bill_for WITH my
					REPL act_mbil.blz_calcd WITH act_cust.last_calc



					DO WHILE .NOT. EOF()
&&do for all residential
						IF ((LEFT(ALLTRIM(district),1)$distrix)) .AND. (totl_amt>1.00) .AND. ((cust_type$[Rr]))  &&(.not.(cust_type$[Ii])) && don't send bills less than 1 dollar, or to inactive customers.
							=ACOPY(l_b,l_c)  &&duplicate the bill image in array l_c
							STORE l_m TO sequence_number
							FOR l_i=1 TO ALEN(l_c,1)   &&         *go thru image and insert data from record into l_c .  act_bill can be of any length, but it is assumed to contain certain fields:
								DO CASE       &&         * case by line
								CASE l_i=b_co  && use the district # as the sequence # on the lower left of the bill
									STORE [#_]+ALLTRIM(STR(sequence_number,6)) TO l_n
									STORE STUFF(l_c(l_i), b_co1,LEN(l_n),l_n) TO l_c(l_i)
								CASE l_i=b_mo
									STORE STUFF(l_c(l_i), b_mo1,LEN(my),my) TO l_c(l_i)
									STORE STUFF(l_c(l_i), b_mo2,LEN(my),my) TO l_c(l_i)
								CASE l_i=b_du
									STORE STUFF(l_c(l_i), b_du1,LEN(due),due) TO l_c(l_i)
									STORE STUFF(l_c(l_i), b_du2,LEN(due),due) TO l_c(l_i)
								CASE l_i=b_am
									STORE ALLTRIM(STR(totl_amt,10,2)) TO l_n
									STORE STUFF(l_c(l_i), b_am1,LEN(l_n),l_n) TO l_c(l_i)
									STORE STUFF(l_c(l_i), b_am2, LEN(l_n),l_n) TO l_c(l_i)
								CASE l_i=b_id
									STORE STUFF(l_c(l_i), b_id1,LEN(pickup_id),pickup_id) TO l_c(l_i)
									STORE STUFF(l_c(l_i), b_id2,LEN(pickup_id),pickup_id) TO l_c(l_i)
								CASE l_i=b_na
									STORE ALLTRIM(fname)+[ ]+ALLTRIM(lname) TO l_n
									STORE STUFF(l_c(l_i), b_na1,LEN(l_n),l_n) TO l_c(l_i)
									STORE STUFF(l_c(l_i), b_na2,LEN(l_n),l_n) TO l_c(l_i)
								CASE l_i=b_ad
									STORE STUFF(l_c(l_i), b_ad1,LEN(address),address) TO l_c(l_i)
									STORE STUFF(l_c(l_i), b_ad2,LEN(address),address) TO l_c(l_i)
								CASE l_i=b_ci
									STORE ALLTRIM(city)+[, ]+state+[  ]+zip TO l_n
									STORE STUFF(l_c(l_i), b_ci1,LEN(l_n),l_n) TO l_c(l_i)
									STORE STUFF(l_c(l_i), b_ci2,LEN(l_n),l_n) TO l_c(l_i)
								CASE l_i=b_di
									STORE STUFF(l_c(l_i), b_di1,LEN(district),district) TO l_c(l_i)
* CASE l_i=b_nu
									STORE STR(l_m,8) TO l_n
									STORE STUFF(l_c(l_i), b_nu1,LEN(l_n),l_n) TO l_c(l_i)
								ENDCASE
							ENDFOR   && for all lines in a bill
							SET PRINT ON          &&STUFF IN THE PRINTER CODES FOR 6 AND 8 LPI--GO 4" AT 6LPI, 0.25 AT 8LPI
							STORE STUFF(l_c(1), 1,0,lpi6eps) TO l_c(1)

&&								STORE STUFF(l_c(25),LEN(RTRIM(l_c(25))),0,lpi8eps) TO l_c(25)
&&   HACK==>  COERCE 4 " CARD HEIGHT WSH 9/26/03			STORE STUFF(l_c(25),LEN(RTRIM(l_c(25))),0,lpi8eps) TO l_c(25)

							FOR l_i=1 TO ALEN(l_c,1)
								? l_c(l_i,1)  && actually dump bill to printer file.
							ENDFOR
							SET PRINT OFF
							@ 0,0 SAY l_m
							l_m=l_m+1
						ENDIF &&  if district in distrix, and $>1
						SKIP  &&next customer
					ENDDO  && finish for all file

					SET PRINTER TO
				ENDIF  &&if c$[RrBb]

				IF c$[CcBb]
					REPO FORM act_bilc TO FILE \temp\lsw_bill.002 ALL FOR ((cust_type$[Cc]) ;
						.AND. (LEFT(ALLTRIM(district),1)$distrix))  ;
						.AND. (totl_amt>1.00)  && don't send bills less than 1 dollar
				ENDIF

				SET PRINT OFF
				SET PRINTER TO
				SET CONSOLE ON
				SET STATUS BAR ON

&& set filter for totals
				IF c$[Rr]
					SET FILTER TO ((LEFT(ALLTRIM(district),1)$distrix)) .AND. (totl_amt>1.00) .AND. ((cust_type$[Rr]))
				ENDIF

				IF c$[Cc]
					SET FILTER TO ((cust_type$[Cc]) .AND. (LEFT(ALLTRIM(district),1)$distrix))  ;
						.AND. (totl_amt>1.00)  && don't send bills less than 1 dollar
				ENDIF

				IF c$[Bb]
					SET FILTER TO ((LEFT(ALLTRIM(district),1)$distrix)) .AND. (totl_amt>1.00) .AND. ((cust_type$[RrCc]))
				ENDIF


				REPL act_mbil.tot_count WITH RECCOUNT()  && count # of rex
				SUM totl_amt ALL TO  tot_m
				REPL act_mbil.tot_amt  WITH tot_m &&all $
				AVERAGE totl_amt ALL TO avg_m
				REPL act_mbil.avg_bill WITH avg_m  &&avg $/bill
				USE
				SELE act_mbil
				USE  && close the monthly billing dbf


				DO view_set
				ACTIVATE SCREEN
				CLEAR
				? [! DONE !]
				? [The billing routine is complete, printing Residentials can commence on LPT1.]
				? [The Residential bills are in \TEMP\LSW_BILL.001, the Commercials are in LSW_BILL.002]
				? [You may skip the next option and choose to print the bills later from DOS. Use]
				? [the command: "COPY \TEMP\LSW_BILL.001 LPT1:" for Residentials and use the]
				? [command "COPY \TEMP\LSW_BILL.002 LPT1:" for the Commercials. NB:  you may  ]
				? [substitute other LPT's, and route the printout to a different printer.]
				?

				IF c$[RrBb]
					IF yesno([Ready to Copy \TEMP\LSW_BILL.001 to LPT1 now.])
						!COPY \temp\lsw_bill.001 lpt1
					ENDIF
				ENDIF
				IF c$[CcBb]
					IF yesno([Ready to Copy \TEMP\LSW_BILL.002 to LPT1 now.])
						!COPY \temp\lsw_bill.002 lpt1
					ENDIF
				ENDIF



			ENDIF  &&If Zipout
		ENDIF &&if ok

		RETURN


***************************************************************************
	PROCEDURE act_dun
***************************************************************************
		PRIVATE threshold, i_thresh
		STORE [18.50 ] TO threshold
		STORE 1.00 TO i_thresh

		CLEAR

		? [This routine recomputes a customer's total bill.]
		? [If the customer is an R type (Residential), and they]
		? [owe more than the amount you indicate, they will be  ]
		? [included in the Dun list, \TEMP\LSW_BILL.DUN]
		? [When this procedure succesfully finishes, all]
		? [customers in \TEMP\LSW_BILL.DUN owe more than the]
		? [threshold value.  You may edit the file with any]
		? [word processor.]

		SELE act_cust
		ACCE [Enter the Districts. i.e.: 01235  ==> ] TO distrix
		ACCE [Enter the Dollar threshold to begin dunning, i.e. $18.50 ==>] TO threshold
		i_thresh=VAL(threshold)
		IF i_thresh> 1.00

			CLEAR
			?
			? [Computing all current bills...this will take a while.]
			DO calc_balance

			SELE act_cust
			SET ORDER TO bothnames
			SET FILTER TO (((cust_type=[R]) .AND. (totl_amt>i_thresh)) .AND. (ALLTRIM(district)$distrix))
			GO TOP

			SET PRINTER OFF
			SET PRINTER TO \temp\lsw_bill.dun
			SET PRINTER ON
			? [DUNNING LIST]
			? DATE()
			? [Dunning Threshold==>], i_thresh
			? [DISTRICTS==>],distrix

			DO WHILE .NOT. EOF()
				? pickup_id,' ',ALLTRIM(fname),' ',INITIAL,' ',ALLTRIM(lname),' ',ALLTRIM(address),'  ',ALLTRIM(address2),'  ',ALLTRIM(city),', ',ALLTRIM(state),' ',totl_amt
				SKIP
			ENDDO

			SET PRINTER OFF
			SET PRINT TO
		ELSE
			WAIT [Error:  Bad threshold amount,  please try again.]
		ENDIF
		CLEAR
		DO view_set

		RETURN

********************************************
	PROCEDURE xlatxlsw
********************************************

		CLEAR


		? [***  W A R N I N G   ***  ***  W A R N I N G   ***]
		? [***  W A R N I N G   ***  ***  W A R N I N G   ***]
		?
		? [Completing the following procedure will REPLACE the]
		? [existing Customer list with records imported from]
		? [the SW_ADD.DBF (format of 8/15/95).]
		?
		? [DO NOT RUN THIS ROUTINE UNLESS YOU]
		? [INTEND TO REPLACE THE CUSTOMER LIST.]
		?
		? [You must have EXCLUSIVE USE of the]
		? [ACT Data Files and the SW_ADD files.]
		?
		?
		IF yesno([Overwrite Existing Customer List ? ])


			SELE act_cust
			USE act_cust EXCL
			ZAP

			?
			?
			? [***   PLEASE WAIT--LOADING DATA FROM SW_ADD.DBF  ***]
			?
			?
			SELE 4
			USE sw_add EXCL
			REPLACE ALL compound WITH cust_id
			SET ORDER TO TAG compound
			SELE act_cust
			SET ORDER TO 0
			APPE FROM sw_add
* *! use  sw_add shared

			GOTO TOP

			?
			? [   Now updating ACT_CUST.  Please Wait.]
			?

			GOTO TOP
			SET RELATION TO compound INTO sw_add
			SET TALK ON
			DO WHILE .NOT. EOF()
				REPLACE act_cust.pickup_id WITH ALLTRIM(sw_add.compound),act_cust.address WITH ALLTRIM(sw_add.street),act_cust.fname WITH ALLTRIM(sw_add.firstname),act_cust.lname WITH ALLTRIM(sw_add.lastname),act_cust.state ;
					WITH ALLTRIM(sw_add.st),act_cust.comments WITH sw_add.COMMENT,act_cust.address2 WITH ALLTRIM(sw_add.addr2)
				@0,0 SAY RECNO()
*sele sw_add
*disp next 1 fields compound, lastname, street,addr2,city
*sele act_cust
*disp next 1 fields compound, lname, address,address2,city
				SKIP
			ENDDO
			SET TALK OFF
			USE act_cust SHARED ORDER TAG pickup_id


		ENDIF  &&yes Overwrite
		CLEAR
		CLOSE DATA
		DO view_set

		RETURN






	PROCEDURE peat2act
		PUBLIC p_a, p_b, p_c, p_d,p_i,p_j,p_k
&&v1.0
		CLEAR
		? [**************************************************************************]
		? [*** W A R N I N G ***      *** W A R N I N G ***     *** W A R N I N G ***]
		? [**************************************************************************]
		? [This procedure imports Customers from Peachtree Accounting.]
		? [Peachtree must have the Final Year End Accounting Period]
		? [closed, and all records exported as Statement files.  Complete steps 1-6]
		? [before accepting the 'Continue with Import' option below.]
		?
		? [Completing the following procedure will append records to the existing Customer list]
		? [with records imported from the Peachtree Accounting system.  YOU MUST ASSURE THAT]
		? [IMPORTED CUSTOMER'S ID NUMBERS DO NOT DUPLICATE ANY EXISTING CUSTOMER ID.  YOU]
		? [MUST ALSO MANAGE THE ID NUMBER RANGE-IF YOUR IMPORTED ID'S ARE GREATER THAN THE ]
		? [CURRENT ID'S, FIXUP THE 'CU' RECORD IN ACT_CUST.DBF TO BE GREATER THAN ANY YOU'VE IMPORTED.]
		?
		? [WARNING!!!  Running this procedure twice will destroy the backup files]
		? [in .\BAK\LSWBAK.ZIP--duplicate these critical files after]
		? [the first run, they are your current data!]
		?
		? [If you are not already at the end of the Fiscal Year, do the following: ]
		? [1) Begin by setting the interest rate in Peachtree to $0.0]
		? [2) Quit Windows and promote the date with the DOS DATE command.  Set the date]
		? [   to the end of the next month.]
		? [3) Close the  accounting period just like you were going to print the monthly]
		? [   bills.  Run the Peachtree billing steps just like you would for a regular billing.]
		? [   You do not need to actually print the bills to paper, nor run any of the DOS ]
		? [   programs, LSWBILL.EXE, BSORT.EXE or LSWPRINT.EXE, but it won't hurt if you do.]
		? [Repeat 2 & 3, until the end of the Fiscal Year.]
		?
		? [When you are done settling the accounts: ]
		? [4) Set the printer to 'Generic, Text Only' and  select 'Print to File'.]
		? [5) Use PeachTree to R)eport Statements and use the LSW_2ACT form to print.]
		? [6) Print all the records to C:\TEMP\LSW_2ACT.XFR]

		IF yesno([Continue with Import--Append to Existing Customer List ? ])

&&
			SET SPACE OFF
			SET CONSOLE ON
* SET STATUS ON
			SET SCOREBOARD OFF
			SET HISTORY OFF
			SET TALK OFF
			SET SAFETY OFF

			CLOSE ALL
&& backup the data set
			! \nuzip\pkzip -A .\bak\lsw_bak.zip \lsw\ACT_.*

			SET DELETED OFF
			SELE 0
			USE act_xpt EXCL
			ZAP  &&zero the import file
			APPE FROM c:\temp\lsw_2act.xfr TYPE DELIMITED  &&fill the import file with pt lines from lsw_2act.xfr
			GOTO TOP
			DO WHILE .NOT. EOF()  && get rid of all empty lines
				REPLACE l WITH ALLTRIM(l)
				IF LEN(l)<1
					DELETE
				ENDIF
				SKIP
			ENDDO
			PACK
			INDE ON l TAG l
			USE
			SET DELETED ON
			DO view_set  && reset the file view to default
			SELE act_cust
			SET ORDER TO TAG pickup_id
			SELE 0  && open up the  import text
			USE act_xpt
			SET ORDER TO 1  &&read them in ID order
			DO WHILE .NOT. EOF()
* READ A RECORD
* EXTRACT THE id# to P_A
				STORE LEFT(l,6) TO p_a
* XTRACT THE LINE CODE ~,^,{,|,@ to P_B
				STORE ALLTRIM(SUBSTR(l,7,7)) TO p_b  &&requires thatLSW_2ACT have ~ codes w/in 7chars of ID
* xTRACT THE LINE to P_C
				STORE ALLTRIM(LEFT(l,15)) TO p_c  &&assure that this column spacing is right in Peachtree's lsw2_act
* SELECT THE LINE TYPE
* PARSE THE LINE
* REPLACE THE ACT_CUST FIELDS WITH THE PARSED LINES
				IF LEN(p_c)>0
					DO CASE  && five line types
					CASE p_b=[~]  && fname,lname
* create a new cust record-this is a new id--this presumes ~ all come first in sequence-this should be a good assumption
* cannot use standard method to add record, it assigns the ID#, so do it yourself
						SELE act_cust
						APPEND BLANK
*presume we have simple last name, and stuff all preamble to fname, check later for ok
						REPLACE pickup_id WITH p_a, lname WITH SUBSTR(p_c,LEN(p_c)-RAT([ ],p_c)),;
							data_quali WITH [P],first_star WITH DATE(),;
							last_updat WITH DATE(), SOURCE WITH [P]
* we can relate the orginal SW_add data in dist 345 with these records later.
* check the right hand end for SR, JR, etc (complex lastname)
						IF RAT([ ],p_c)>0  &&two words
							REPLACE fname WITH SUBSTR(p_c,1,LEN(p_c)-RAT([ ],p_c)-1)  && do first name
							STORE ALLTRIM(SUBSTR(p_c, RAT([ ],p_c))) TO p_d
							IF (p_d $[SrsrSRSr.sr.SR.JrjrJRJr.jr.JR.123456789]) .OR. ([#]$p_d)
&& get prev field, this is JR, Sr, or #
								STORE RAT([ ],p_c,2) TO p_i
								IF p_i>0
&& there is a word to the left of the JR/SR/#
									REPLACE lname WITH SUBSTR(p_c, LEN(p_c)-p_i), fname WITH SUBSTR(p_c,1,p_i-1)
								ENDIF
							ENDIF
						ENDIF
						SELE act_xpt  && all other actions will remain selected to act_xpt
					CASE p_b=[^]  && addr1
						IF p_a<> act_cust.pickup_id
							?[Import Data ID Sequence error. Customer ID doesn't Jive with Import Record.]
							?[ Program Halted--RESTORE DATA FROM BACKUP, FIX IMPORT DATA AND TRY AGAIN.]
							WAIT
							QUIT
						ENDIF
						REPLACE act_cust.address WITH p_c, act_cust.street WITH p_c
					CASE p_b=[{]  &&addr2
						IF p_a<> act_cust.pickup_id
							?[Import Data ID Sequence error. Customer ID doesn't Jive with Import Record.]
							?[ Program Halted--RESTORE DATA FROM BACKUP, FIX IMPORT DATA AND TRY AGAIN.]
							WAIT
							QUIT
						ENDIF
						REPLACE act_cust.address2 WITH p_c
					CASE p_b=[|]  &&city, st,zip
						IF p_a<> act_cust.pickup_id
							?[Import Data ID Sequence error. Customer ID doesn't Jive with Import Record.]
							?[ Program Halted--RESTORE DATA FROM BACKUP, FIX IMPORT DATA AND TRY AGAIN.]
							WAIT
							QUIT
						ENDIF
						REPLACE act_cust.city WITH SUBSTR(p_c,1,AT([,],p_c)),;
							act_cust.state WITH SUBSTR(p_c,AT([,],p_c)),;
							act_cust.zip WITH SUBSTR(p_c,RAT([ ],p_c))
						REPLACE act_cust.state WITH LEFT(act_cust.state,LEN(act_cust.state)-LEN(act_cust.zip))
					CASE p_b=[@]  &&balance
						IF p_a<> act_cust.pickup_id
							?[Import Data ID Sequence error. Customer ID doesn't Jive with Import Record.]
							?[ Program Halted--RESTORE DATA FROM BACKUP, FIX IMPORT DATA AND TRY AGAIN.]
							WAIT
							QUIT
						ENDIF
						REPLACE act_cust.totl_amt WITH VAL(p_c)
					ENDCASE
				ENDIF
* REPEAT UNTIL EOF()
				SKIP
			ENDDO &&while not eof()
			FLUSH
			CLOSE DATA
		ENDIF  &&yesno ok to overwrite
		CLEAR
		DO view_set
		RETURN
***************************************************************************



********************************************
	PROCEDURE new_year
********************************************
* rev 1/8/03
		PRIVATE nudir,nuyear,nutemp,nu_ok,cur_dir,u_ok4this
		USE act_y SHARED
		SET ORDER TO 1
		SEEK [P1]
		STORE act_y->u_r TO u_ok4this
		USE
		CLEAR
		?
		? [ ************************************************************************************]
		? [ *******  Make New Year *** Consolidates previous year and carries YTD balance. *******]
		? [ <* YTD *>   This procedure overwrites the accounts in the New Directory.  <*  YTD *>]
		? [ ************************************************************************************]
		?
		? [ This routine needs to recalculate all account balances first thing.  This may take a while. ]
		? [ 1:) Run after the Old Year has been closed by printing the last bills,]
		? [ 2:) You may post payments after the last billing (a new feature), ]
		? [ 3:) Assure that the files have been backed up to .\BAK1 and that you have made archival copies,]
		? [ 4:) & you've duplicated the current year's files to your new year's directory,]
		? [ 5:) & you have made a new desktop icon for the new directory,]
		? [ 6:) & you have launched the ACT_ program from the new icon.]
		? [ All records will be balanced before consolidation-this takes some time. ]
		? [ The files that must to be copied to the new directory are:  ACT_.EXE, ]
		? [ FOX2600.ESL, ACT_*.DBF, ACT_*.CDX, ACT_*.FPT, SW_ADD.*, and CUSHEADER.TXT ]
		? [ You can  copy the entire current directory, .\*.*]
		?
		IF yesno ([Did you launch from the NEW icon and are you READY to continue?  ]);
				.AND. yesno ([Destroy the Invoice file and Start New Year?  Your last chance to quit!])
			? [  Enter Password ==>  ]
			STORE ' ' TO nu_ok
			@ 2,35 EDIT nu_ok FUNCTION 'J' SIZE 1, 1
			READ
*ACCE [ Enter Password==> ] to uz

*    acce [ Whats the Password? ==>] to nu_ok
			IF ALLTRIM(UPPER(nu_ok))=ALLTRIM(u_ok4this)
*  zero out the lines and scr and pay files, keep the id#s, invoice numbering system, etc
				SET SAFETY OFF
				SET STATUS OFF
				USE act_x EXCL
*  Yes the YTD does refresh the audit file.  Audits are yearlong data sets.
				ZAP
				DO view_set
				DO reindxm  &&assure good indexes
*  ? [Finished Re-Indexing]
				SELE act_main  && balance the act_main recs to reflect any new bills or credits
				GO TOP
				DO WHILE (.NOT. EOF())
&& recompute all invoices & assign invoice headers
*  ? [Scr_Subtot for Act_Main Recno:],recno()
					DO scr_subtot  && sum up the counts, make the lists and values
					SKIP
				ENDDO
*  ? [Starting Calc_Balance ****]
				DO calc_balance  && assign recomputed balances to customer rex
*  Since quarterly billing, cannot manage the "Just did billing" rule anymore, but allows posting after last billing.
				DO view_set
*  ? [Zapping old rex]
				SELE act_main
				USE act_main EXCL
				ZAP
				SELE act_scr
				USE act_scr EXCL
				ZAP
				SELE act_pay
				USE act_pay EXCL
				ZAP
*  ? [ Done Zapping]
				SELE act_uniq
				SEEK [IN]
				REPLACE COUNT WITH 0
				SEEK [PY]
				REPLACE COUNT WITH 0
* create an invoice for each customer showing a balance forward and the dollar amount.
*  ? [ Begin Adding $ data to Cust Record & create Invoice with balance forward]
				SELE act_main
				SET RELA OFF INTO act_cust
				SELE act_cust
				SET ORDER TO cust_type
				GOTO TOP
				DO WHILE .NOT. EOF()
*NOW CREATE AN INVOICE FOR THIS FINANCE CHARGE
*CREATE NEW invoice RECORD IN MAIN    * (from orig invoice add line in menu)
*  ? [Assigned current date to cust recno:],recno()
					REPLACE rev_date WITH DATE() && assign the latest billing date to the cust record
&&we are billing this one--put billing date into cust record

					SELE act_main
					ar_i=add_1([IN])
					UNLOCK ALL
*  ? [added invoice #], ar_i
					REPL invoice WITH ar_i
					REPL srvc_dat WITH DATE()
					REPL rev_date WITH DATE()  && billing date
					REPL pickup_id WITH act_cust.pickup_id
					REPL lname WITH act_cust->lname
					REPL fname WITH act_cust->fname
					REPL INITIAL WITH act_cust->INITIAL
					REPL Phone  WITH act_cust->Phone
					REPL address WITH act_cust->address
					REPL address2 WITH act_cust->address2
					REPL city WITH act_cust->city
					REPL zip WITH act_cust->zip
					REPL state WITH act_cust->state
*            REPL dob WITH act_cust->dob
					UNLOCK ALL

					IF act_cust.totl_amt<0
* ? [at act_cust.totl_amt<0, adding rec to act_pay to show credit balance]
						SELE act_pay
						ar_i=add_1([PY])
						REPL act_pay.pay_rec_n WITH ar_i,date_paid WITH DATE(), amt_paid WITH (-1*act_cust.totl_amt),check_n WITH [95.96],;
							cshchkcr WITH [R],id_of_payr WITH act_cust.pickup_id, invoice WITH [],pickup_id WITH act_cust.pickup_id,;
							t_name WITH act_cust.lname, y_name WITH act_cust.lname  ,COMMENT WITH [Year to Date Carry Forward.]
					ELSE
* ? [at act_cust.totl_amt >=0-making new act_scr rec]
*CREATE NEW RECORD IN SCR
						SELE act_scr
						APPEND BLANK
						REPLACE invoice WITH act_main.invoice
&&YTD brought forward
						REPL act_scr->c1 WITH 1
						REPL act_scr->i1 WITH [YTD]
						REPL act_scr->code1 WITH [Y]
						REPL act_scr->p1 WITH act_cust.totl_amt  &&cYTD
					ENDIF

					UNLOCK ALL
					DO scr_subtot  &&build service strings and invoice total
					UNLOCK ALL
					SELE act_cust
					SKIP  && next
				ENDDO  &&all customers
*  ? [finished adding $ data to all cust]
				CLOSE DATA
				DO view_set  &&reset the  files
* Done
				DO purgem  &&pack the files
				CLEAR
			ENDIF
		ENDIF
		CLEAR
		RETURN


******==========================================================*******
	PROCEDURE fix_physical
******==========================================================*******
&& consolidates physical addresses

		SELE act_cust
		SET FILTER TO
		REPL ALL compound WITH ""
		REPL ALL compound WITH ALLTRIM(street)
		SET FILTER TO LEN(ALLTRIM(street))>0
		REPL ALL compound WITH UPPER(SUBSTR(ALLTRIM(street),AT(' ',ALLTRIM(street)))+PADL(LEFT(ALLTRIM(street),AT(' ',ALLTRIM(street))),8,' ')) FOR (SUBSTR(ALLTRIM(street), 1,1 )$[0123456789])
		SET FILTER TO LEN(ALLTRIM(location))>0
		REPL ALL compound WITH ALLTRIM(location)
		REPL ALL compound WITH UPPER(SUBSTR(ALLTRIM(location),AT(' ',ALLTRIM(location)))+PADL(LEFT(ALLTRIM(location),AT(' ',ALLTRIM(location))),8,' ')) FOR (SUBSTR(ALLTRIM(location), 1,1 )$[0123456789])
		SET FILTER TO (([BOX]$address2).AND.(LEN(ALLTRIM(address))>0))
		REPL ALL compound WITH ALLTRIM(address)
		REPL ALL compound WITH UPPER(SUBSTR(ALLTRIM(address),AT(' ',ALLTRIM(address)))+PADL(LEFT(ALLTRIM(address),AT(' ',ALLTRIM(address))),8,' ')) FOR (SUBSTR(ALLTRIM(address), 1,1 )$[0123456789])
		SET FILTER TO
		REPL ALL compound WITH ALLTRIM(compound)
&& repl all street with compound

		RETURN


******==========================================================*******
	PROCEDURE newnz  && fix messed up commercial addresses
******==========================================================*******
&& make empty invoice reocrds for new customers

		SELE act_main
		SET RELA OFF INTO act_cust
		SELE act_cust
		USE
		USE act_cust EXCL
		PACK
		SET FILTER TO cust_type=[C]
		DELE ALL FOR LEN(ALLTRIM(address))=0
		REPL ALL address WITH address2 FOR DELETED()
		REPL ALL address2 WITH [] FOR DELETED()
		RECA ALL
		DELE ALL FOR ALLTRIM(address)$ALLTRIM(address2)
		REPL ALL address2 WITH [] FOR DELETED()
		RECA ALL

&&  create new YTD so there is an invoice pointing to a customer

		SET ORDER TO cust_type
		SET FILTER TO cust_type=[C]
		GOTO TOP
		DO WHILE .NOT. EOF()

			SELE act_main
			ar_i=add_1([IN])
			UNLOCK ALL
*  ? [added invoice #], ar_i
			REPL invoice WITH ar_i
			REPL srvc_dat WITH DATE()
			REPL rev_date WITH DATE()  && billing date
			REPL pickup_id WITH act_cust.pickup_id
			REPL lname WITH act_cust->lname
			REPL fname WITH act_cust->fname
			REPL INITIAL WITH act_cust->INITIAL
			REPL Phone  WITH act_cust->Phone
			REPL address WITH act_cust->address
			REPL address2 WITH act_cust->address2
			REPL city WITH act_cust->city
			REPL zip WITH act_cust->zip
			REPL state WITH act_cust->state
*            REPL dob WITH act_cust->dob
			UNLOCK ALL

*CREATE NEW RECORD IN SCR
			SELE act_scr
			APPEND BLANK
			REPLACE invoice WITH act_main.invoice
&&YTD brought forward
			REPL act_scr->c1 WITH 1
			REPL act_scr->i1 WITH [YTD]
			REPL act_scr->code1 WITH [Y]
			REPL act_scr->p1 WITH act_cust.mthly_rate &&cYTD


			UNLOCK ALL
			DO scr_subtot  &&build service strings and invoice total
			UNLOCK ALL
			SELE act_cust
			SKIP  && next
		ENDDO  &&all customers
*  ? [finished adding $ data to all cust]
		CLOSE DATA
		DO view_set  &&reset the  files
* Done


******==========================================================*******
	PROCEDURE fix_q2
******==========================================================*******

		DO view_set
		SELE act_main  && fix the act_main recs to reflect quarterly
&& scope the recs in the first quarterly billing.
		GO TOP
		DO WHILE (.NOT. EOF())
&& recompute all invoices
			DO scr_subtot  && sum up the counts, make the lists and values
			SKIP
		ENDDO
		DO calc_balance  && set all cust rex right
		RETURN

******==========================================================*******
	PROCEDURE fix_com
******==========================================================*******
* wsh 09/04/2004
		DO view_set
		SELE act_scr
		SET FILTER TO ((VAL(act_scr.invoice)>33897).AND.(LEN(ALLTRIM(i1))+LEN(ALLTRIM(i2))+LEN(ALLTRIM(i3))=0))
		GOTO TOP
		DELE REST FOR p3=0.0
		SET DELETED ON
		GOTO TOP
		REPL ALL code3 WITH [R] FOR p3=12.50
		REPL ALL code3 WITH [C] FOR p3>12.50
		REPL ALL i3 WITH [Residential] FOR p3=12.50
		REPL ALL i3 WITH [Commercial] FOR p3>12.50
		SET FILTER TO
		SET DELETED OFF
		DO fix_q2
		RETURN





******==========================================================*******
	PROCEDURE act_chex
**************************************************************
**************************************************************
*     Account Audit Program (C) W.S. Herrick 1999            *
**************************************************************
**************************************************************
		ACTIVATE SCREEN
		SELE A
		PUBLIC zero_acc
		PRIVATE hey_ok, u_ok2audit
		STORE [          ] TO hey_ok
		STORE [NO  ] TO zero_acc
		SELE 25
		USE act_y SHARED
		SET ORDER TO 1
		SEEK [P3]
		STORE act_y->u_r TO u_ok2audit
		USE
		SELE A
		CLEAR
		? [  Please Enter Audit password ==>  ]
		STORE ' ' TO hey_ok
		@ 2,35 EDIT hey_ok FUNCTION 'J' SIZE 1, 1
		READ
*ACCE [ Enter Password==> ] to uz
*ACCE([Enter Audit Password ==>  ]) to hey_ok
		CLEAR

		IF (ALLTRIM(UPPER(hey_ok))=ALLTRIM(u_ok2audit))

TEXT

  This routine queries payment files for credit records
  that fall on Saturday, or Sunday.  It excludes
  records of credits on the first Saturday of the month.  It
  includes any payment record that lies on a Sunday.
  It includes all non-credit records made on a Saturday.  It DOES
  NOT check Holidays.  It queries the whole year.

  Records that are suspicious are copied to a new database
  that you name.  Run this routine once for each year to audit.
  When finished, you can browse the suspicous records in the new
  database.

  You can use this procedure to check across years.  It
  can accumulate good records across all years you choose.
  If you want to zero out the accumulator file with all years
  credit legitmate records, answer YES to the next
  prompt.  Answer NO to accumulate the legitimate records
  from year to year.  You must answer in upper case.

  Zero the Accumulated "good" credit records?
ENDTEXT

			SELE b
			USE all_ok_cr EXCL
			ACCE [  Enter YES or NO==>] TO zero_acc
			IF ALLTRIM(zero_acc)=[YES]
*prepare an accumulator file to hold all credits that appear ok
				ZAP
				PACK
			ENDIF
			SELE A

TEXT


  You will be prompted for a file name below.  You
  must indicate which years ACT_PAY.DBF you wish to audit.
  Give the full path and filename for ACT_PAY.DBF in the
  form:
       C:\LSW2000\ACT_PAY.DBF

  Be SURE (!) to SELECT THE EXCLUSIVE OPTION when
  opening the file, or this procedure will fail.


ENDTEXT

			WAIT

****
*manage Y2k, count any deleted record already in
* the database, quit with warning if any records marked for deletion
****
*Y2k
			SET CENTURY ON
*declare counting variables
			PUBLIC del_at_start
			PUBLIC unaccounted_sum
*default them to 0
			STORE 0 TO del_at_start
			STORE 0 TO unaccounted_sum


* Make user select the file to audit

*count the deleted records
			COUNT ALL FOR DELETED() TO del_at_start
			IF del_at_start>0
TEXT

  Warning: records are already marked to delete.  This may throw
  off the sums. Quit and inspect the already deleted records.
  Backup the data before proceeding. After backup and review,
  pack the files to eliminate any deleted records.
ENDTEXT

				WAIT
				CANCEL
			ENDIF
****
****

*deleted records will now be removed from the active calculations
			SET DELETED ON

*start at the beginning of the file
			GOTO TOP

*Build a numeric value for the day of the week, 1..7, Sun-sat
			REPL ALL pay_src WITH DOW(date_paid)

* build an index to the day of week
			INDEX ON pay_src TAG pay_src ADDITIVE

* process the records quickly
			SET ORDER TO

*shift the code for Sunday to 8 from 1
			SET FILTER TO pay_src=1
			REPL ALL pay_src WITH 8

* now filter out credits that fall
*on 1st Saturday of the month
			SET FILTER TO (((ALLTRIM(cshchkcr)$[cC]) .AND. (pay_src=7)) .AND. (DAY(date_paid)<8))

*now bag the legitimate saturday credits (made first saturday of the month, dow=7, day<8)

			COPY ALL TO \junk
			DELE ALL

*capture these legitmate credits to \all_ok_credits
			SELE b
			APPE FROM \junk
			ERASE \junk.DBF
			RECA ALL
			SELE A

*now construct a list of all other credit records- they are all doubtful
			SET FILTER TO (ALLTRIM(cshchkcr)$[cC])
* tag check # with [?@ ] if it's a questionable record
*exclude YTD R type records
			REPL ALL FOR (.NOT.(ALLTRIM(cshchkcr)$[Rr])) check_n WITH [?@ ]+ALLTRIM(check_n)

*now construct a list of all saturday transactions not credits-they are all doubtful
			SET FILTER TO ((.NOT.(ALLTRIM(cshchkcr)$[cC])) .AND. (pay_src=7))
* tag check # with [?# ] if it's a questionable record
*exclude YTD R type records
			REPL ALL FOR (.NOT.(ALLTRIM(cshchkcr)$[Rr])) check_n WITH [?# ]+ALLTRIM(check_n)

*now construct a list of all sunday transactions-they are all doubtful
			SET FILTER TO  (pay_src=8)
* tag check # with [?* ] if it's a questionable record
*exclude YTD R type records
			REPL ALL FOR (.NOT.(ALLTRIM(cshchkcr)$[Rr])) check_n WITH [?* ]+ALLTRIM(check_n)

*recall all the "good" records
*the final test is any record that falls on a holiday
			RECA ALL
			SET FILTER TO (.NOT.(ALLTRIM(cshchkcr)$[Rr]))





			SUM ALL amt_paid TO unaccounted_sum
			? [The unaccounted dollars are summed below: ]
			? unaccounted_sum
			?[ Save the Unaccounted Data:  ]
			ACCE [Please name this list of Unaccounted records, ie: \Urec99.dbf ==> ] TO out_name
			COPY ALL TO &out_name
			USE

			SELE b
			USE
		ENDIF
		RETURN



********************************************************************************
********************************************************************************
	PROCEDURE zapem
********************************************************************************
********************************************************************************
&& nail files to start fresh
		DO view_set
		SELE act_cust
		USE act_cust EXCL
		ZAP
		SELE act_main
		USE act_main EXCL
		ZAP
		SELE act_scr
		USE act_scr EXCL
		ZAP
		SELE act_uniq
		REPL ALL COUNT WITH 1
		SELE 0
		USE act_dlq	EXCL									&& shim file to glue PVA rex to delinquent SW
		SELE 0
		USE act_dle	EXCL									&& file of delinquent accounts that got letters.
		ZAP
		CLOSE DATA
		DO view_set





********************************************************************************
********************************************************************************
********************                            			********************************
********************       ERROR HANDLER        	********************************
********************                            			********************************
********************************************************************************
********************************************************************************

	PROCEDURE syserror
		PARAMETERS err_line
		PRIVATE x_i,xx_ii,nextstep,ib_err,pre_window

		STORE ERROR() TO ib_err

DEFINE WINDOW syserror   FROM 05,00 TO 16,77 FLOAT GROW ZOOM CLOSE COLOR SCHEME 7
STORE WLAST() TO pre_window
SET DEVICE TO SCREEN
SET CONSOLE ON
SET PRINTER OFF
CLEAR GETS
STORE ' ' TO progname
STORE 0 TO counter
DO WHILE .NOT. 'SYSERROR' $ progname
	STORE counter + 1 TO counter
	STORE SYS(16,counter) TO progname
ENDDO
STORE counter - 2 TO proglevel
STORE 'Retry   ' TO nextstep

IF (ib_err=15)
	ACTIVATE SCREEN
	CLEAR
	?
	?  [Not a Table:  Error #15]
	?
	?  [!!ERROR!!  !!ERROR!!  !!ERROR!!  A critical file is lost, probably by]
	?  [this program having an abnormal ending during it's last session.  Do you ]
	?  [want to restore data from the Backup files in .\BAK1.  You may have a ]
	?  [more recent copy of the data, in which case quit this program and]
	?  [restore from those files, then restart.  ]
	?
	?

	IF yesno([Restore files from .\BAK1 ? ])
		? [  Please enter your password ==>  ]
		STORE ' ' TO uz
		@ 2,35 EDIT uz FUNCTION 'J' SIZE 1, 1
		READ
*ACCE [ Enter Special Function Password==> ] to uz
		u_sz=[]
		SELE 25
		USE act_y SHARED
		SET ORDER TO 1
		SEEK [P4]
		IF FOUND()
			u_sz=ALLTRIM(UPPER(u_r))
		ENDIF
		USE
		SELE 1
		IF ALLTRIM(UPPER(uz))=u_sz
			DO util_res
		ENDIF
		CLEAR
	ENDIF
ELSE

	IF ((ib_err=1104) .OR. (ib_err=5)) .AND. (err5_n<4)
		err5_n=err5_n+1
&& WSH 3/23/92
* ? [Waiting for network... E=], ib_err
		t_time=SECONDS()

*DO WHILE t_time+1>SECONDS()   &&KILL TIME
		FOR tymzmony= 1 TO 200
		ENDFOR  &&DO   && wait

	ELSE

		ACTIVATE WINDOW syserror
		CLEAR GETS
		CLEAR
		IF (ib_err=108) .OR. (ib_err=109) .OR. (ib_err=1705)
			err5_n=0  && reset err5 flag to no count
* | * ON ERROR DO syserror WITH LINENO()
			STORE 'Retry   ' TO nextstep
			?? CHR(07)
			CLEAR
			@ 02,01 SAY '  Sharing Conflict. Another user has the file or record you want.'
			@ 03,01 SAY '  Please Retry first. Select one: '

			@ 04,01 SAY ''
			??' Error# ',ib_err,', LINE:  ' , LTRIM(STR(err_line,5))
			@ 06,01 SAY MESSAGE(1)
			@ 07,01 SAY '  IN  ' + SYS(16,proglevel)
			@ 08,01 SAY 'Retry / Wait / Cancel / Quit ?: ' GET nextstep ;
				PICTURE '@M Retry, Wait, Cancel  ,Quit    '
			READ
			DEACTIVATE WINDOW syserror
*ACTIVATE WINDOW (pre_window)
			DO CASE
			CASE nextstep = 'Retry'
				RETRY
			CASE nextstep = 'Wait'
				x_i_=SECONDS()+3
				DO WHILE SECONDS()<x_i_
				ENDDO
				RETRY
			CASE nextstep = 'Cancel'
				UNLOCK ALL
				STORE .F. TO in_orderin
				DEACTIVATE MENU

				CANCEL

			CASE nextstep = 'Quit'
				UNLOCK ALL
				QUIT

			ENDCASE


		ELSE
** ||  ** ON ERROR
			err5_n=0   && reset the err5_count
			?? CHR(07)
			?? CHR(07)
			?? CHR(07)
			@ 00,01 SAY '                A PROGRAM ERROR HAS BEEN ENCOUNTERED!'
			@ 02,01 SAY ''
			? '  ERROR NUMBER: ', LTRIM(STR(ib_err,5))
			?? ' IN LINE: ' , LTRIM(STR(err_line,5))
			?? ' MESSAGE: ' , LEFT(MESSAGE(),75)
			? '    IN PROGRAM: ' , SYS(16,proglevel)
			? '    ERROR LINE: ' , LEFT(MESSAGE(1),60)

			@ 08,01 SAY 'Retry / Continue / Suspend / Edit / Cancel / Quit ?: ' GET nextstep ;
				PICTURE '@M Retry   ,Continue,Suspend ,Edit    ,Cancel  ,Quit    '
			READ
			DEACTIVATE WINDOW syserror
* ACTIVATE WINDOW (pre_window)
			DO CASE
			CASE nextstep = 'Retry'
				RETRY
			CASE nextstep = 'Continue'

*          CASE (nextstep = 'Suspend')
*            ON ERROR
*            SUSPEND
*          CASE (nextstep = 'Edit')
*            STORE RAT('\',SYS(16,proglevel)) + 1 TO startloc
*            STORE LTRIM(SUBSTR(SYS(16,proglevel),startloc)) TO objfile
*            STORE RAT('.',objfile) - 1 TO startloc
*            STORE LTRIM(SUBSTR(objfile,1,startloc)) + '.PRG' TO prgfile
*            IF .NOT. FILE(prgfile)
*              MODIFY COMMAND
*            ELSE
*              MODIFY COMMAND (prgfile)
*            ENDIF
			CASE  (nextstep = 'Cancel')
				STORE .F. TO in_orderin
				UNLOCK ALL
				DEACTIVATE MENU
			CASE nextstep = 'Quit'
				HIDE WINDOW ALL
				ACTIVATE SCREEN
				CLEAR
				WAIT [...] TIMEOUT 1
				UNLOCK ALL
				QUIT
			ENDCASE

			RELEASE WINDOW syserror

			IF yesno([LOG This ERROR ? Y/N])
				STORE SELE() TO ret_dbf		  && stor current dbf name
				SELE 0						  && goto free work area to open errlog
				USE act_err
				UNLOCK ALL

				APPEND BLANK

* fill out record
				REPL USER WITH LEFT(SYS(0),20)
				REPL DATE WITH DATE()
				REPL TIME WITH LEFT(TIME(),10)
				REPL mastr_prog WITH LEFT(PROGRAM(0),35)
* memo fields
				STORE SYS(3)+'.erl' TO memfile			  && display memory
				LIST MEMORY TO &memfile
				APPEND MEMO list_mem FROM &memfile
				ERASE &memfile

				STORE SYS(3)+'.erl' TO stafile			  && display status
				LIST TO &stafile
				APPEND MEMO list_stat FROM &stafile
				ERASE &stafile
*!*          REPL ad_err_inf WITH LEFT(SYS(2019),30)
				REPL err_msg WITH LEFT(MESSAGE(1),30)
				REPL err_prog WITH LEFT(SYS(16,1),40)
				USE
				UNLOCK ALL
				SELE (ret_dbf)
			ENDIF  ** END WRITE TO ERROR LOG
		ENDIF    && # 108 & 109  &1705 errors
	ENDIF   && #5 & 1104 errors
ENDIF &&type 15 errors  (not a table)
*	DEACTIVATE WINDOW syserror

* | * ON ERROR DO syserror WITH LINENO()

RETURN


